      subroutine dimsixread
      implicit none
      double precision Hto4l_dCz,Hto4l_Caa,Hto4l_Cza,Hto4l_Czz,
     .     Hto4l_Czbx,Hto4l_dGlL,Hto4l_dGlR,
     .     Hto4l_dGhlL,Hto4l_dGhlR,
     .     Hto4l_tCaa,Hto4l_tCza,Hto4l_tCzz
      common/dim6/Hto4l_dCz,Hto4l_Caa,Hto4l_Cza,Hto4l_Czz,
     .     Hto4l_Czbx,Hto4l_dGlL,Hto4l_dGlR,
     .     Hto4l_dGhlL,Hto4l_dGhlR,
     .     Hto4l_tCaa,Hto4l_tCza,Hto4l_tCzz
*-------------------------------------------------------------------------
      double precision  S_cH,S_cHl,S_cHlp,S_cHe,
     .     S_cll,S_cT,S_c2W,S_c2B,S_cg,S_cW,
     .     S_cB,S_cHW,S_cHB,S_tcg,S_tcHW,S_tcHB
      common/SILH/S_cH,S_cHl,S_cHlp,S_cHe,
     .     S_cll,S_cT,S_c2W,S_c2B,S_cg,S_cW,
     .     S_cB,S_cHW,S_cHB,S_tcg,S_tcHW,S_tcHB
*------------------------------------------------------------------------
      double precision W_cHl3,W_cHl1,W_cHe,W_cHWB,W_cll,
     .     W_cHD,W_cHbx,W_cHW,W_cHB,W_tcHW,
     .     W_tcHB,W_tcHWB
      common/warsaw/W_cHl3,W_cHl1,W_cHe,W_cHWB,W_cll,
     .     W_cHD,W_cHbx,W_cHW,W_cHB,W_tcHW,
     .     W_tcHB,W_tcHWB
*------------------------------------------------------------------------
      integer anm_cpg,basis,quadratics,CP
      common/anm/anm_cpg,basis,quadratics,CP
      character*20 string
      character*50 dimsixcard
      common/dim6card/dimsixcard

      integer i

      
      open(unit=1, status='OLD',file=dimsixcard)
      
      i = 0
      do while(i.eq.0)
         read(1,fmt='(a)',err=777,end=666) string
         i = index(string,'<higgs>')
         if(i.ne.0) then
            read(1,*) Hto4l_dCz
            read(1,*) Hto4l_Caa
            read(1,*) Hto4l_Cza
            read(1,*) Hto4l_Czz
            read(1,*) Hto4l_Czbx
            read(1,*) Hto4l_dGlL
            read(1,*) Hto4l_dGlR
            read(1,*) Hto4l_dGhlL
            read(1,*) Hto4l_dGhlR
            read(1,*) Hto4l_tCaa
            read(1,*) Hto4l_tCza
            read(1,*) Hto4l_tCzz

            i = 0
            read(1,fmt='(a)') string
            i = index(string,'<\higgs>')
            if(i.eq.0) goto 777 
         endif
      enddo

      i = 0
      do while(i.eq.0)
         read(1,fmt='(a)',err=777,end=666) string
         i = index(string,'<silh>')
         if(i.ne.0) then
            read(1,*) S_cH
            read(1,*) S_cT
            read(1,*) S_c2W
            read(1,*) S_c2B
            read(1,*) S_cg
            read(1,*) S_cW
            read(1,*) S_cB
            read(1,*) S_cHW
            read(1,*) S_cHB
            read(1,*) S_cHl
            read(1,*) S_cHlp
            read(1,*) S_cHe
            read(1,*) S_cll
            read(1,*) S_tcg
            read(1,*) S_tcHW
            read(1,*) S_tcHB
            
            i = 0
            read(1,fmt='(a)') string
            i = index(string,'<\silh>')
            if(i.eq.0) goto 777
         endif
      enddo

      i = 0
      do while(i.eq.0)
         read(1,fmt='(a)',err=777,end=666) string
         i = index(string,'<warsaw>')
         if(i.ne.0) then
            read(1,*) W_cHD
            read(1,*) W_cHbx
            read(1,*) W_cHW
            read(1,*) W_cHB
            read(1,*) W_cHWB
            read(1,*) W_cHl1
            read(1,*) W_cHl3
            read(1,*) W_cHe
            read(1,*) W_cll
            read(1,*) W_tcHW
            read(1,*) W_tcHB
            read(1,*) W_tcHWB
            
            i = 0
            read(1,fmt='(a)') string
            i = index(string,'<\warsaw>')
            if(i.eq.0) goto 777
         endif
      enddo

 666  continue
      close(1)

      call dictionary
      return

 777  continue
      print*, ' '
      print*, string
      print*, i
      print*, '#####################################'
      print*, 'Error in the dimension 6 param card'
      print*, 'Stopping here!!!!!'
      print*, '#####################################'
      stop

      end

      subroutine ANOMALOUS(p1,p2,p3,p4,MSQBSM)
      implicit double complex (Z)
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      double precision MSQBSM,MSQSM
*------------------------------------------------------------------------
      double precision gW,gZ,CW,SW,MZ,WZ,g1,gfermi,vev,vev2,delta_mz2
      common/anmcpgs/gW,gZ,CW,SW,MZ,WZ,g1,gfermi,vev,vev2,delta_mz2
*-------------------------------------------------------------------------
      double precision NP,NPSQ
      common/EFTORDER/NP,NPSQ
*-------------------------------------------------------------------------
      double precision COUPLSM,CV,CA,CVA,CVSQ,CASQ,MZSQ
      double precision CASQ2,CVASQ,CVSQ2,SUMSQ,SUMSQ2
      double precision sw2,sw4,sw8,cw2,cw4,cw8 
      double precision oMZSQ, oMZSQ2
      common/additional/sw2,sw4,sw8,cw2,cw4,cw8,oMZSQ,oMZSQ2,
     .     COUPLSM,CV,CA,CVA,CVSQ,CASQ,MZSQ,
     .     CASQ2,CVASQ,CVSQ2,SUMSQ,SUMSQ2
*-------------------------------------------------------------------------
      double precision k1(0:3),k2(0:3),k3(0:3),k4(0:3)
      double precision s12,s13,s14,s23,s24,s34
      double precision os12,os13,os14,os23,os24,os34
      double precision s12sq,s13sq,s14sq,s23sq,s24sq,s34sq
      double precision os12sq,os13sq,os14sq,os23sq,os24sq,os34sq	
      double complex PROPZ12,PROPZ34,PROPZ12C,PROPZ34C
      double complex PROPZ12SQ,PROPZ34SQ
      double complex PropZ1234,PropZ1234C,PropZ1234SQ,
     .     PropZ12C34,PropZ12C34C,PropZ12C34SQ,PropZ12SQ34,PropZ12SQ34C,
     .     PropZ14SQ34SQ
      double complex PROPZ14,PROPZ23,PROPZ14C,PROPZ23C,PROPZ14SQ,
     .     PROPZ23SQ,PropZ1423,PropZ1423C,PropZ14C23,PropZ14C23C,
     .     PropZ1423SQ,PropZ14SQ23,PropZ14C23SQ,PropZ14SQ23C,
     .     PropZ14SQ23SQ,PropZ142312C34C,PropZ123414C23C 

*-------------------------------------------------------------------------
      double precision m3s,me2,mm2,me4,mm4
      double complex cm3s,cover,eps1234
      integer ifirst
      common/commonforborn/cm3s,m3s,cover,me2,mm2,me4,mm4,ifirst
      double precision vczbx(1:10),vczz(1:10)
      integer i
      integer idpart
      common/identicalparticles/idpart

* ANOMALOUS COUPLINGS      
*-------------------------------------------------------------------------
      double precision dGlL,dGlR,dGhlL,dGhlR,dCz,Caa,Cza,Czz,Czbx,Cabx,
     .                 tCaa,tCza,tCzz
      common/higgsbasis/dGlL,dGlR,dGhlL,dGhlR,dCz,Caa,Cza,Czz,Czbx,Cabx,
     .                  tCaa,tCza,tCzz
*------------------------------------------------------------------------      
      integer anm_cpg,basis,quadratics,CP
      common/anm/anm_cpg,basis,quadratics,CP
*---------------------------------------------------------------------------
      
      double complex CI
      common/ccmplx/CI
      
      double precision dot
      double complex  epsfun
      external dot,epsfun
      
      if (ifirst.eq.1) then
         CI = (0D0, 1D0)
         COUPLSM = (gZ**3*MZ)**2

         MZSQ   = MZ**2
         oMZSQ  = 1d0/MZSQ
         oMZSQ2 = oMZSQ**2

         sw2 = sw**2
         sw4 = sw2**2
         sw8 = sw4**2
         cw2 = cw**2
         cw4 = cw2**2
         cw8 = cw4**2

         CV   = (SW2 -1.D0/4.D0)
         CA   = (+1.D0/4.D0)
         CVA  = CV*CA
         CVSQ = CV**2
         CASQ = CA**2
         
         CVSQ2 = CVSQ**2
         CASQ2 = CASQ**2
         CVASQ = CVA**2
         SUMSQ = CVSQ + CASQ
         SUMSQ2= CVSQ2 + CASQ2      

         ifirst = 0
      endif

      k1=p1
      k2=p2
      k3=p3
      k4=p4

      s12 = dot(k1,k2)
      s13 = dot(k1,k3)
      s14 = dot(k1,k4)
      s23 = dot(k2,k3)
      s24 = dot(k2,k4)
      s34 = dot(k3,k4)

      os12 = 1d0/s12
      os13 = 1d0/s13
      os14 = 1d0/s14
      os23 = 1d0/s23
      os24 = 1d0/s24
      os34 = 1d0/s34
 
      
      s12sq = s12**2 
      s13sq = s13**2
      s14sq = s14**2
      s23sq = s23**2
      s24sq = s24**2
      s34sq = s34**2

      os12sq = 1d0/s12sq
      os13sq = 1d0/s13sq
      os14sq = 1d0/s14sq
      os23sq = 1d0/s23sq
      os24sq = 1d0/s24sq
      os34sq = 1d0/s34sq

      PROPZ12 = 1d0/(dot(k1+k2,k1+k2)-MZSQ+CI*WZ*MZ)
      PROPZ34 = 1d0/(dot(k3+k4,k3+k4)-MZSQ+CI*WZ*MZ)

      PROPZ12C= 1d0/(dot(k1+k2,k1+k2)-MZSQ-CI*WZ*MZ)
      PROPZ34C= 1d0/(dot(k3+k4,k3+k4)-MZSQ-CI*WZ*MZ)

      PROPZ12SQ = PROPZ12*PROPZ12C
      PROPZ34SQ = PROPZ34*PROPZ34C

      PropZ1234  = PROPZ12*PROPZ34
      PropZ1234C = PROPZ12*PROPZ34C
      PropZ12C34 = PROPZ12C*PROPZ34
      PropZ12C34C= PROPZ12C*PROPZ34C

      PropZ1234SQ  = PROPZ12*PROPZ34SQ
      PropZ12SQ34  = PROPZ12SQ*PROPZ34
      PropZ12C34SQ = PROPZ12C*PROPZ34SQ
      PropZ12SQ34C = PROPZ12SQ*PROPZ34C

      PropZ12SQ34SQ = PROPZ12SQ*PROPZ34SQ

      PROPZ14 = 1d0/(dot(k1+k4,k1+k4)-MZSQ+CI*WZ*MZ)
      PROPZ23 = 1d0/(dot(k2+k3,k2+k3)-MZSQ+CI*WZ*MZ)

      PROPZ14C= 1d0/(dot(k1+k4,k1+k4)-MZSQ-CI*WZ*MZ)
      PROPZ23C= 1d0/(dot(k2+k3,k2+k3)-MZSQ-CI*WZ*MZ)

      PROPZ14SQ = PROPZ14*PROPZ14C
      PROPZ23SQ = PROPZ23*PROPZ23C

      PropZ1423  = PROPZ14*PROPZ23
      PropZ1423C = PROPZ14*PROPZ23C
      PropZ14C23 = PROPZ14C*PROPZ23
      PropZ14C23C= PROPZ14C*PROPZ23C

      PropZ1423SQ  = PROPZ14*PROPZ23SQ
      PropZ14SQ23  = PROPZ14SQ*PROPZ23
      PropZ14C23SQ = PROPZ14C*PROPZ23SQ
      PropZ14SQ23C = PROPZ14SQ*PROPZ23C

      PropZ14SQ23SQ    = PROPZ14SQ*PROPZ23SQ
      PropZ123414C23C  = PROPZ1234*PropZ14C23C
      PropZ142312C34C  = PROPZ1423*PROPZ12C34C

      eps1234 = CI*epsfun(k1,k2,k3,k4)
      
     
      if(CP.eq.1) then
         if (idpart .eq. 0) then
            include "form/h2e2mu_ME_BSM-CPE-opt.f"
         endif
         if (idpart .eq. 1) then
            include "form/h4e_ME_BSM-CPE-opt.f"
         endif
      elseif(CP.eq.2) then
         if (idpart .eq. 0) then
            include "form/h2e2mu_ME_BSM-CPO-opt.f"
         endif
         if (idpart .eq. 1) then
            include "form/h4e_ME_BSM-CPO-opt.f"
         endif
      elseif(CP.eq.3) then
         if (idpart .eq. 0) then
            include "form/h2e2mu_ME_BSM-full-opt.f"
         endif
         if (idpart .eq. 1) then
            include "form/h4e_ME_BSM-full-opt.f"
         endif
      endif
      end

      

      subroutine dictionary
      implicit none
      double precision NP,NPSQ
      double precision x1,x2
      common/EFTORDER/NP,NPSQ      
*------------------------------------------------------------------------
      double precision Hto4l_dCz,Hto4l_Caa,Hto4l_Cza,Hto4l_Czz,
     .     Hto4l_Czbx,Hto4l_dGlL,Hto4l_dGlR,
     .     Hto4l_dGhlL,Hto4l_dGhlR,
     .     Hto4l_tCaa,Hto4l_tCza,Hto4l_tCzz
      common/dim6/Hto4l_dCz,Hto4l_Caa,Hto4l_Cza,Hto4l_Czz,
     .     Hto4l_Czbx,Hto4l_dGlL,Hto4l_dGlR,
     .     Hto4l_dGhlL,Hto4l_dGhlR,
     .     Hto4l_tCaa,Hto4l_tCza,Hto4l_tCzz
*------------------------------------------------------------------------
      double precision  S_cH,S_cHl,S_cHlp,S_cHe,
     .     S_cll,S_cT,S_c2W,S_c2B,S_cg,S_cW,
     .     S_cB,S_cHW,S_cHB,S_tcg,S_tcHW,S_tcHB
      common/SILH/S_cH,S_cHl,S_cHlp,S_cHe,
     .     S_cll,S_cT,S_c2W,S_c2B,S_cg,S_cW,
     .     S_cB,S_cHW,S_cHB,S_tcg,S_tcHW,S_tcHB
*------------------------------------------------------------------------
      double precision W_cHl3,W_cHl1,W_cHe,W_cHWB,W_cll,
     .     W_cHD,W_cHbx,W_cHW,W_cHB,W_tcHW,
     .     W_tcHB,W_tcHWB
      common/warsaw/W_cHl3,W_cHl1,W_cHe,W_cHWB,W_cll,
     .     W_cHD,W_cHbx,W_cHW,W_cHB,W_tcHW,
     .     W_tcHB,W_tcHWB
*------------------------------------------------------------------------
      double precision dGlL,dGlR,dGhlL,dGhlR,dCz,Caa,Cza,Czz,Czbx,Cabx,
     .     tCaa,tCza,tCzz
      common/higgsbasis/dGlL,dGlR,dGhlL,dGhlR,dCz,Caa,Cza,Czz,Czbx,Cabx,
     .     tCaa,tCza,tCzz
*-------------------------------------------------------------------------
      double precision zmassAN,wmassAN,gfermiAN,zwidthAN 
      common/coupAMB/zmassAN,wmassAN,gfermiAN,zwidthAN
*------------------------------------------------------------------------
      double precision gW,gz,CW,SW,MZ,WZ,g1,gfermi,vev,vev2,delta_mz2
      common/anmcpgs/gW,gz,CW,SW,MZ,WZ,g1,gfermi,vev,vev2,delta_mz2
      double precision swsq
      double precision mw
*-------------------------------------------------------------------------          
      integer anm_cpg,basis,quadratics,CP
      common/anm/anm_cpg,basis,quadratics,CP

      call init_apar_anc
      MZ = zmassAN
      WZ = zwidthAN
      MW = wmassAN
      gfermi = gfermiAN
      
      gW = sqrt(4d0*sqrt(2d0)*gfermi*mw*mw)
      SW = sqrt(1d0 - mw**2/mz**2)
      CW = sqrt(1d0 - sw**2)

      
      g1   = sqrt(4d0*sqrt(2d0)*gfermi*(mz**2 - mw**2))
      gZ   = gw/cw
      vev  = sqrt(1d0/(sqrt(2d0)*gfermi))
      vev2 = vev**2
      SWSQ = SW**2
      
*------INIZIALIZATION ----------------------------------------------------
      dCz    = 0d0
      Caa    = 0d0
      Czz    = 0d0
      Cza    = 0d0  
      Czbx   = 0d0
      dGlL   = 0d0
      dGlR   = 0d0
      dGhlL  = 0d0
      dGhlR  = 0d0
      tCaa   = 0d0
      tCzz   = 0d0
      tCza   = 0d0  

      if (basis.eq.1) then      ! Higgs basis
         dGlL  = Hto4l_dGlL 
         dGlR  = Hto4l_dGlR
         dGhlL = Hto4l_dGhlL 
         dGhlR = Hto4l_dGhlR
         dCz   = Hto4l_dCz
         Caa   = Hto4l_Caa*gw**2
         Cza   = Hto4l_Cza*gw**2
         Czz   = Hto4l_Czz*(gw**2 + g1**2)
         Czbx  = Hto4l_Czbx*gw**2
         tCaa  = Hto4l_tCaa*gw**2
         tCza  = Hto4l_tCza*gw**2
         tCzz  = Hto4l_tCzz*(gw**2 + g1**2)

****  DEPENDENT COUPLING***       
         Cabx = 0d0
         Cabx = + 2d0*Czbx + Czz - swsq*Caa -
     &        ((gW**2-g1**2)/gw**2)*Cza      
         Cabx = Cabx/(gW**2-g1**2)
         Cabx = Cabx*gw**2

***************************

      elseif(basis.eq.2) then ! SILH basis   
         delta_mz2 =  2d0*g1**2/(g1**2 + gw**2)*(S_cW + S_cB) - S_cT 
         delta_mz2 =  0.25d0*delta_mz2*vev*vev*(gw**2 + g1**2)

         x1 = (1d0/(sqrt(2d0)*gfermi))*(2d0*S_cHlp/vev2 - S_cll/vev2)
         x2 = delta_mz2/(2d0*(MZ**2 - MW**2))

         Caa  = 16d0*S_cg
         
         Czz  = (g1**2/gw**2)*(S_cHB - 4d0*(g1**2/(g1**2 + gw**2))*S_cg)
         Czz  = Czz + S_cHW
         Czz  = -4d0*Czz
         
         Cza   = S_cHW - S_cHB + 8d0*(g1**2/(g1**2 + gw**2))*S_cg
         Cza   = -2d0*Cza
         
         Czbx  = S_cW + S_cHW + (g1**2/gw**2)*(S_cB + S_cHB)
         Czbx  = Czbx * 2d0
         
         dCz   = 2d0*S_cT - 0.5d0*S_cH
         dCz   = dCz + 2d0*(g1**2/(g1**2 + gw**2))*(S_cW + S_cB) 
C-- Further contribution due to the choice of input parameter scheme
         dCz = dCz - 0.5d0*x1 - 2d0*g1**2/(g1**2+gw**2)*x2
*-------------------------------------------------------------------

         Cabx  = (2d0)*(S_cW - S_cB + S_cHW - S_cHB)
      
         dGlL  = 0.5d0*((g1**2*(gw**2 - g1**2))/(g1**2 + gw**2)**2)
     .        *(S_cW + S_cB)
         dGlL  = dGlL - 0.5d0*(S_cHl + S_cHlp)
         
C-- Further contribution due to the choice of input parameter scheme
         dGlL = dGlL +   0.5d0*(0.5d0*x1 + g1**2/(g1**2+gw**2)*x2)
     >               + (-0.5d0*x1 + (g1**2/(g1**2+gw**2)-2d0)*x2)
C--------------------------------------------------------------------
         
         dGlR  = ((g1**2 * gw**2)/(g1**2 + gw**2)**2)*(S_cW + S_cB)
         dGlR  = dGlR - 0.5d0*S_cHe

C--   Further contribution due to the choice of input parameter scheme
         dGlR = dGlR +( -0.5d0*x1 + (g1**2/(g1**2+gw**2)-2d0)*x2 )
C---------------------------------------------------------------
         
         dGhlL = - 0.5d0*(S_cHl + S_cHlp)
         dGhlR = - 0.5d0*S_cHe
         
         tCaa = 16d0*S_tcg
         
         tCzz=(g1**2/gw**2)*(S_tcHB - 4d0*(g1**2/(g1**2 + gw**2))*S_tcg)
         tCzz= tCzz + S_tcHW 
         tCzz= -4d0*tCzz
         
         tCza =  S_tcHW - S_tcHB + 8d0*(g1**2/(g1**2 + gw**2))*S_tcg
         tCza = -2d0*tCza
         
      elseif(basis.eq.3) then   ! Warsaw basis

         delta_mz2 = 0.5d0*W_cHD + 2d0*g1*gw/(g1**2 + gw**2)*W_cHWB
         delta_mz2 = 0.25d0*(gw**2 + g1**2)*vev2*vev2*delta_mz2

         x1 = (1d0/(sqrt(2d0)*gfermi))*(2d0*W_cHl3 - W_cll)
         x2 = delta_mz2/(2d0*(MZ**2 - MW**2))


         Caa   = W_cHB/g1**2 + W_cHW/gw**2 - W_cHWB/(g1*gw)
         Caa   = vev2*Caa*4d0
         Caa   = Caa*gw**2
         
         Czz   = (gw**2)*W_cHW + (g1**2)*W_cHB + gw*g1*W_cHWB
         Czz   = vev2*Czz*4d0/(gw**2 + g1**2)**2
         Czz   = Czz*(gw**2 + g1**2)
         
         Cza   = (2d0/(g1*gw))*(W_cHW - W_cHB) 
         Cza   = Cza - (1d0/g1**2 - 1d0/gw**2)*W_cHWB
         Cza   = vev2*Cza*2d0*(g1**2 + gw**2)/(g1*gw)
         Cza   = Cza*gw**2
         
         Czbx  = 0d0
         Cabx  = 0d0
         
         dCz   = (3d0/4d0)*W_cHD + W_cHbx
         dCz   = vev2*(dCz + 2d0*(g1*gw/(g1**2 + gw**2))*W_cHWB)
C-- Further contribution due to the choice of input parameter scheme
         dCz = dCz - 0.5d0*x1 - 2d0*g1**2/(g1**2+gw**2)*x2
*-------------------------------------------------------------------

         dGhlL = -0.5d0*vev2*(W_cHl3 + W_cHl1) 
         dGhlR = -0.5d0*vev2*W_cHe
         
         dGlL = 0.5d0*vev2*(g1*gw/(g1**2+gw**2)**2)*(gw**2-g1**2)*W_cHWB
         dGlL = dGlL + dGhlL
C-- Further contribution due to the choice of input parameter scheme
         dGlL = dGlL +   0.5d0*( 0.5d0*x1 + g1**2/(g1**2+gw**2)*x2 )
     >               + (-0.5d0*x1 + (g1**2/(g1**2+gw**2)-2d0)*x2   )
C--------------------------------------------------------------------

         dGlR = 0.5d0*vev2*(g1*gw/(g1**2 + gw**2)**2)*(2d0*gw**2)*W_cHWB
         dGlR = dGlR + dGhlR  
C--   Further contribution due to the choice of input parameter scheme
         dGlR = dGlR +( -0.5d0*x1 + (g1**2/(g1**2+gw**2)-2d0)*x2 )
C---------------------------------------------------------------
         
         tCaa  = (1d0/gw**2)*W_tcHW
         tCaa  = tCaa + (1d0/g1**2)*W_tcHB
         tCaa  = tCaa - (1d0/(gw*g1))*W_tcHWB
         tCaa  = vev2*tCaa*4d0
         tCaa  = tCaa*gw**2
         
         tCzz  = (gw**2)*W_tcHW + (g1**2)*W_tcHB
         tCzz  = tCzz + gw*g1*W_tcHWB
         tCzz  = vev2*tCzz*4d0/(gw**2 + g1**2)**2
         tCzz  = tCzz*(gw**2 + g1**2)
         
         tCza   = (2d0/(g1*gw))*(W_tcHW - W_tcHB) 
         tCza   = tCza - (1d0/g1**2 - 1d0/gw**2)*W_tcHWB
         tCza   = vev2*tCza*2d0*(g1**2 + gw**2)/(g1*gw)
         tCza   = tCza*gw**2

      endif

         NP   = 1d0
         NPSQ = quadratics      
         end

      subroutine init_apar_anc
      implicit none
      double precision zmassAN,wmassAN,gfermiAN,zwidthAN 
      common/coupAMB/zmassAN,wmassAN,gfermiAN,zwidthAN
      include "couplingandmasses.h"

      zmassAN  = zmass
      wmassAN  = wmass
      zwidthAN = zwidth
      gfermiAN = gfermi
      end


      
