      subroutine hto4l_initialize
      implicit double precision (a-h,m,l,o-z)
#include "inigenfin.h"
      data Hto4lversion /'2.02'/
#include "LesHouches.h"
      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3),q(0:3)
      dimension p1l(0:3),p2l(0:3),p3l(0:3),p4l(0:3),ql(0:3)
      dimension ptmp(0:3),pp(0:3),charges(4)
      dimension qph(40,0:3),qphl(40,0:3),csi(1)
      real*4 timearray(2) ,timesum
      double precision em,mm
      integer isvec(25)
      parameter (npart = 5)
      character*9 crsstr
      character*1 tstr
      integer*8 ncalls
      integer lux,lpath,lsuff
      parameter (lux=4,k1=0,k2=0)
      character*100 massadellhiggs
      character*30 errpos
      data errpos/'                              '/
      common/photonmass/mg ! common for routine propagator in Asu3.f
      common/paramhiggs/masshiggs
      integer anm_cpg,basis,quadratics,CP
      common/anm/anm_cpg,basis,quadratics,CP
      double precision mhnom,whtot
      common/higgsnominal/mhnom,whtot
      common/alphas/alpha0,alphaGF,alpha
      common/gdifermi/gfermi
      common/wparam/wmass,wwidth
      common/forcuts/egmax
      common/hadron_parton/ipartonic,iusempi
      common/recombinesmearcut/irecombine,ismearing,icut
      double precision mz1,mz2
      integer nphleg(4)
      common/eikcheck/mz1,mz2,nphleg
      integer iclosecomm(40)
      common/iclosecomm/iclosecomm
      double complex Dr,Drt
      common/deltaerre/Dr,Drt
      common/zwidthonoff/zwonoff
      common/zparam/zmass,zwidth
      common/imode/imode
      integer iba
      common/ibaswitch/iba
      common/identicalparticles/idpart
      parameter (nfs=3,nord=9)
      character*4 fsa(nfs)
      character*8 orda(nord)
      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed
      double precision rescaleQED
      common/QEDrescale/rescaleQED
      common/cutonlowinvmasses/cutlowinvmass
      data ord,fsa,orda/'        ',
     .                  'eemm','eeee','mmmm',
     .                  'born',
     .                  'exoalyin','exoalnin',
     .                  'psoal','psexp',
     .                  'newpsoal','newpsexp','matched','matchnin'
     . /

      double precision mass(5)
      common/amasses/mass
      common/nphotMODE/nphotmode
      data ((qph(i,j),i=1,40),j=0,3) / 160 * 0.d0/	
      data ((qphl(i,j),i=1,40),j=0,3) / 160 * 0.d0/	
      data path /'                                            
     >                                              '/
c      character*12 col(20)
      character*1 tb
      character*1 col(20)
      common/colors/col
      double precision phmass,egmin
      COMMON/INFRAR/phmass,egmin
      common/FSmasses/ame,amm
      common/todebug/emtx2,phsp
      integer ifsc
      common/fscindex/ifsc
      double precision tolleranza
      integer iverbose
      common/verbosity/tolleranza,iverbose
      integer nsearch
      common/searchpoints/nsearch
      double precision truemaxinput
      common/inputtruemax/truemaxinput
      character*10 ctmp
      character*50 dimsixcard
      common/dim6card/dimsixcard
      character*10 basisname
#include "looptools.h"

      call initcolors

*>>* PID of the process loaded in procid
      call itoa(getpid(),procid)
      call hostnm(machine)
*<<*
      tb = char(9)
      print*,' '
      print*,'*********************************************************'
      print*,'                     Hto4l [v'//Hto4lversion//']'
      print*,'  '
      print*,'   decaying SM Higgs into 4 charged leptons at EW NLOPS '
      print*,'  '
      print*,'       http://www.pv.infn.it/hepcomplex/hto4l.html'
      print*,'  '
      print*,'S. Boselli'//tb//tb//'stefano.boselli[at]pv.infn.it'
      print*,'C.M. Carloni Calame'//tb//
     >'carlo.carloni.calame[at]pv.infn.it'
      print*,'G. Montagna'//tb//tb//'guido.montagna[at]pv.infn.it'
      print*,'O. Nicrosini'//tb//tb//'oreste.nicrosini[at]pv.infn.it'
      print*,'F. Piccinini'//tb//tb//'fulvio.piccinini[at]pv.infn.it'
      print*,'*********************************************************'
      print*,'  '

      ipartonic = 1 ! hardwired
      
      print*,col(5)//'Enter fs particles (eemm/eeee/mmmm)'//col(1)
      read(*,*)fsc

! put in common to talk with LHE interface      
      ifsc = 1
      if (fsc.eq.'mmmm') ifsc = 2
      if (fsc.eq.'eeee') ifsc = 3
!
      
      print*,col(5)//'Enter order of corrections (born/exoal/matched)'
     >     //col(1)

cc for authors, the true available ord are the following ones...
c      print*,col(5)//' (born/exoalyin/exoalnin/psoal/psexp)'//col(1)
c      print*,col(5)//'(*newpsoal/newpsexp/matched/matchnin*)'//col(1)
      read(*,*)ord
      if (ord(1:5).eq.'exoal') ord = 'exoalyin'
      
      iba = 0                   ! hardwired      
c      print*,col(5)//'Enter if including IBA or not'//col(1)
c      read(*,*)iba

      print*,col(6)//'Enter seed for random number generator'//col(1)
      read(*,*)iseed
!      print*,col(5)//'Nphotmode? (<0/0/1)'//col(1)
!      read(*,*)nphotmode
      nphotmode = -1 ! hardwired

      mg = 1d-5 ! hardwired

c     print*,col(5)//'Minimum photon energy (egmin) in radiative'//
c     >' event (GeV)'//col(1)
c      read(*,*)egmin
      egmin = 5d-4 ! hardwired
      
      print*,col(5)//'Higgs mass (GeV)'//col(1)
      read(*,*)masshiggs

***   in common!
      mhnom = masshiggs
***
c      print*,col(5)//'Higgs Total Width (GeV)'//col(1)
c      read(*,*)whtot

      whtot = 5d-3 ! hardwired!!
      
      print*,col(5)//'Switch on weak corrections? (0=only QED/1=full'//
     .' EW NLO)'//col(1)
      read(*,*)iweakcorr
      ionlyqed = 1 - iweakcorr

      icut       = 0
      irecombine = 0
      ismearing  = 0

      print*,col(5)//'Cut on low lepton pair inv. mass? (GeV)'//col(1)
      read(*,*)cutlowinvmass
      print*,'anomalous couplings involved? (0=NO; >0 YES)'
      read(*,*) anm_cpg
      print*,'CP choice (1=EVEN, 2=ODD, 3 = EVEN + ODD)'
      read(*,*) CP
      print*,'basis choice (higgs, silh, warsaw)'
      read(*,*) basisname      
      print*,'dimension-6 card'
      read(*,*) dimsixcard 
      print*,'anomalous quadratic terms (0 int, 1 quadratics)'
      read(*,*) quadratics
      nmax = huge(nmax)! hardwired (and not used....)

      isstandalone = .FALSE.
      print*,col(5)//'Run in standalone mode or lhe mode?'//col(1)
      read(*,*)ctmp
      if (ctmp(1:10).eq.'standalone') isstandalone = .TRUE.
      
      print*,col(5)//'Output directory (max. 20 char.)'//col(1)
      read(*,*)path

***   LHE interface
      lheinfile  = 'lheinput.lhe'
      lheoutfile = 'lheoutput.lhe'

      if (.NOT.isstandalone) then
         print*,col(5)//'Input LHE file?'
     >        //col(1)
         read*,lheinfile
         
         print*,col(5)//'Output LHE file?'
     >        //col(1)
         read*,lheoutfile
      endif

      
***************read the dimension-6 param card *******************************
      if(anm_cpg .gt. 0) then
         if(ord.ne.'born') then
            print*,'The dimension six operators are taken' 
            print*,'into account only at LO SM accuracy'
            print*,' Stopping here.'     
            print*,'###############################################'
            stop
         endif
      endif
      
      if(anm_cpg .gt. 0) then
         if(basisname(1:5).eq.'higgs')  then
            basis = 1
         elseif(basisname(1:4).eq.'silh') then
            basis = 2
         elseif(basisname(1:6).eq.'warsaw') then
            basis = 3
         else
            print*,'Wrong basis choice: '//basisname
            print*,' Stopping here.'     
            print*,'###############################################'
            stop
         endif

         if (CP.ne.1 .and. CP.ne.2 .and. CP.ne.3) then
            print*, 'invalid CP choice! Stopping here!'
            print*,'###############################################'
            stop
         endif

         if (quadratics.ne.0 .and. quadratics.ne.1) then
            print*, 'invalid choice on the quadratics! Stopping here!'
            print*,'###############################################'
            stop
         endif

         
         if(Hto4l_dGlL.ne.Hto4l_dGhlL .or.
     .      Hto4l_dGlR.ne.Hto4l_dGhlR) then
            print*, " "
            print*, "WARNING: IN THE LINEAR EFT THE CONTACTS ARE EQUAL"
            print*, "TO THE ANOMALOUS Zff VERTEXES !!!"
         endif
         
      endif
******************************************************************************

      iok = 0
      do i = 1,nfs
         if (fsc.eq.fsa(i)) iok = 1
      enddo
      if (iok.eq.0) then
         print*,' ' 
         print*,'Wrong final state string: '//fsc
         print*,' Stopping here.'     
         print*,'###############################################'
         stop
      endif

      iok = 0
      do i = 1,nord
         if (ord.eq.orda(i)) iok = 1
      enddo
      if (iok.eq.0) then
         print*,' ' 
         print*,'Wrong order string: '//ord
         print*,' Stopping here!'     
         print*,'###############################################'
         stop
      endif
      
      if ((fsc.eq.'eeee'.or.fsc.eq.'mmmm').and.ord.eq.'exoalnin') then
         print*,' ' 
         print*,'Wrong input! Identical particles meaningless without'//
     .        ' interference. Stopping here!'
         print*,'###############################################'
         stop
      endif
      
      if ((fsc.eq.'eeee'.or.fsc.eq.'mmmm').and.ord.eq.'matchnin') then
         print*,' ' 
         print*,'Wrong input! Identical particles meaningless without'//
     .        ' interference. Stopping here!'
         print*,'###############################################'
         stop
      endif


         
****************************************************************************

*********** setting old imode (used in subroutines) ******************
      if (ord.eq.'exoalnin'.and.fsc.eq.'eemm') imode = 1
      if (ord.eq.'exoalyin'.and.fsc.eq.'eemm') imode = 2
      if (ord.eq.'exoalyin'.and.fsc.eq.'eeee') imode = 3
      if (ord.eq.'exoalyin'.and.fsc.eq.'mmmm') imode = 4
      if (ord.eq.'psoal'   .and.fsc.eq.'eemm') imode = 11
      if (ord.eq.'psexp'   .and.fsc.eq.'eemm') imode = 12
      if (ord.eq.'psoal'   .and.fsc.eq.'eeee') imode = 13
      if (ord.eq.'psexp'   .and.fsc.eq.'eeee') imode = 14
      if (ord.eq.'psoal'   .and.fsc.eq.'mmmm') imode = 15
      if (ord.eq.'psexp'   .and.fsc.eq.'mmmm') imode = 16
      if (ord.eq.'born'    .and.fsc.eq.'eemm') imode = 21
      if (ord.eq.'born'    .and.fsc.eq.'eeee') imode = 22
      if (ord.eq.'born'    .and.fsc.eq.'mmmm') imode = 23
      if (ord.eq.'newpsoal'.and.fsc.eq.'eemm') imode = 31
      if (ord.eq.'newpsoal'.and.fsc.eq.'eeee') imode = 32
      if (ord.eq.'newpsoal'.and.fsc.eq.'mmmm') imode = 33
      if (ord.eq.'newpsexp'.and.fsc.eq.'eemm') imode = 34
      if (ord.eq.'newpsexp'.and.fsc.eq.'eeee') imode = 35
      if (ord.eq.'newpsexp'.and.fsc.eq.'mmmm') imode = 36
      if (ord.eq.'matched' .and.fsc.eq.'eemm') imode = 37
      if (ord.eq.'matched' .and.fsc.eq.'eeee') imode = 38
      if (ord.eq.'matched' .and.fsc.eq.'mmmm') imode = 39
      if (ord.eq.'matchnin'.and.fsc.eq.'eemm') imode = 40
****************************************************************************

**** NAME OF FILES **********
      do ki =1,30
         suffix(ki:ki) = ' '
      enddo

      if (iba.eq.0) then
         if (imode.eq.1)  suffix='ex_nin_eemm_'
         if (imode.eq.2)  suffix='ex_yin_eemm_'
         if (imode.eq.3)  suffix='ex_yin_eeee_'
         if (imode.eq.4)  suffix='ex_yin_mmmm_'
         if (imode.eq.11) suffix='ps_oal_eemm_' 
         if (imode.eq.12) suffix='ps_exp_eemm_' 
         if (imode.eq.13) suffix='ps_oal_eeee_' 
         if (imode.eq.14) suffix='ps_exp_eeee_' 
         if (imode.eq.15) suffix='ps_oal_mmmm_' 
         if (imode.eq.16) suffix='ps_exp_mmmm_'
         if (imode.eq.21) suffix='born_eemm_' 
         if (imode.eq.22) suffix='born_eeee_' 
         if (imode.eq.23) suffix='born_mmmm_' 
         
         if (imode.eq.31) suffix='newps_oal_eemm_' 
         if (imode.eq.32) suffix='newps_oal_eeee_' 
         if (imode.eq.33) suffix='newps_oal_mmmm_' 
         
         if (imode.eq.34) suffix='newps_exp_eemm_' 
         if (imode.eq.35) suffix='newps_exp_eeee_' 
         if (imode.eq.36) suffix='newps_exp_mmmm_' 
         
         if (imode.eq.37) suffix='matched_exp_eemm_' 
         if (imode.eq.38) suffix='matched_exp_eeee_' 
         if (imode.eq.39) suffix='matched_exp_mmmm_' 
         if (imode.eq.40) suffix='matchnin_exp_eemm_'
      else
         if (imode.eq.1)  suffix='ex_nin_IBA_eemm_'
         if (imode.eq.2)  suffix='ex_yin_IBA_eemm_'
         if (imode.eq.3)  suffix='ex_yin_IBA_eeee_'
         if (imode.eq.4)  suffix='ex_yin_IBA_mmmm_'
         if (imode.eq.11) suffix='ps_oal_IBA_eemm_' 
         if (imode.eq.12) suffix='ps_exp_IBA_eemm_' 
         if (imode.eq.13) suffix='ps_oal_IBA_eeee_' 
         if (imode.eq.14) suffix='ps_exp_IBA_eeee_' 
         if (imode.eq.15) suffix='ps_oal_IBA_mmmm_' 
         if (imode.eq.16) suffix='ps_exp_IBA_mmmm_'
         if (imode.eq.21) suffix='born_IBA_eemm_' 
         if (imode.eq.22) suffix='born_IBA_eeee_' 
         if (imode.eq.23) suffix='born_IBA_mmmm_' 
         
         if (imode.eq.31) suffix='newps_oal_IBA_eemm_' 
         if (imode.eq.32) suffix='newps_oal_IBA_eeee_' 
         if (imode.eq.33) suffix='newps_oal_IBA_mmmm_' 
         
         if (imode.eq.34) suffix='newps_exp_IBA_eemm_' 
         if (imode.eq.35) suffix='newps_exp_IBA_eeee_' 
         if (imode.eq.36) suffix='newps_exp_IBA_mmmm_' 
         
         if (imode.eq.37) suffix='matched_exp_IBA_eemm_' 
         if (imode.eq.38) suffix='matched_exp_IBA_eeee_' 
         if (imode.eq.39) suffix='matched_exp_IBA_mmmm_' 
         if (imode.eq.40) suffix='matchnin_exp_IBA_eemm_' 
      endif

      if (ionlyqed.eq.1.and.
     >     (suffix(1:2).eq.'ex'.or.
     .      suffix(1:2).eq.'ma')) then
         ils = 1
         do while (suffix(ils:ils).ne.' ')
            ils = ils + 1
         enddo
         suffix = suffix(1:ils-1)//'QED_'
      endif

      call fptoa(masshiggs,massadellhiggs)
      tmp = abs(masshiggs-int(masshiggs))
      if (tmp.lt.1.d-10) call itoa(int(masshiggs),massadellhiggs)
      call merge_strings(suffix,massadellhiggs,suffix)

      do ki = 1,100
         if (path(ki:ki).ne.' ') lpath=ki
      enddo
      if (path(lpath:lpath).ne.'/') then
         lpath = lpath+1
         path(lpath:lpath)='/'
      endif
      call system('mkdir -p '//path)

      do ki = 1,30
         if (suffix(ki:ki).ne.' ') lsuff=ki
      enddo   

      call itoa(icut,tstr)
      crsstr(1:3) = '_c'//tstr
      call itoa(irecombine,tstr)
      crsstr(4:6) = '_r'//tstr
      call itoa(ismearing,tstr)
      crsstr(7:9) = '_s'//tstr   
c      outputfile = path(1:lpath)//suffix(1:lsuff)//crsstr//'_statistics'
      outputfile = path(1:lpath)//suffix(1:lsuff)//'_statistics'
      
      call setfilenames(suffix,path)
*******************************

      ame = 0.51099892d-3
      amm = 0.105658369d0

      if(anm_cpg .gt. 0) then         
         ame = 0d0
         amm = 0d0
      endif
      
      statfactor = 2.d0 ! statistical factor!!
                        ! con 2 ottengo i numeri
                        ! di higgsdecay
      em     = ame
      mm     = amm
      phmass = mg

      if (fsc.eq.'eemm') then
         idpart  = 0
         mass(1) = ame
         mass(2) = ame
         mass(3) = amm
         mass(4) = amm
      elseif (fsc.eq.'eeee') then
         idpart  = 1
         mass(1) = ame
         mass(2) = ame
         mass(3) = ame
         mass(4) = ame
      elseif (fsc.eq.'mmmm') then
         idpart  = 1
         mass(1) = amm
         mass(2) = amm
         mass(3) = amm
         mass(4) = amm
      endif

      mass(5) = 0.d0

************** STATISTICAL FACTOR
      statfact = 1.d0/2.d0
      if (idpart.eq.1) statfact = statfact * 4.d0
      statfactor = statfactor*statfact
*********************************************************

      do ki = 1,4
         charges(ki) = -1.d0
      enddo

      ph(0) = masshiggs
      ph(1) = 0.d0
      ph(2) = 0.d0
      ph(3) = 0.d0
      
      call initlooptools

      call init_apar

      call initrndgen(iseed)

      call init_partonshower
      
      if(anm_cpg .gt. 0) call dimsixread
      
! if Parton Shower is chosen, no exact photons are present!
      if (imode.gt.10.and.imode.lt.30) nphotmode = 0

c      open(16,file='rlxjump',status='unknown')
c      read(16,*)isvec
c      call rluxin(isvec)
c      close(16)

      call etime(timearray2,timesum2)
      k = 0
      iwri = 0

      toXeV  = 1000.d0 ! this translates to MeV

      tolleranza = 1.5d0
      iverbose   = 0
      nsearch    = 1000000
      truemax    = truemaxinput
      
      iwriout = 500000
      if (imode.ge.37) iwriout = 50000

***   
      return
      end

*******************************************************************************
      subroutine hto4l_decay(weimo,ntotin,mh,phin,p1l,p2l,p3l,p4l,qphl,
     >     ng,weight,ierr)
! Inputs:
!     character*10 weimo: 'weighted' or 'unweighted'. If 'weighted', the routine will return
!               when an event with weight 'weight' is generated, otherwise when an
!               unweighted event has been generated
!     integer*8 ntotin: total number of events to be generated, according to 'weimo'
!     double precision mh: mass of the Higgs boson (GeV)
!     double precision phin(0:3): Higgs momentum in the LAB frame, 0=E, 1=px, 2=py, 3=pz
!
! Outputs:
!     double precision p1l, p2l, p3l, p4l: lepton momenta in the LAB frame
!     double precision qphl(40,0:3): up to 40 photon momenta
!     integer ng: number of photons
!     double precision weight: weight of the event. If weimo='unweighted', weight = +1 or -1
!     integer ierr: error code. ierr = 0 no error, ierr > 0 event to be rejected
      implicit double precision (a-h,m,l,o-z)
#include "inigenfin.h"
      character*10 weimo
      integer ierr
      integer*8 ntotin,k,kunw,kw,nmaxprw,nmaxprunw,imtxcalc
      double precision phin(0:3)
      
      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3),q(0:3)
      dimension p1l(0:3),p2l(0:3),p3l(0:3),p4l(0:3),ql(0:3)
      dimension ptmp(0:3),pp(0:3),charges(4)
      dimension qph(40,0:3),qphl(40,0:3),csi(1)
      real*4 timearray(2) ,timesum

      double precision em,mm

      integer isvec(25)
      parameter (npart = 5)
      character*9 crsstr
      character*1 tstr
      integer*8 ncalls
      integer lpath,lsuff
      character*100 massadellhiggs
      character*30 errpos
      data errpos/'                              '/

      common/photonmass/mg ! common for routine propagator in Asu3.f
      common/paramhiggs/masshiggs

      double precision mhnom,whtot
      common/higgsnominal/mhnom,whtot

      common/alphas/alpha0,alphaGF,alpha
      common/gdifermi/gfermi
      common/wparam/wmass,wwidth
      common/forcuts/egmax
      common/hadron_parton/ipartonic,iusempi
      common/recombinesmearcut/irecombine,ismearing,icut

      double precision mz1,mz2
      integer nphleg(4)
      common/eikcheck/mz1,mz2,nphleg
      integer iclosecomm(40)
      common/iclosecomm/iclosecomm

      double complex Dr,Drt
      common/deltaerre/Dr,Drt

      common/zwidthonoff/zwonoff
      common/zparam/zmass,zwidth

      common/imode/imode
      integer iba
      common/ibaswitch/iba
      common/identicalparticles/idpart

      parameter (nfs=3,nord=9)
      character*4 fsa(nfs)
      character*8 orda(nord)

      logical writecond
      
      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed

      double precision rescaleQED
      common/QEDrescale/rescaleQED

      double precision mass(5)
      common/amasses/mass

      common/nphotMODE/nphotmode

      data ((qph(i,j),i=1,40),j=0,3) / 160 * 0.d0/	

c      character*12 col(20)
      character*1 col(20)
      common/colors/col

      double precision phmass,egmin
      COMMON/INFRAR/phmass,egmin
      common/FSmasses/ame,amm

      common/todebug/emtx2,phsp

      integer mothersph(50),motherslep(4)
      common/figli_di_padre_ignoto/mothersph,motherslep
      
      common/Hdecaygen/nmaxprw,nmaxprunw,kw,ifirstdecay,iwmod,
     >     iunwmod,istopsearch,isearch,nover,nnegw,nnegunw
      data ifirstdecay /1/
      integer*8 ntotincmn
      common/tobeprinted/ntotincmn

      common/howmanycalctimes/imtxcalc
      data imtxcalc /0/
      
      double precision tolleranza
      integer iverbose,nsearch
      common/verbosity/tolleranza,iverbose
      common/searchpoints/nsearch
      common/suggestedtruemax/truemaxsuggested
      
#include "looptools.h"
      if (ifirstdecay.eq.1) then
         
         ntotincmn = ntotin

         isearch     = 0
         
         nhit     = 0
         nhitmiss = 0
         ic       = 0

         nover   = 0
         nnegw   = 0
         nnegunw = 0

         kw   = 0

         qphl = 0.d0

         iwmod = 0
         if (weimo.eq.'weighted') iwmod = 1
         iunwmod = 1 - iwmod

         nmaxprw   = ntotin * iwmod   + nmax * (1-iwmod)
         nmaxprunw = ntotin * iunwmod + nmax * (1-iunwmod)

         
         if (iunwmod.eq.1) then
            if (truemax.gt.0.d0) then
               print*,'Using as maximum value for unweighting ',
     >              truemax,', as set in input'
            else
               print*,'Looking for maximum diff. partial width with ',
     >              nsearch,' phase space points'
            endif
         endif

         flux = 1.d0/2.d0/masshiggs
         
         do ki = 0,40
            w_sum(ki)  = 0.d0
            w_sum2(ki) = 0.d0
            sigma(ki) = 0.d0
            width(ki) = 0.d0
         enddo
         w_sumt  = 0.d0
         w_sumt2 = 0.d0
         sigmat  = 0.d0
         widtht  = 0.d0
         nphmax = 0
         
         sumover  = 0.d0
         sumover2 = 0.d0
         sumneg   = 0.d0
         sumneg2  = 0.d0
         
         ic = 0
         varbefore = 1d-9
         emin1 = masshiggs
         emin2 = masshiggs
         nhit  = 0
         widthhm = 0.d0
         varhm   = 0.d0
         effhm   = 0.d0
         emtxmax = 0.d0
         phspmax = 0.d0

         truemaxsuggested = 0.d0
         if (truemax.gt.0.d0) then
            setmax      = truemax
            istopsearch = 1
         else   
            truemax     =  1.d-10
            setmax      =  1.15d0 * truemax
            istopsearch = -1
         endif

         truemin = huge(truemin)
         
         ifirstdecay = 0
      endif

      masshiggs = mh
      call new_boost(phin,phin,ph,1)
      
      ierr = 0
      
 1000 continue ! loop over nsearch and misses

      kw   = kw + 1
      
      call rluxut(isvec)
      emtx2 = 0.d0

      qphl(max(1,nphmax),:) = 0.d0 ! resetting photon momenta

      call phasespaceZatREST(ph,mass,ng,p1,p2,p3,p4,qph,
     >     phsp,wphsp,iephsp)

c$$$     !no longer used  
c$$$      call cutfflowinvmasses(p1,p2,p3,p4,icut)
c$$$      if (icut.gt.0) iephsp = icut
c$$$
      call cuts(p1,p2,p3,p4,qph,icut)
      if (icut.gt.0) iephsp = icut
      
      if (ng.gt.nphmax) nphmax = ng

      wmulti = 1.d0
      q(0) = qph(1,0)
      q(1) = qph(1,1)
      q(2) = qph(1,2)
      q(3) = qph(1,3)
           
* Parton Shower         
      if (imode.gt.10.and.imode.lt.30.and.iephsp.eq.0) then 
         call newborn(p1,p2,p3,p4,emtx2,bornIBA)
c            call newbornSPINORS(p1,p2,p3,p4,emtx2,bornIBA)
         if (iba.eq.1) emtx2 = bornIBA
!!! test for PS scale
         q2 = zmass**2          ! old choice
         q21 = q2
         q22 = q2
         call QEDPartonShower(q21,q22,p1,p2,p3,p4,qph,q,ieps)
! in q is put the most energetic photon!
         iephsp = iephsp + ieps
      endif
**************************
      sez = 1.d0
      p1l = p1
      p2l = p2
      p3l = p3
      p4l = p4
      qphl(1:max(1,ng),:) = qph(1:max(1,ng),:)
      ql = qph(1,:)
*************************
      egmax = 10.d0*ph(0)
      if (iephsp.eq.0) then
         ireject = 0
c         call cutsandsmear(p1l,p2l,p3l,p4l,ql,qphl,ireject)
c         if (ireject.eq.1) iephsp = 1
      endif
      if (iephsp.gt.0) then 
         phsp = 0.d0
         wphsp = 0.d0
         emtx2 = 0.d0
      endif
      
      if (iephsp.eq.0) then
         if (imode.lt.10.or.imode.gt.30) then
********************************************************
            call matrixelement(p1,p2,p3,p4,qph,ng,emtx2)
            imtxcalc = imtxcalc + 1
********************************************************
         endif
!! START CHECKING NANs!!
         if (isnan(emtx2).or.isnan(phsp).or.isnan(wphsp)) then
            print*,'POSSIBLE NAN!! ',ng,emtx2,phsp,wphsp
            if (iverbose.eq.1) then
               open(16,file=path(1:lpath)//'rlxNaN-'//procid,
     .              access='append',status='unknown')
               write(16,*)'phsp*wphsp ',phsp*wphsp
               write(16,*)'k ',kw
               write(16,*)'n. gammas: ',ng
               write(16,*)'fermion momenta'
               write(16,*)p1
               write(16,*)p2
               write(16,*)p3
               write(16,*)p4
               write(16,*)'conservation'           
               write(16,*)p1+p2+p3+p4+sum(qph(1:ng,:),1)
               write(16,*)'imode ',imode
               write(16,*)'|M|^2 ',emtx2
               write(16,*)'       p1(0) = ',p1(0)
               write(16,*)'       p1(1) = ',p1(1)
               write(16,*)'       p1(2) = ',p1(2)
               write(16,*)'       p1(3) = ',p1(3)
               write(16,*)'       p2(0) = ',p2(0)
               write(16,*)'       p2(1) = ',p2(1)
               write(16,*)'       p2(2) = ',p2(2)
               write(16,*)'       p2(3) = ',p2(3)
               write(16,*)'       p3(0) = ',p3(0)
               write(16,*)'       p3(1) = ',p3(1)
               write(16,*)'       p3(2) = ',p3(2)
               write(16,*)'       p3(3) = ',p3(3)
               write(16,*)'       p4(0) = ',p4(0)
               write(16,*)'       p4(1) = ',p4(1)
               write(16,*)'       p4(2) = ',p4(2)
               write(16,*)'       p4(3) = ',p4(3)
               do ki = 1,max(1,ng)
                  write(16,*)'       q(0)  = ',qph(ki,0)
                  write(16,*)'       q(1)  = ',qph(ki,1)
                  write(16,*)'       q(2)  = ',qph(ki,2)
                  write(16,*)'       q(3)  = ',qph(ki,3)
               enddo
               write(16,*)'ISVEC FOR RANLUX'
               write(16,*)isvec
               write(16,*)'******************************'
               close(16)
            endif
         endif
!! END CHECKING NANs!!
      endif

      pwidth = phsp*emtx2*flux/statfactor*wmulti*wphsp*toXeV
      pwidth = pwidth * sez
      
!! rejecting if it's a NAN....
      ipwnan = 0
      if (isnan(pwidth)) then
         print*,'KILLED THE EVENT BECAUSE OF A NaN'
         pwidth = 0.d0
         ipwnan = 1
         
         p1l  = 0.d0
         p2l  = 0.d0
         p3l  = 0.d0
         p4l  = 0.d0
         qphl = 0.d0
         goto 1000
c     kw = kw - 1              ! bah...
c         iwri = iwri - 1
      endif
!!!!!!!!!!!!!!!!!!!!!!!!!!
      w_sum(ng)  = w_sum(ng)  + pwidth
      w_sum2(ng) = w_sum2(ng) + pwidth*pwidth
      
      w_sumt  = w_sumt  + pwidth
      w_sumt2 = w_sumt2 + pwidth*pwidth
      
      ak = 1.d0*kw
      width(ng) = w_sum(ng)/ak
      
      widtht    = w_sumt/ak
      
      var(ng)   = (w_sum2(ng)/ak - width(ng)**2)/ak
      sigma(ng) = sqrt(abs(var(ng)))
      
      sigmat = sqrt(abs((w_sumt2/ak - widtht**2)/ak))

*>>   * CLEAR LT CACHE TO AVOID MEMORY LEAKS
      call clearcache()
*<<*
*>>* Distributions     
      ncalls = kw
      if (iephsp.eq.0.and.ipwnan.eq.0) then
         if (iunwmod.eq.1.and.istopsearch.eq.0) then 
            continue ! no distribution whilst looking for the maximum, because also weighted events will be reset
         else
            call distributions(pwidth,ncalls,p1l,p2l,p3l,p4l,ng,qphl)
c            if (ncalls.lt.20) print*,'WARNING WARNING WARNING!!!'
c            rrr = 1.d0
c            call distributions(rrr,ncalls,p1l,p2l,p3l,p4l,ng,qphl)
         endif
      endif
*<< *
      
      if (kw.gt.100000) then
         if (sigmat.gt.tolleranza*varbefore) then
            
            print*,'>>>>>>>> VARIANCE JUMP. EVENT n.',kw,'<<<<<<<<<<'

            if (iverbose.eq.1) then
               open(16,file=path(1:lpath)//'rlxjump-'//procid,
     .              access='append',status='unknown')
               write(16,*)'Event n. = ',kw
               write(16,*)'var,varbefore = ',sigmat,varbefore
               write(16,*)'tolerance ',tolleranza
               write(16,*)'imode ',imode
               write(16,*)'ng     = ',ng
               write(16,*)'phsp  = ',phsp
               write(16,*)'wphsp = ',wphsp
               write(16,*)'|M|^2 = ',emtx2
               write(16,*)'mz1 and mz2 ',mz1,mz2
               write(16,*)'nphleg ',nphleg
               write(16,*)'iclose ',iclosecomm(1:ng)
               write(16,*)'       p1(0) = ',p1(0)
               write(16,*)'       p1(1) = ',p1(1)
               write(16,*)'       p1(2) = ',p1(2)
               write(16,*)'       p1(3) = ',p1(3)
               write(16,*)'       p2(0) = ',p2(0)
               write(16,*)'       p2(1) = ',p2(1)
               write(16,*)'       p2(2) = ',p2(2)
               write(16,*)'       p2(3) = ',p2(3)
               write(16,*)'       p3(0) = ',p3(0)
               write(16,*)'       p3(1) = ',p3(1)
               write(16,*)'       p3(2) = ',p3(2)
               write(16,*)'       p3(3) = ',p3(3)
               write(16,*)'       p4(0) = ',p4(0)
               write(16,*)'       p4(1) = ',p4(1)
               write(16,*)'       p4(2) = ',p4(2)
               write(16,*)'       p4(3) = ',p4(3)
               do ki = 1,max(1,ng)
                  write(16,*)'       q(0)  = ',qph(ki,0)
                  write(16,*)'       q(1)  = ',qph(ki,1)
                  write(16,*)'       q(2)  = ',qph(ki,2)
                  write(16,*)'       q(3)  = ',qph(ki,3)
               enddo
               write(16,*)'ISVEC FOR RANLUX'
               write(16,*)isvec
               write(16,*)'******************************'
               close(16)
            endif
         endif
      endif

      abspwidth = abs(pwidth)

c      open(66,file='scatter',status='OLD',access='APPEND')
c      write(66,*)ng,sqrt(dot(p1l+p2l,p1l+p2l)),abspwidth,emtx2,phsp,
c     .     wphsp     
c      close(66)
      if (pwidth.lt.truemin) then
         truemin = pwidth
      endif

      if (abspwidth.gt.truemaxsuggested) then
         truemaxsuggested = abspwidth
      endif
      
***** unweightening *******************
      if (abspwidth.gt.truemax) then
         truemax = abspwidth
      endif
      if (istopsearch.eq.1) then
         nhitmiss = nhitmiss + 1
         call wraprnd(csi,1)

         if (setmax.lt.pwidth) then
            sumover  = sumover  + pwidth - setmax
            sumover2 = sumover2 + (pwidth-setmax)*(pwidth-setmax)
            nover = nover + 1
c            if (iunwmod.eq.1) goto 1000 ! miss, regenerating the event
         endif
         if (csi(1)*setmax.lt.abspwidth) then
            intw = nint(pwidth/abspwidth)
            nhit = nhit + intw ! hit, added with +-1...
            if (intw.lt.0) nnegunw = nnegunw + 1
         else
            if (iunwmod.eq.1) goto 1000 ! miss, regenerating the event
         endif
      else
         setmax  = truemax
         isearch = isearch  + 1
      endif
***************************************      
      varbefore = sigmat

      writecond =! kw.ge.nmaxprw.or.nhit.ge.nmaxprunw.or.
     >     (mod(nhit,iwriout).eq.0.and.istopsearch.eq.1.and.nhit.gt.0)
     >     .or.mod(kw,iwriout).eq.0
      call writeoutputHto4l(writecond)

      if (isearch.eq.nsearch) then
         istopsearch = 1
!     setmax      = 1.d0*setmax
!     setmax      = 1.1d0*setmax
         setmax      = 1.03d0*setmax         
         isearch     = isearch + 1 ! to avoid to fall inside this IF again
         print*,'Finished looking for the maximum. '//
     >        'Starting unweighted generation.'
         if (iunwmod.eq.1) then
** resetting weighted stats...
c CHECK ALSO THE CALL TO DISTRIBUTIONS!!
            print*,'Resetting also weighted generation'
            kw = 0
            do ki = 0,40
               w_sum(ki)  = 0.d0
               w_sum2(ki) = 0.d0
               sigma(ki) = 0.d0
               width(ki) = 0.d0
            enddo
            w_sumt  = 0.d0
            w_sumt2 = 0.d0
            sigmat  = 0.d0
            widtht  = 0.d0
            nphmax = 0
***   
            goto 1000
         endif
      endif
      if (iunwmod.eq.1.and.istopsearch.ne.1) goto 1000 ! this is to look for the maximum

***   returning the weigth
      if (abspwidth.lt.tiny(abspwidth)) then
         weight = 0.d0
         p1l    = 0.d0
         p2l    = 0.d0
         p3l    = 0.d0
         p4l    = 0.d0
         qphl   = 0.d0
         ierr   = 1
         return
      endif
      weight = pwidth
      if (iunwmod.eq.1) then
         weight = 0.d0
         if (abspwidth.gt.0.d0) weight = pwidth/abspwidth
      endif
*** boosting back into the lab the output momenta
      call new_boost(phin,p1l,p1l,-1)
      call new_boost(phin,p2l,p2l,-1)
      call new_boost(phin,p3l,p3l,-1)
      call new_boost(phin,p4l,p4l,-1)
      if (ng.gt.0) then
         do i = 1,ng
            ptmp = qphl(i,:)
            call new_boost(phin,ptmp,ptmp,-1)
            qphl(i,:) = ptmp
         enddo
      endif
********************************************
      return
      end
*******************************************************************************************      
      subroutine hto4l_finalize
      implicit double precision (a-h,m,l,o-z)
#include "looptools.h"
#include "inigenfin.h"

      call writeoutputHto4l(.TRUE.)

#ifdef LT210
      call ltexi
#endif
#ifdef LT28
      call ltexi
#endif
#ifdef LT25
      call ffexi
#endif
      return
      end
