C--
C-- Convention: eps^{0,1,2,3} = +1 
C--
      DOUBLE PRECISION FUNCTION EPS4(p1,p2,p3,p4)
      DOUBLE PRECISION p1(0:3),p2(0:3),p3(0:3),p4(0:3)

      EPS4 = 0D0

      EPS4 =
     &  + p1(1) * ( p2(2)*p3(3)*p4(0) - p2(2)*p3(0)*p4(3) - p2(3)*p3(2)
     &    *p4(0) + p2(3)*p3(0)*p4(2) + p2(0)*p3(2)*p4(3) - p2(0)*p3(3)*
     &    p4(2) )
      EPS4 = EPS4 + p1(2) * (  - p2(1)*p3(3)*p4(0) + p2(1)*p3(0)*p4(3) +
     &    p2(3)*p3(1)*p4(0) - p2(3)*p3(0)*p4(1) - p2(0)*p3(1)*p4(3) +
     &    p2(0)*p3(3)*p4(1) )
      EPS4 = EPS4 + p1(3) * ( p2(1)*p3(2)*p4(0) - p2(1)*p3(0)*p4(2) -
     &    p2(2)*p3(1)*p4(0) + p2(2)*p3(0)*p4(1) + p2(0)*p3(1)*p4(2) -
     &    p2(0)*p3(2)*p4(1) )
      EPS4 = EPS4 + p1(0) * (  - p2(1)*p3(2)*p4(3) + p2(1)*p3(3)*p4(2) +
     &    p2(2)*p3(1)*p4(3) - p2(2)*p3(3)*p4(1) - p2(3)*p3(1)*p4(2) +
     &    p2(3)*p3(2)*p4(1) )

      RETURN
      END
