C-- Input parameters from MG5 
c$$$      gW = MG5GW
c$$$      CW = MG5CW
c$$$      SW = MG5SW
c$$$      MZ = MDL_MZ
c$$$      WZ = MDL_WZ
C=================
      gZ = gW/CW
      g1 = gZ*SW
      gE = gW*SW
      COUPLSM = (gZ**3*MZ)**2

      SWSQ = SW**2
      CV   = (SWSQ -1.D0/4.D0)
      CA   = (+1.D0/4.D0)
      CVA  = CV*CA
      CVSQ = CV**2
      CASQ = CA**2

      MZSQ = MZ**2

      s12 = dot(k1,k2)
      s13 = dot(k1,k3)
      s14 = dot(k1,k4)
      s23 = dot(k2,k3)
      s24 = dot(k2,k4)
      s34 = dot(k3,k4)

      CI = (0D0, 1D0)
      PROPZ12 = 1d0/(dot(k1+k2,k1+k2)-MZSQ+CI*WZ*MZ)
      PROPZ34 = 1d0/(dot(k3+k4,k3+k4)-MZSQ+CI*WZ*MZ)

      PROPZ12C= 1d0/(dot(k1+k2,k1+k2)-MZSQ-CI*WZ*MZ)
      PROPZ34C= 1d0/(dot(k3+k4,k3+k4)-MZSQ-CI*WZ*MZ)

      PROPZ12SQ = PROPZ12*PROPZ12C
      PROPZ34SQ = PROPZ34*PROPZ34C

*      eps1234 = EPS4(k1,k2,k3,k4)
      eps1234 = CI*epsfun(k1,k2,k3,k4) ! in Hto4l

      MSQSM =
     &  + CASQ**2*couplsm*PropZ12SQ*PropZ34SQ * ( 32*s14*s23 + 32*s13*
     &    s24 )
      MSQSM = MSQSM + CVSQ*CASQ*couplsm*PropZ12SQ*PropZ34SQ * (  - 64*
     &    s14*s23 + 192*s13*s24 )
      MSQSM = MSQSM + CVSQ**2*couplsm*PropZ12SQ*PropZ34SQ * ( 32*s14*
     &    s23 + 32*s13*s24 )

      MSQBSM =
     &  + mzsq**(-2)*couplsm*NPSQ*tCaa**2 * (  - s12**(-2)*s14**2*
     &    s23**2*s34**(-2)*cw**4*sw**8 + 2*s12**(-2)*s13*s14*s23*s24*
     &    s34**(-2)*cw**4*sw**8 - s12**(-2)*s13**2*s24**2*s34**(-2)*
     &    cw**4*sw**8 + 1./2.*s12**(-1)*s24**2*s34**(-1)*cw**4*sw**8 + 
     &    1./2.*s12**(-1)*s23**2*s34**(-1)*cw**4*sw**8 + s12**(-1)*s14*
     &    s23*s34**(-1)*cw**4*sw**8 + 1./2.*s12**(-1)*s14**2*s34**(-1)*
     &    cw**4*sw**8 + s12**(-1)*s13*s24*s34**(-1)*cw**4*sw**8 + 1./2.
     &    *s12**(-1)*s13**2*s34**(-1)*cw**4*sw**8 - cw**4*sw**8 )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NP*tCaa*PropZ12C*
     & PropZ34C*CI * (  - 4*s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4
     &     + 4*s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4 + 4*s12**(-1)
     &    *s13*s14*s23*s34**(-1)*cw**2*sw**4 - 4*s12**(-1)*s13**2*s24*
     &    s34**(-1)*cw**2*sw**4 + 4*s24*cw**2*sw**4 - 4*s13*cw**2*sw**4
     &     )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NP*PropZ12*PropZ34*tCaa*
     & CI * ( 4*s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4 - 4*
     &    s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4 - 4*s12**(-1)*s13*
     &    s14*s23*s34**(-1)*cw**2*sw**4 + 4*s12**(-1)*s13**2*s24*
     &    s34**(-1)*cw**2*sw**4 - 4*s24*cw**2*sw**4 + 4*s13*cw**2*sw**4
     &     )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*tCza**2*PropZ34SQ
     &  * (  - 4*s12**(-2)*s14**2*s23**2*sw**4 + 8*s12**(-2)*s13*s14*
     &    s23*s24*sw**4 - 4*s12**(-2)*s13**2*s24**2*sw**4 + 2*s12**(-1)
     &    *s24**2*s34*sw**4 + 2*s12**(-1)*s23**2*s34*sw**4 + 4*
     &    s12**(-1)*s14*s23*s34*sw**4 + 2*s12**(-1)*s14**2*s34*sw**4 + 
     &    4*s12**(-1)*s13*s24*s34*sw**4 + 2*s12**(-1)*s13**2*s34*sw**4
     &     - 4*s34**2*sw**4 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*tCza**2*PropZ12SQ
     &  * (  - 4*s14**2*s23**2*s34**(-2)*sw**4 + 8*s13*s14*s23*s24*
     &    s34**(-2)*sw**4 - 4*s13**2*s24**2*s34**(-2)*sw**4 + 2*s12*
     &    s24**2*s34**(-1)*sw**4 + 2*s12*s23**2*s34**(-1)*sw**4 + 4*s12
     &    *s14*s23*s34**(-1)*sw**4 + 2*s12*s14**2*s34**(-1)*sw**4 + 4*
     &    s12*s13*s24*s34**(-1)*sw**4 + 2*s12*s13**2*s34**(-1)*sw**4 - 
     &    4*s12**2*sw**4 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*tCaa*tCzz*PropZ12C
     & *PropZ34C * ( 2*s24**2*cw**2*sw**4 - 2*s23**2*cw**2*sw**4 + 4*
     &    s14*s23*cw**2*sw**4 - 2*s14**2*cw**2*sw**4 - 4*s13*s24*cw**2*
     &    sw**4 + 2*s13**2*cw**2*sw**4 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*PropZ34*tCza**2*
     & PropZ12C * ( 2*s24**2*sw**4 - 2*s23**2*sw**4 + 4*s14*s23*sw**4
     &     - 2*s14**2*sw**4 - 4*s13*s24*sw**4 + 2*s13**2*sw**4 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*PropZ12*tCza**2*
     & PropZ34C * ( 2*s24**2*sw**4 - 2*s23**2*sw**4 + 4*s14*s23*sw**4
     &     - 2*s14**2*sw**4 - 4*s13*s24*sw**4 + 2*s13**2*sw**4 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*PropZ12*PropZ34*
     & tCaa*tCzz * ( 2*s24**2*cw**2*sw**4 - 2*s23**2*cw**2*sw**4 + 4*
     &    s14*s23*cw**2*sw**4 - 2*s14**2*cw**2*sw**4 - 4*s13*s24*cw**2*
     &    sw**4 + 2*s13**2*cw**2*sw**4 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*eps1234*couplsm*NP*tCaa*
     & PropZ12C*PropZ34C * (  - 2*s12**(-1)*s24*s34**(-1)*cw**2*sw**4
     &     - 2*s12**(-1)*s23*s34**(-1)*cw**2*sw**4 - 2*s12**(-1)*s14*
     &    s34**(-1)*cw**2*sw**4 - 2*s12**(-1)*s13*s34**(-1)*cw**2*sw**4
     &     )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*eps1234*couplsm*NP*PropZ12*
     & PropZ34*tCaa * (  - 2*s12**(-1)*s24*s34**(-1)*cw**2*sw**4 - 2*
     &    s12**(-1)*s23*s34**(-1)*cw**2*sw**4 - 2*s12**(-1)*s14*
     &    s34**(-1)*cw**2*sw**4 - 2*s12**(-1)*s13*s34**(-1)*cw**2*sw**4
     &     )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-2)*couplsm*NPSQ*tCzz**2*
     & PropZ12SQ*PropZ34SQ * (  - 16*s14**2*s23**2 + 32*s13*s14*s23*s24
     &     - 16*s13**2*s24**2 + 8*s12*s24**2*s34 + 8*s12*s23**2*s34 + 
     &    16*s12*s14*s23*s34 + 8*s12*s14**2*s34 + 16*s12*s13*s24*s34 + 
     &    8*s12*s13**2*s34 - 16*s12**2*s34**2 )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-1)*eps1234*couplsm*NP*tCzz*
     & PropZ12SQ*PropZ34SQ * (  - 16*s24 + 16*s23 + 16*s14 - 16*s13 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*tCza**2*PropZ34SQ
     &  * (  - 4*s12**(-2)*s14**2*s23**2*sw**4 + 8*s12**(-2)*s13*s14*
     &    s23*s24*sw**4 - 4*s12**(-2)*s13**2*s24**2*sw**4 + 2*s12**(-1)
     &    *s24**2*s34*sw**4 + 2*s12**(-1)*s23**2*s34*sw**4 + 4*
     &    s12**(-1)*s14*s23*s34*sw**4 + 2*s12**(-1)*s14**2*s34*sw**4 + 
     &    4*s12**(-1)*s13*s24*s34*sw**4 + 2*s12**(-1)*s13**2*s34*sw**4
     &     - 4*s34**2*sw**4 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*tCza**2*PropZ12SQ
     &  * (  - 4*s14**2*s23**2*s34**(-2)*sw**4 + 8*s13*s14*s23*s24*
     &    s34**(-2)*sw**4 - 4*s13**2*s24**2*s34**(-2)*sw**4 + 2*s12*
     &    s24**2*s34**(-1)*sw**4 + 2*s12*s23**2*s34**(-1)*sw**4 + 4*s12
     &    *s14*s23*s34**(-1)*sw**4 + 2*s12*s14**2*s34**(-1)*sw**4 + 4*
     &    s12*s13*s24*s34**(-1)*sw**4 + 2*s12*s13**2*s34**(-1)*sw**4 - 
     &    4*s12**2*sw**4 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*tCaa*tCzz*PropZ12C
     & *PropZ34C * (  - 4*s12**(-1)*s14**2*s23**2*s34**(-1)*cw**2*sw**4
     &     + 8*s12**(-1)*s13*s14*s23*s24*s34**(-1)*cw**2*sw**4 - 4*
     &    s12**(-1)*s13**2*s24**2*s34**(-1)*cw**2*sw**4 + 2*s24**2*
     &    cw**2*sw**4 + 2*s23**2*cw**2*sw**4 + 4*s14*s23*cw**2*sw**4 + 
     &    2*s14**2*cw**2*sw**4 + 4*s13*s24*cw**2*sw**4 + 2*s13**2*cw**2
     &    *sw**4 - 4*s12*s34*cw**2*sw**4 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*PropZ34*tCza**2*
     & PropZ12C * (  - 4*s12**(-1)*s14**2*s23**2*s34**(-1)*sw**4 + 8*
     &    s12**(-1)*s13*s14*s23*s24*s34**(-1)*sw**4 - 4*s12**(-1)*
     &    s13**2*s24**2*s34**(-1)*sw**4 + 2*s24**2*sw**4 + 2*s23**2*
     &    sw**4 + 4*s14*s23*sw**4 + 2*s14**2*sw**4 + 4*s13*s24*sw**4 + 
     &    2*s13**2*sw**4 - 4*s12*s34*sw**4 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*PropZ12*tCza**2*
     & PropZ34C * (  - 4*s12**(-1)*s14**2*s23**2*s34**(-1)*sw**4 + 8*
     &    s12**(-1)*s13*s14*s23*s24*s34**(-1)*sw**4 - 4*s12**(-1)*
     &    s13**2*s24**2*s34**(-1)*sw**4 + 2*s24**2*sw**4 + 2*s23**2*
     &    sw**4 + 4*s14*s23*sw**4 + 2*s14**2*sw**4 + 4*s13*s24*sw**4 + 
     &    2*s13**2*sw**4 - 4*s12*s34*sw**4 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*PropZ12*PropZ34*
     & tCaa*tCzz * (  - 4*s12**(-1)*s14**2*s23**2*s34**(-1)*cw**2*sw**4
     &     + 8*s12**(-1)*s13*s14*s23*s24*s34**(-1)*cw**2*sw**4 - 4*
     &    s12**(-1)*s13**2*s24**2*s34**(-1)*cw**2*sw**4 + 2*s24**2*
     &    cw**2*sw**4 + 2*s23**2*cw**2*sw**4 + 4*s14*s23*cw**2*sw**4 + 
     &    2*s14**2*cw**2*sw**4 + 4*s13*s24*cw**2*sw**4 + 2*s13**2*cw**2
     &    *sw**4 - 4*s12*s34*cw**2*sw**4 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*eps1234*couplsm*NP*tCaa*
     & PropZ12C*PropZ34C * (  - 2*s12**(-1)*s24*s34**(-1)*cw**2*sw**4
     &     + 2*s12**(-1)*s23*s34**(-1)*cw**2*sw**4 + 2*s12**(-1)*s14*
     &    s34**(-1)*cw**2*sw**4 - 2*s12**(-1)*s13*s34**(-1)*cw**2*sw**4
     &     )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*eps1234*couplsm*NP*PropZ12*
     & PropZ34*tCaa * (  - 2*s12**(-1)*s24*s34**(-1)*cw**2*sw**4 + 2*
     &    s12**(-1)*s23*s34**(-1)*cw**2*sw**4 + 2*s12**(-1)*s14*
     &    s34**(-1)*cw**2*sw**4 - 2*s12**(-1)*s13*s34**(-1)*cw**2*sw**4
     &     )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-2)*couplsm*NPSQ*tCzz**2*
     & PropZ12SQ*PropZ34SQ * (  - 32*s14**2*s23**2 + 64*s13*s14*s23*s24
     &     - 32*s13**2*s24**2 + 48*s12*s24**2*s34 - 16*s12*s23**2*s34
     &     + 96*s12*s14*s23*s34 - 16*s12*s14**2*s34 - 32*s12*s13*s24*
     &    s34 + 48*s12*s13**2*s34 - 32*s12**2*s34**2 )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-1)*eps1234*couplsm*NP*tCzz*
     & PropZ12SQ*PropZ34SQ * (  - 96*s24 - 32*s23 - 32*s14 - 96*s13 )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-2)*couplsm*NPSQ*tCzz**2*
     & PropZ12SQ*PropZ34SQ * (  - 16*s14**2*s23**2 + 32*s13*s14*s23*s24
     &     - 16*s13**2*s24**2 + 8*s12*s24**2*s34 + 8*s12*s23**2*s34 + 
     &    16*s12*s14*s23*s34 + 8*s12*s14**2*s34 + 16*s12*s13*s24*s34 + 
     &    8*s12*s13**2*s34 - 16*s12**2*s34**2 )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-1)*eps1234*couplsm*NP*tCzz*
     & PropZ12SQ*PropZ34SQ * (  - 16*s24 + 16*s23 + 16*s14 - 16*s13 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NP*tCza*PropZ34C*CI*
     & PropZ12SQ * ( 4*s14*s23*s24*s34**(-1)*sw**2 + 4*s14*s23**2*
     &    s34**(-1)*sw**2 - 4*s14**2*s23*s34**(-1)*sw**2 - 4*s13*s24**2
     &    *s34**(-1)*sw**2 - 4*s13*s23*s24*s34**(-1)*sw**2 + 4*s13*s14*
     &    s24*s34**(-1)*sw**2 - 4*s13*s14*s23*s34**(-1)*sw**2 + 4*
     &    s13**2*s24*s34**(-1)*sw**2 - 4*s12*s24*sw**2 + 4*s12*s23*
     &    sw**2 - 4*s12*s14*sw**2 + 4*s12*s13*sw**2 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NP*tCza*PropZ12C*CI*
     & PropZ34SQ * ( 4*s12**(-1)*s14*s23*s24*sw**2 - 4*s12**(-1)*s14*
     &    s23**2*sw**2 + 4*s12**(-1)*s14**2*s23*sw**2 - 4*s12**(-1)*s13
     &    *s24**2*sw**2 + 4*s12**(-1)*s13*s23*s24*sw**2 - 4*s12**(-1)*
     &    s13*s14*s24*sw**2 - 4*s12**(-1)*s13*s14*s23*sw**2 + 4*
     &    s12**(-1)*s13**2*s24*sw**2 - 4*s24*s34*sw**2 - 4*s23*s34*
     &    sw**2 + 4*s14*s34*sw**2 + 4*s13*s34*sw**2 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NP*PropZ34*tCza*CI*
     & PropZ12SQ * (  - 4*s14*s23*s24*s34**(-1)*sw**2 - 4*s14*s23**2*
     &    s34**(-1)*sw**2 + 4*s14**2*s23*s34**(-1)*sw**2 + 4*s13*s24**2
     &    *s34**(-1)*sw**2 + 4*s13*s23*s24*s34**(-1)*sw**2 - 4*s13*s14*
     &    s24*s34**(-1)*sw**2 + 4*s13*s14*s23*s34**(-1)*sw**2 - 4*
     &    s13**2*s24*s34**(-1)*sw**2 + 4*s12*s24*sw**2 - 4*s12*s23*
     &    sw**2 + 4*s12*s14*sw**2 - 4*s12*s13*sw**2 )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NP*PropZ12*tCza*CI*
     & PropZ34SQ * (  - 4*s12**(-1)*s14*s23*s24*sw**2 + 4*s12**(-1)*s14
     &    *s23**2*sw**2 - 4*s12**(-1)*s14**2*s23*sw**2 + 4*s12**(-1)*
     &    s13*s24**2*sw**2 - 4*s12**(-1)*s13*s23*s24*sw**2 + 4*
     &    s12**(-1)*s13*s14*s24*sw**2 + 4*s12**(-1)*s13*s14*s23*sw**2
     &     - 4*s12**(-1)*s13**2*s24*sw**2 + 4*s24*s34*sw**2 + 4*s23*s34
     &    *sw**2 - 4*s14*s34*sw**2 - 4*s13*s34*sw**2 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NP*tCza*PropZ34C*CI*
     & PropZ12SQ * ( 12*s14*s23*s24*s34**(-1)*sw**2 - 4*s14*s23**2*
     &    s34**(-1)*sw**2 + 4*s14**2*s23*s34**(-1)*sw**2 - 12*s13*
     &    s24**2*s34**(-1)*sw**2 + 4*s13*s23*s24*s34**(-1)*sw**2 - 4*
     &    s13*s14*s24*s34**(-1)*sw**2 - 12*s13*s14*s23*s34**(-1)*sw**2
     &     + 12*s13**2*s24*s34**(-1)*sw**2 - 12*s12*s24*sw**2 - 4*s12*
     &    s23*sw**2 + 4*s12*s14*sw**2 + 12*s12*s13*sw**2 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NP*tCza*PropZ12C*CI*
     & PropZ34SQ * ( 12*s12**(-1)*s14*s23*s24*sw**2 + 4*s12**(-1)*s14*
     &    s23**2*sw**2 - 4*s12**(-1)*s14**2*s23*sw**2 - 12*s12**(-1)*
     &    s13*s24**2*sw**2 - 4*s12**(-1)*s13*s23*s24*sw**2 + 4*
     &    s12**(-1)*s13*s14*s24*sw**2 - 12*s12**(-1)*s13*s14*s23*sw**2
     &     + 12*s12**(-1)*s13**2*s24*sw**2 - 12*s24*s34*sw**2 + 4*s23*
     &    s34*sw**2 - 4*s14*s34*sw**2 + 12*s13*s34*sw**2 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NP*PropZ34*tCza*CI*
     & PropZ12SQ * (  - 12*s14*s23*s24*s34**(-1)*sw**2 + 4*s14*s23**2*
     &    s34**(-1)*sw**2 - 4*s14**2*s23*s34**(-1)*sw**2 + 12*s13*
     &    s24**2*s34**(-1)*sw**2 - 4*s13*s23*s24*s34**(-1)*sw**2 + 4*
     &    s13*s14*s24*s34**(-1)*sw**2 + 12*s13*s14*s23*s34**(-1)*sw**2
     &     - 12*s13**2*s24*s34**(-1)*sw**2 + 12*s12*s24*sw**2 + 4*s12*
     &    s23*sw**2 - 4*s12*s14*sw**2 - 12*s12*s13*sw**2 )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NP*PropZ12*tCza*CI*
     & PropZ34SQ * (  - 12*s12**(-1)*s14*s23*s24*sw**2 - 4*s12**(-1)*
     &    s14*s23**2*sw**2 + 4*s12**(-1)*s14**2*s23*sw**2 + 12*
     &    s12**(-1)*s13*s24**2*sw**2 + 4*s12**(-1)*s13*s23*s24*sw**2 - 
     &    4*s12**(-1)*s13*s14*s24*sw**2 + 12*s12**(-1)*s13*s14*s23*
     &    sw**2 - 12*s12**(-1)*s13**2*s24*sw**2 + 12*s24*s34*sw**2 - 4*
     &    s23*s34*sw**2 + 4*s14*s34*sw**2 - 12*s13*s34*sw**2 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*tCaa*tCza*PropZ34C
     &  * ( 2*s12**(-2)*s14**2*s23**2*s34**(-1)*cw**2*sw**6 - 4*
     &    s12**(-2)*s13*s14*s23*s24*s34**(-1)*cw**2*sw**6 + 2*s12**(-2)
     &    *s13**2*s24**2*s34**(-1)*cw**2*sw**6 - s12**(-1)*s24**2*cw**2
     &    *sw**6 - s12**(-1)*s23**2*cw**2*sw**6 - 2*s12**(-1)*s14*s23*
     &    cw**2*sw**6 - s12**(-1)*s14**2*cw**2*sw**6 - 2*s12**(-1)*s13*
     &    s24*cw**2*sw**6 - s12**(-1)*s13**2*cw**2*sw**6 + 2*s34*cw**2*
     &    sw**6 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*tCaa*tCza*PropZ12C
     &  * ( 2*s12**(-1)*s14**2*s23**2*s34**(-2)*cw**2*sw**6 - 4*
     &    s12**(-1)*s13*s14*s23*s24*s34**(-2)*cw**2*sw**6 + 2*s12**(-1)
     &    *s13**2*s24**2*s34**(-2)*cw**2*sw**6 - s24**2*s34**(-1)*cw**2
     &    *sw**6 - s23**2*s34**(-1)*cw**2*sw**6 - 2*s14*s23*s34**(-1)*
     &    cw**2*sw**6 - s14**2*s34**(-1)*cw**2*sw**6 - 2*s13*s24*
     &    s34**(-1)*cw**2*sw**6 - s13**2*s34**(-1)*cw**2*sw**6 + 2*s12*
     &    cw**2*sw**6 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*PropZ34*tCaa*tCza
     &  * ( 2*s12**(-2)*s14**2*s23**2*s34**(-1)*cw**2*sw**6 - 4*
     &    s12**(-2)*s13*s14*s23*s24*s34**(-1)*cw**2*sw**6 + 2*s12**(-2)
     &    *s13**2*s24**2*s34**(-1)*cw**2*sw**6 - s12**(-1)*s24**2*cw**2
     &    *sw**6 - s12**(-1)*s23**2*cw**2*sw**6 - 2*s12**(-1)*s14*s23*
     &    cw**2*sw**6 - s12**(-1)*s14**2*cw**2*sw**6 - 2*s12**(-1)*s13*
     &    s24*cw**2*sw**6 - s12**(-1)*s13**2*cw**2*sw**6 + 2*s34*cw**2*
     &    sw**6 )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*PropZ12*tCaa*tCza
     &  * ( 2*s12**(-1)*s14**2*s23**2*s34**(-2)*cw**2*sw**6 - 4*
     &    s12**(-1)*s13*s14*s23*s24*s34**(-2)*cw**2*sw**6 + 2*s12**(-1)
     &    *s13**2*s24**2*s34**(-2)*cw**2*sw**6 - s24**2*s34**(-1)*cw**2
     &    *sw**6 - s23**2*s34**(-1)*cw**2*sw**6 - 2*s14*s23*s34**(-1)*
     &    cw**2*sw**6 - s14**2*s34**(-1)*cw**2*sw**6 - 2*s13*s24*
     &    s34**(-1)*cw**2*sw**6 - s13**2*s34**(-1)*cw**2*sw**6 + 2*s12*
     &    cw**2*sw**6 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*tCza*tCzz*
     & PropZ34C*PropZ12SQ * ( 8*s14**2*s23**2*s34**(-1)*sw**2 - 16*s13*
     &    s14*s23*s24*s34**(-1)*sw**2 + 8*s13**2*s24**2*s34**(-1)*sw**2
     &     - 12*s12*s24**2*sw**2 + 4*s12*s23**2*sw**2 - 24*s12*s14*s23*
     &    sw**2 + 4*s12*s14**2*sw**2 + 8*s12*s13*s24*sw**2 - 12*s12*
     &    s13**2*sw**2 + 8*s12**2*s34*sw**2 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*tCza*tCzz*
     & PropZ12C*PropZ34SQ * ( 8*s12**(-1)*s14**2*s23**2*sw**2 - 16*
     &    s12**(-1)*s13*s14*s23*s24*sw**2 + 8*s12**(-1)*s13**2*s24**2*
     &    sw**2 - 12*s24**2*s34*sw**2 + 4*s23**2*s34*sw**2 - 24*s14*s23
     &    *s34*sw**2 + 4*s14**2*s34*sw**2 + 8*s13*s24*s34*sw**2 - 12*
     &    s13**2*s34*sw**2 + 8*s12*s34**2*sw**2 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*PropZ34*tCza*
     & tCzz*PropZ12SQ * ( 8*s14**2*s23**2*s34**(-1)*sw**2 - 16*s13*s14*
     &    s23*s24*s34**(-1)*sw**2 + 8*s13**2*s24**2*s34**(-1)*sw**2 - 
     &    12*s12*s24**2*sw**2 + 4*s12*s23**2*sw**2 - 24*s12*s14*s23*
     &    sw**2 + 4*s12*s14**2*sw**2 + 8*s12*s13*s24*sw**2 - 12*s12*
     &    s13**2*sw**2 + 8*s12**2*s34*sw**2 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*PropZ12*tCza*
     & tCzz*PropZ34SQ * ( 8*s12**(-1)*s14**2*s23**2*sw**2 - 16*
     &    s12**(-1)*s13*s14*s23*s24*sw**2 + 8*s12**(-1)*s13**2*s24**2*
     &    sw**2 - 12*s24**2*s34*sw**2 + 4*s23**2*s34*sw**2 - 24*s14*s23
     &    *s34*sw**2 + 4*s14**2*s34*sw**2 + 8*s13*s24*s34*sw**2 - 12*
     &    s13**2*s34*sw**2 + 8*s12*s34**2*sw**2 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*eps1234*couplsm*NP*tCza*
     & PropZ34C*PropZ12SQ * ( 12*s24*s34**(-1)*sw**2 + 4*s23*s34**(-1)*
     &    sw**2 + 4*s14*s34**(-1)*sw**2 + 12*s13*s34**(-1)*sw**2 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*eps1234*couplsm*NP*tCza*
     & PropZ12C*PropZ34SQ * ( 12*s12**(-1)*s24*sw**2 + 4*s12**(-1)*s23*
     &    sw**2 + 4*s12**(-1)*s14*sw**2 + 12*s12**(-1)*s13*sw**2 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*eps1234*couplsm*NP*PropZ34*
     & tCza*PropZ12SQ * ( 12*s24*s34**(-1)*sw**2 + 4*s23*s34**(-1)*
     &    sw**2 + 4*s14*s34**(-1)*sw**2 + 12*s13*s34**(-1)*sw**2 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*eps1234*couplsm*NP*PropZ12*
     & tCza*PropZ34SQ * ( 12*s12**(-1)*s24*sw**2 + 4*s12**(-1)*s23*
     &    sw**2 + 4*s12**(-1)*s14*sw**2 + 12*s12**(-1)*s13*sw**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*tCza*tCzz*
     & PropZ34C*PropZ12SQ * ( 8*s14**2*s23**2*s34**(-1)*sw**2 - 16*s13*
     &    s14*s23*s24*s34**(-1)*sw**2 + 8*s13**2*s24**2*s34**(-1)*sw**2
     &     - 4*s12*s24**2*sw**2 - 4*s12*s23**2*sw**2 - 8*s12*s14*s23*
     &    sw**2 - 4*s12*s14**2*sw**2 - 8*s12*s13*s24*sw**2 - 4*s12*
     &    s13**2*sw**2 + 8*s12**2*s34*sw**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*tCza*tCzz*
     & PropZ12C*PropZ34SQ * ( 8*s12**(-1)*s14**2*s23**2*sw**2 - 16*
     &    s12**(-1)*s13*s14*s23*s24*sw**2 + 8*s12**(-1)*s13**2*s24**2*
     &    sw**2 - 4*s24**2*s34*sw**2 - 4*s23**2*s34*sw**2 - 8*s14*s23*
     &    s34*sw**2 - 4*s14**2*s34*sw**2 - 8*s13*s24*s34*sw**2 - 4*
     &    s13**2*s34*sw**2 + 8*s12*s34**2*sw**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*PropZ34*tCza*
     & tCzz*PropZ12SQ * ( 8*s14**2*s23**2*s34**(-1)*sw**2 - 16*s13*s14*
     &    s23*s24*s34**(-1)*sw**2 + 8*s13**2*s24**2*s34**(-1)*sw**2 - 4
     &    *s12*s24**2*sw**2 - 4*s12*s23**2*sw**2 - 8*s12*s14*s23*sw**2
     &     - 4*s12*s14**2*sw**2 - 8*s12*s13*s24*sw**2 - 4*s12*s13**2*
     &    sw**2 + 8*s12**2*s34*sw**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*PropZ12*tCza*
     & tCzz*PropZ34SQ * ( 8*s12**(-1)*s14**2*s23**2*sw**2 - 16*
     &    s12**(-1)*s13*s14*s23*s24*sw**2 + 8*s12**(-1)*s13**2*s24**2*
     &    sw**2 - 4*s24**2*s34*sw**2 - 4*s23**2*s34*sw**2 - 8*s14*s23*
     &    s34*sw**2 - 4*s14**2*s34*sw**2 - 8*s13*s24*s34*sw**2 - 4*
     &    s13**2*s34*sw**2 + 8*s12*s34**2*sw**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*eps1234*couplsm*NP*tCza*
     & PropZ34C*PropZ12SQ * ( 4*s24*s34**(-1)*sw**2 - 4*s23*s34**(-1)*
     &    sw**2 - 4*s14*s34**(-1)*sw**2 + 4*s13*s34**(-1)*sw**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*eps1234*couplsm*NP*tCza*
     & PropZ12C*PropZ34SQ * ( 4*s12**(-1)*s24*sw**2 - 4*s12**(-1)*s23*
     &    sw**2 - 4*s12**(-1)*s14*sw**2 + 4*s12**(-1)*s13*sw**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*eps1234*couplsm*NP*PropZ34*
     & tCza*PropZ12SQ * ( 4*s24*s34**(-1)*sw**2 - 4*s23*s34**(-1)*sw**2
     &     - 4*s14*s34**(-1)*sw**2 + 4*s13*s34**(-1)*sw**2 )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*eps1234*couplsm*NP*PropZ12*
     & tCza*PropZ34SQ * ( 4*s12**(-1)*s24*sw**2 - 4*s12**(-1)*s23*sw**2
     &     - 4*s12**(-1)*s14*sw**2 + 4*s12**(-1)*s13*sw**2 )
