      subroutine debug5p

      double complex pent1B1S,pent2B1S,pent3B1S,pent4B1S,
     .               pent5B1S,pent6B1S,pent7B1S,pent8B1S,
     .               pent1B2S,pent2B2S,pent3B2S,pent4B2S,
     .               pent5B2S,pent6B2S,pent7B2S,pent8B2S
      common/fivepointsresults/pent1B1S,pent2B1S,pent3B1S,pent4B1S,
     .                         pent5B1S,pent6B1S,pent7B1S,pent8B1S,
     .                         pent1B2S,pent2B2S,pent3B2S,pent4B2S,
     .                         pent5B2S,pent6B2S,pent7B2S,pent8B2S

      double complex pentW1B1S,pentW2B1S,pentW3B1S,pentW4B1S,
     .               pentW5B1S,pentW6B1S,pentW7B1S,pentW8B1S,
     .               pentW1B2S,pentW2B2S,pentW3B2S,pentW4B2S,
     .               pentW5B2S,pentW6B2S,pentW7B2S,pentW8B2S,
     .               pentZ1B1S,pentZ2B1S,pentZ3B1S,pentZ4B1S,
     .               pentZ5B1S,pentZ6B1S,pentZ7B1S,pentZ8B1S,
     .               pentZ1B2S,pentZ2B2S,pentZ3B2S,pentZ4B2S,
     .               pentZ5B2S,pentZ6B2S,pentZ7B2S,pentZ8B2S

      common/fivepointsresultsW/pentW1B1S,pentW2B1S,pentW3B1S,pentW4B1S,
     .                          pentW5B1S,pentW6B1S,pentW7B1S,pentW8B1S,
     .                          pentW1B2S,pentW2B2S,pentW3B2S,pentW4B2S,
     .                          pentW5B2S,pentW6B2S,pentW7B2S,pentW8B2S,
     .                          pentZ1B1S,pentZ2B1S,pentZ3B1S,pentZ4B1S,
     .                          pentZ5B1S,pentZ6B1S,pentZ7B1S,pentZ8B1S,
     .                          pentZ1B2S,pentZ2B2S,pentZ3B2S,pentZ4B2S,
     .                          pentZ5B2S,pentZ6B2S,pentZ7B2S,pentZ8B2S

      print*,'pentagons with photons'
      print*,pent1B1S,pent2B1S,pent3B1S,pent4B1S
      print*,pent5B1S,pent6B1S,pent7B1S,pent8B1S
      print*,pent1B2S,pent2B2S,pent3B2S,pent4B2S
      print*,pent5B2S,pent6B2S,pent7B2S,pent8B2S
      print*,'pentagons with Z'
      print*,pentZ1B1S,pentZ2B1S,pentZ3B1S,pentZ4B1S
      print*,pentZ5B1S,pentZ6B1S,pentZ7B1S,pentZ8B1S
      print*,pentZ1B2S,pentZ2B2S,pentZ3B2S,pentZ4B2S
      print*,pentZ5B2S,pentZ6B2S,pentZ7B2S,pentZ8B2S
      print*,'pentagons with W'
      print*,pentW1B1S,pentW2B1S,pentW3B1S,pentW4B1S
      print*,pentW5B1S,pentW6B1S,pentW7B1S,pentW8B1S
      print*,pentW1B2S,pentW2B2S,pentW3B2S,pentW4B2S
      print*,pentW5B2S,pentW6B2S,pentW7B2S,pentW8B2S

      return
      end
************************************************************************
      subroutine get_pentagons(pentagon)
*** definitions in the notes
*** labelling of the diagrams defined at pag 14 of the notes
c      implicit none      
      implicit double complex (Z)

      double precision pentagon
      double complex   cpentagon
      double complex   pent1BS,pent2BS,pent3BS,pent4BS,
     .                 pent5BS,pent6BS,pent7BS,pent8BS

      double complex   tmp(8)

      integer          i,id,ifirst,iret,idpart,count
! these are defined integer*8 in looptools.h!!!!!!!!!!
      integer*8          id1,id2,id3,id4,id5,id6,id7,id8
      integer*8          id1w,id2w,id3w,id4w,id5w,id6w,id7w,id8w
      integer*8          id1z,id2z,id3z,id4z,id5z,id6z,id7z,id8z
      double complex   ctmp
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3),p5(0:3),ptmp(0:3)
      double complex   E0lt,E1lt,E2lt,E3lt,E4lt,E00lt,E11lt,E12lt,E13lt,
     .                 E14lt,E22lt,E23lt,E24lt,E33lt,E34lt,E44lt
      double precision m1s, m2s, m3s, m4s, m5s
      double precision mws
      double complex   cm1s,cm2s,cm3s,cm4s,cm5s

      double complex   cm2sw,cm5sw ! "w" stands for weak
      double complex   cp3sw,cp4sw,cp1sw,cp2sw

      double precision p3s, p4s, p5s, p1s, p2s
      double complex   cp3s,cp4s,cp5s,cp1s,cp2s
      double complex   cmws

      double complex   cp1p2s,cp1p3s,cp1p4s,cp1p5s
      double complex   cp2p3s,cp2p4s,cp2p5s
      double complex   cp3p4s,cp3p5s
      double complex   cp4p5s

      double precision uno,zero

      common/reali/uno,zero
      data uno,zero/1.d0,0.d0/

      double complex cover,coverZ,coverW
      common/commonforpent/cover,coverZ,coverW,
     .                     me2,mm2,me4,mm4,ifirst,count

      data ifirst,count/1,0/

      double complex pent1B1S,pent2B1S,pent3B1S,pent4B1S,
     .               pent5B1S,pent6B1S,pent7B1S,pent8B1S,
     .               pent1B2S,pent2B2S,pent3B2S,pent4B2S,
     .               pent5B2S,pent6B2S,pent7B2S,pent8B2S
      common/fivepointsresults/pent1B1S,pent2B1S,pent3B1S,pent4B1S,
     .                         pent5B1S,pent6B1S,pent7B1S,pent8B1S,
     .                         pent1B2S,pent2B2S,pent3B2S,pent4B2S,
     .                         pent5B2S,pent6B2S,pent7B2S,pent8B2S

      double complex pentW1B1S,pentW2B1S,pentW3B1S,pentW4B1S,
     .               pentW5B1S,pentW6B1S,pentW7B1S,pentW8B1S,
     .               pentW1B2S,pentW2B2S,pentW3B2S,pentW4B2S,
     .               pentW5B2S,pentW6B2S,pentW7B2S,pentW8B2S,
     .               pentZ1B1S,pentZ2B1S,pentZ3B1S,pentZ4B1S,
     .               pentZ5B1S,pentZ6B1S,pentZ7B1S,pentZ8B1S,
     .               pentZ1B2S,pentZ2B2S,pentZ3B2S,pentZ4B2S,
     .               pentZ5B2S,pentZ6B2S,pentZ7B2S,pentZ8B2S

      common/fivepointsresultsW/pentW1B1S,pentW2B1S,pentW3B1S,pentW4B1S,
     .                          pentW5B1S,pentW6B1S,pentW7B1S,pentW8B1S,
     .                          pentW1B2S,pentW2B2S,pentW3B2S,pentW4B2S,
     .                          pentW5B2S,pentW6B2S,pentW7B2S,pentW8B2S,
     .                          pentZ1B1S,pentZ2B1S,pentZ3B1S,pentZ4B1S,
     .                          pentZ5B1S,pentZ6B1S,pentZ7B1S,pentZ8B1S,
     .                          pentZ1B2S,pentZ2B2S,pentZ3B2S,pentZ4B2S,
     .                          pentZ5B2S,pentZ6B2S,pentZ7B2S,pentZ8B2S

      common/fivePargs/cm1s,cm2s,cm3s,cm4s,cm5s,cp1s,cp2s,cp3s,cp4s,
     .                 cp5s,cmws,cm2sw,cm5sw,cp1sw,cp2sw,cp3sw,cp4sw,
     .                 m1s, m2s, m3s, m4s, m5s,mws,p1s, p2s, p3s, p4s,
     .                 p5s

#include "invariants.h"
**** external parameters
      integer imode
      common/imode/imode
      common/identicalparticles/idpart
      double precision me2,mm2,me4,mm4
      double precision mass(5)
      common/amasses/mass ! common used also to force pXs = m^2

      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed
***
*test
      double complex bornC(2,2),soft_integralIRtest
      external soft_integralIRtest
      common/fortestIR/bornC
      double complex softarray(8)
      double precision sffn
      common/softarrayc/softarray,sffn
****
      double precision dot
      double complex epsfun
      external dot,epsfun

#include "couplingandmasses.h"

#include "looptools.h"

      if (ifirst.eq.1) then

         cover = -(128.d0,0.d0)/16.d0/pi2
     .            * g*conjg(g) 
     .            * g*conjg(g) 
     .            * CHZZ*conjg(CHZZ)  
     .            * elc2 * im

         cover = cover * rescaleQED

         coverZ =  (128.d0,0.d0)/16.d0/pi2
     .            * g*conjg(g) 
     .            * g*conjg(g) 
     .            * CHZZ*conjg(CHZZ)  
     .            * g * g * im

         coverW =  (128.d0,0.d0)/16.d0/pi2
     .            * g*conjg(g) 
     .            * g*conjg(g) 
     .            * CHWW*conjg(CHZZ)  
     .            * g * g * im


c         do i = 1,10
c            print*,'RESTORE massess IN PENTAGONS!'
c         enddo
         me2 = mass(1)*mass(1) !* 0.d0
         mm2 = mass(3)*mass(3) !* 0.d0
         me4 = me2*me2
         mm4 = me2*mm2

c         do i = 1,10
c            print*,'RESTORE COVER IN PENTAGONS!'
c         enddo
c         cover = czero

! >> always the same masses, put in common
         m1s = 0.d0             ! mass(5)*mass(5)
         m2s = mass(3)*mass(3)
         m3s = zmass*zmass
         m4s = zmass*zmass
         m5s = mass(1)*mass(1)
         cm1s = cone * m1s
         cm2s = cone * m2s
         cm3s = m3s - im * zmass * zwidth * zwonoff
         cm4s = m4s - im * zmass * zwidth * zwonoff
         cm5s = cone * m5s

         cm2sw = kfm * cm2s
         cm5sw = kfm * cm5s

         mws  = wmass*wmass
         cmws = mws - im * wmass * wwidth

         pent1B1S = (0.d0,0.d0)
         pent2B1S = (0.d0,0.d0)
         pent3B1S = (0.d0,0.d0)
         pent4B1S = (0.d0,0.d0)
         pent5B1S = (0.d0,0.d0)
         pent6B1S = (0.d0,0.d0)
         pent7B1S = (0.d0,0.d0)
         pent8B1S = (0.d0,0.d0)
         pent1B2S = (0.d0,0.d0)
         pent2B2S = (0.d0,0.d0)
         pent3B2S = (0.d0,0.d0)
         pent4B2S = (0.d0,0.d0)
         pent5B2S = (0.d0,0.d0)
         pent6B2S = (0.d0,0.d0)
         pent7B2S = (0.d0,0.d0)
         pent8B2S = (0.d0,0.d0)

         pentW1B1S = (0.d0,0.d0)
         pentW2B1S = (0.d0,0.d0)
         pentW3B1S = (0.d0,0.d0)
         pentW4B1S = (0.d0,0.d0)
         pentW5B1S = (0.d0,0.d0)
         pentW6B1S = (0.d0,0.d0)
         pentW7B1S = (0.d0,0.d0)
         pentW8B1S = (0.d0,0.d0)
         pentW1B2S = (0.d0,0.d0)
         pentW2B2S = (0.d0,0.d0)
         pentW3B2S = (0.d0,0.d0)
         pentW4B2S = (0.d0,0.d0)
         pentW5B2S = (0.d0,0.d0)
         pentW6B2S = (0.d0,0.d0)
         pentW7B2S = (0.d0,0.d0)
         pentW8B2S = (0.d0,0.d0)

         pentZ1B1S = (0.d0,0.d0)
         pentZ2B1S = (0.d0,0.d0)
         pentZ3B1S = (0.d0,0.d0)
         pentZ4B1S = (0.d0,0.d0)
         pentZ5B1S = (0.d0,0.d0)
         pentZ6B1S = (0.d0,0.d0)
         pentZ7B1S = (0.d0,0.d0)
         pentZ8B1S = (0.d0,0.d0)
         pentZ1B2S = (0.d0,0.d0)
         pentZ2B2S = (0.d0,0.d0)
         pentZ3B2S = (0.d0,0.d0)
         pentZ4B2S = (0.d0,0.d0)
         pentZ5B2S = (0.d0,0.d0)
         pentZ6B2S = (0.d0,0.d0)
         pentZ7B2S = (0.d0,0.d0)
         pentZ8B2S = (0.d0,0.d0)

         ifirst = 0
      endif

c      print*,'pent ',iweakcorr,ionlyqed,rescaleQED

 111  count = count + 1
****  ARGUMENTS FOR Eget... calculated here once for all

      p1s   = mass(1)*mass(1)
      p2s   = p1s  ! mass(1)*mass(1)
      p3s   = mass(3)*mass(3)
      p4s   = p3s  !mass(3)*mass(3)
      p5s   = p1p2p3p4s

      if (zwonoff.gt.0.5d0.or.wwonoff.gt.0.5d0) then
         cp1p2s = cone * p1p2s
         cp1p3s = cone * p1p3s
         cp1p4s = cone * p1p4s
         cp1p5s = cone * p1p5s
         cp2p3s = cone * p2p3s
         cp2p4s = cone * p2p4s
         cp2p5s = cone * p2p5s
         cp3p4s = cone * p3p4s
         cp3p5s = cone * p3p5s
         cp4p5s = cone * p4p5s
         cp1s   = cone * p1s
         cp2s   = cone * p2s
         cp3s   = cone * p3s
         cp4s   = cone * p4s
         cp5s   = cone * p5s

         cp1sw = cp1s*kfm
         cp2sw = cp2s*kfm
         cp3sw = cp3s*kfm
         cp4sw = cp4s*kfm
      endif

      pentagon  = 0.d0
      cpentagon = (0.d0,0.d0)

*************************************************************************************************
******** START PENTAGON 1 WITH PHOTON BETWEEN PARTICLES 2 AND 3 INTERFERED WITH conjugate[BORN_1]
      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id1 = Eget(p3s,p4s,p5s,p1s,p2s,p3p4s,p4p5s,p1p5s,p1p2s,p2p3s,
     .              m1s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id1)
         E1lt  = Eval(ee1,id1)
         E2lt  = Eval(ee2,id1)
         E3lt  = Eval(ee3,id1)
         E4lt  = Eval(ee4,id1)
         E00lt = Eval(ee00,id1)
         E11lt = Eval(ee11,id1)
         E12lt = Eval(ee12,id1)
         E13lt = Eval(ee13,id1)
         E14lt = Eval(ee14,id1)
         E22lt = Eval(ee22,id1)
         E23lt = Eval(ee23,id1)
         E24lt = Eval(ee24,id1)
         E33lt = Eval(ee33,id1)
         E34lt = Eval(ee34,id1)
         E44lt = Eval(ee44,id1)
      else
         id1 = EgetC(cp3s,cp4s,cp5s,cp1s,cp2s,cp3p4s,cp4p5s,cp1p5s,
     .               cp1p2s,cp2p3s,cm1s,cm2s,cm3s,cm4s,cm5s)
         E0lt  = EvalC(ee0,id1)
         E1lt  = EvalC(ee1,id1)
         E2lt  = EvalC(ee2,id1)
         E3lt  = EvalC(ee3,id1)
         E4lt  = EvalC(ee4,id1)
         E00lt = EvalC(ee00,id1)
         E11lt = EvalC(ee11,id1)
         E12lt = EvalC(ee12,id1)
         E13lt = EvalC(ee13,id1)
         E14lt = EvalC(ee14,id1)
         E22lt = EvalC(ee22,id1)
         E23lt = EvalC(ee23,id1)
         E24lt = EvalC(ee24,id1)
         E33lt = EvalC(ee33,id1)
         E34lt = EvalC(ee34,id1)
         E44lt = EvalC(ee44,id1)
      endif

      include 'form/pent1B1S.f'
      pent1B1S = pent1BS * cover * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pent1B1S)
      cpentagon = cpentagon + pent1B1S

c      print*,'QED 1 ',2.d0 * dReal(pent1B1S + pent1B2S)

*********** CORRESPONDING WEAK PENTAGONS
      IF (iweakcorr.eq.1) THEN

*** Z pentagon
      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id1z = Eget(p3s,p4s,p5s,p1s,p2s,p3p4s,p4p5s,p1p5s,p1p2s,p2p3s,
     .              m3s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id1z)
         E1lt  = Eval(ee1,id1z)
         E2lt  = Eval(ee2,id1z)
         E3lt  = Eval(ee3,id1z)
         E4lt  = Eval(ee4,id1z)
         E00lt = Eval(ee00,id1z)
         E11lt = Eval(ee11,id1z)
         E12lt = Eval(ee12,id1z)
         E13lt = Eval(ee13,id1z)
         E14lt = Eval(ee14,id1z)
         E22lt = Eval(ee22,id1z)
         E23lt = Eval(ee23,id1z)
         E24lt = Eval(ee24,id1z)
         E33lt = Eval(ee33,id1z)
         E34lt = Eval(ee34,id1z)
         E44lt = Eval(ee44,id1z)
      else
         id1z = EgetC(cp3sw,cp4sw,cp5s,cp1sw,cp2sw,cp3p4s,cp4p5s,cp1p5s,
     .               cp1p2s,cp2p3s,cm3s,cm2sw,cm3s,cm4s,cm5sw)
         E0lt  = EvalC(ee0,id1z)
         E1lt  = EvalC(ee1,id1z)
         E2lt  = EvalC(ee2,id1z)
         E3lt  = EvalC(ee3,id1z)
         E4lt  = EvalC(ee4,id1z)
         E00lt = EvalC(ee00,id1z)
         E11lt = EvalC(ee11,id1z)
         E12lt = EvalC(ee12,id1z)
         E13lt = EvalC(ee13,id1z)
         E14lt = EvalC(ee14,id1z)
         E22lt = EvalC(ee22,id1z)
         E23lt = EvalC(ee23,id1z)
         E24lt = EvalC(ee24,id1z)
         E33lt = EvalC(ee33,id1z)
         E34lt = EvalC(ee34,id1z)
         E44lt = EvalC(ee44,id1z)
      endif

      include 'form/pentZ1B1S.f'
      pentZ1B1S = pent1BS * coverZ * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pentZ1B1S)
      cpentagon = cpentagon + pentZ1B1S

c      print*,'Z 1 ',2.d0 * dReal(pentZ1B1S + pentZ1B2S)

*** W pentagon

      if (wwonoff.lt.0.5d0) then ! Z width set to zero
         id1w = Eget(p3s,p4s,p5s,p1s,p2s,p3p4s,p4p5s,p1p5s,p1p2s,p2p3s,
     .              mws,zero,mws,mws,zero)
         E0lt  = Eval(ee0,id1w)
         E1lt  = Eval(ee1,id1w)
         E2lt  = Eval(ee2,id1w)
         E3lt  = Eval(ee3,id1w)
         E4lt  = Eval(ee4,id1w)
         E00lt = Eval(ee00,id1w)
         E11lt = Eval(ee11,id1w)
         E12lt = Eval(ee12,id1w)
         E13lt = Eval(ee13,id1w)
         E14lt = Eval(ee14,id1w)
         E22lt = Eval(ee22,id1w)
         E23lt = Eval(ee23,id1w)
         E24lt = Eval(ee24,id1w)
         E33lt = Eval(ee33,id1w)
         E34lt = Eval(ee34,id1w)
         E44lt = Eval(ee44,id1w)
      else
         id1w = EgetC(cp3sw,cp4sw,cp5s,cp1sw,cp2sw,cp3p4s,cp4p5s,cp1p5s,
     .               cp1p2s,cp2p3s,cmws,czero,cmws,cmws,czero)

         E0lt  = EvalC(ee0,id1w)
         E1lt  = EvalC(ee1,id1w)
         E2lt  = EvalC(ee2,id1w)
         E3lt  = EvalC(ee3,id1w)
         E4lt  = EvalC(ee4,id1w)
         E00lt = EvalC(ee00,id1w)
         E11lt = EvalC(ee11,id1w)
         E12lt = EvalC(ee12,id1w)
         E13lt = EvalC(ee13,id1w)
         E14lt = EvalC(ee14,id1w)
         E22lt = EvalC(ee22,id1w)
         E23lt = EvalC(ee23,id1w)
         E24lt = EvalC(ee24,id1w)
         E33lt = EvalC(ee33,id1w)
         E34lt = EvalC(ee34,id1w)
         E44lt = EvalC(ee44,id1w)
      endif

      include 'form/pentW1B1S.f'
      pentW1B1S = pent1BS * coverW  * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pentW1B1S)
      cpentagon = cpentagon + pentW1B1S

c      print*,'1   W',2.d0 * dReal(pentW1B1S + pentW1B2S)


***********************************************
      ENDIF
******** END *********************************************************************************

******** START PENTAGON 3 WITH PHOTON BETWEEN PARTICLES 1 AND 4 INTERFERED WITH conjugate[BORN_1]
********                                                               AND WITH conjugate[BORN_2]

      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id3 = Eget(p4s,p3s,p5s,p2s,p1s,p3p4s,p3p5s,p2p5s,p1p2s,p1p4s,
     .              m1s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id3)
         E1lt  = Eval(ee1,id3)
         E2lt  = Eval(ee2,id3)
         E3lt  = Eval(ee3,id3)
         E4lt  = Eval(ee4,id3)
         E00lt = Eval(ee00,id3)
         E11lt = Eval(ee11,id3)
         E12lt = Eval(ee12,id3)
         E13lt = Eval(ee13,id3)
         E14lt = Eval(ee14,id3)
         E22lt = Eval(ee22,id3)
         E23lt = Eval(ee23,id3)
         E24lt = Eval(ee24,id3)
         E33lt = Eval(ee33,id3)
         E34lt = Eval(ee34,id3)
         E44lt = Eval(ee44,id3)
      else
         id3 = EgetC(cp4s,cp3s,cp5s,cp2s,cp1s,cp3p4s,cp3p5s,cp2p5s,
     .               cp1p2s,cp1p4s,cm1s,cm2s,cm3s,cm4s,cm5s)
         E0lt  = EvalC(ee0,id3)
         E1lt  = EvalC(ee1,id3)
         E2lt  = EvalC(ee2,id3)
         E3lt  = EvalC(ee3,id3)
         E4lt  = EvalC(ee4,id3)
         E00lt = EvalC(ee00,id3)
         E11lt = EvalC(ee11,id3)
         E12lt = EvalC(ee12,id3)
         E13lt = EvalC(ee13,id3)
         E14lt = EvalC(ee14,id3)
         E22lt = EvalC(ee22,id3)
         E23lt = EvalC(ee23,id3)
         E24lt = EvalC(ee24,id3)
         E33lt = EvalC(ee33,id3)
         E34lt = EvalC(ee34,id3)
         E44lt = EvalC(ee44,id3)
      endif
      
      include 'form/pent3B1S.f'
      pent3B1S = pent3BS *  cover * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pent3B1S)
      cpentagon = cpentagon + pent3B1S

*********** CORRESPONDING WEAK PENTAGONS
      IF (iweakcorr.eq.1) THEN
*** Z
      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id3z = Eget(p4s,p3s,p5s,p2s,p1s,p3p4s,p3p5s,p2p5s,p1p2s,p1p4s,
     .              m3s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id3z)
         E1lt  = Eval(ee1,id3z)
         E2lt  = Eval(ee2,id3z)
         E3lt  = Eval(ee3,id3z)
         E4lt  = Eval(ee4,id3z)
         E00lt = Eval(ee00,id3z)
         E11lt = Eval(ee11,id3z)
         E12lt = Eval(ee12,id3z)
         E13lt = Eval(ee13,id3z)
         E14lt = Eval(ee14,id3z)
         E22lt = Eval(ee22,id3z)
         E23lt = Eval(ee23,id3z)
         E24lt = Eval(ee24,id3z)
         E33lt = Eval(ee33,id3z)
         E34lt = Eval(ee34,id3z)
         E44lt = Eval(ee44,id3z)
      else
         id3z = EgetC(cp4sw,cp3sw,cp5s,cp2sw,cp1sw,cp3p4s,cp3p5s,cp2p5s,
     .               cp1p2s,cp1p4s,cm3s,cm2sw,cm3s,cm4s,cm5sw)
         E0lt  = EvalC(ee0,id3z)
         E1lt  = EvalC(ee1,id3z)
         E2lt  = EvalC(ee2,id3z)
         E3lt  = EvalC(ee3,id3z)
         E4lt  = EvalC(ee4,id3z)
         E00lt = EvalC(ee00,id3z)
         E11lt = EvalC(ee11,id3z)
         E12lt = EvalC(ee12,id3z)
         E13lt = EvalC(ee13,id3z)
         E14lt = EvalC(ee14,id3z)
         E22lt = EvalC(ee22,id3z)
         E23lt = EvalC(ee23,id3z)
         E24lt = EvalC(ee24,id3z)
         E33lt = EvalC(ee33,id3z)
         E34lt = EvalC(ee34,id3z)
         E44lt = EvalC(ee44,id3z)
      endif
      
      include 'form/pentZ3B1S.f'
      pentZ3B1S = pent3BS * coverZ * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pentZ3B1S)
      cpentagon = cpentagon + pentZ3B1S

*** W
      if (wwonoff.lt.0.5d0) then ! Z width set to zero
         id3w = Eget(p4s,p3s,p5s,p2s,p1s,p3p4s,p3p5s,p2p5s,p1p2s,p1p4s,
     .              mws,zero,mws,mws,zero)
         E0lt  = Eval(ee0,id3w)
         E1lt  = Eval(ee1,id3w)
         E2lt  = Eval(ee2,id3w)
         E3lt  = Eval(ee3,id3w)
         E4lt  = Eval(ee4,id3w)
         E00lt = Eval(ee00,id3w)
         E11lt = Eval(ee11,id3w)
         E12lt = Eval(ee12,id3w)
         E13lt = Eval(ee13,id3w)
         E14lt = Eval(ee14,id3w)
         E22lt = Eval(ee22,id3w)
         E23lt = Eval(ee23,id3w)
         E24lt = Eval(ee24,id3w)
         E33lt = Eval(ee33,id3w)
         E34lt = Eval(ee34,id3w)
         E44lt = Eval(ee44,id3w)
      else
         id3w = EgetC(cp4sw,cp3sw,cp5s,cp2sw,cp1sw,cp3p4s,cp3p5s,cp2p5s,
     .               cp1p2s,cp1p4s,cmws,czero,cmws,cmws,czero)

         E0lt  = EvalC(ee0,id3w)
         E1lt  = EvalC(ee1,id3w)
         E2lt  = EvalC(ee2,id3w)
         E3lt  = EvalC(ee3,id3w)
         E4lt  = EvalC(ee4,id3w)
         E00lt = EvalC(ee00,id3w)
         E11lt = EvalC(ee11,id3w)
         E12lt = EvalC(ee12,id3w)
         E13lt = EvalC(ee13,id3w)
         E14lt = EvalC(ee14,id3w)
         E22lt = EvalC(ee22,id3w)
         E23lt = EvalC(ee23,id3w)
         E24lt = EvalC(ee24,id3w)
         E33lt = EvalC(ee33,id3w)
         E34lt = EvalC(ee34,id3w)
         E44lt = EvalC(ee44,id3w)
      endif
      
      include 'form/pentW3B1S.f'
      pentW3B1S = pent3BS * coverW  * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pentW3B1S)
      cpentagon = cpentagon + pentW3B1S

      ENDIF

******** END *********************************************************************************

******** START PENTAGON 2 WITH PHOTON BETWEEN PARTICLES 1 AND 3 INTERFERED WITH conjugate[BORN_1]
********                                                               AND WITH conjugate[BORN_2]
      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id2 = Eget(p3s,p4s,p5s,p2s,p1s,p3p4s,p4p5s,p2p5s,p1p2s,p1p3s,
     .              m1s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id2)
         E1lt  = Eval(ee1,id2)
         E2lt  = Eval(ee2,id2)
         E3lt  = Eval(ee3,id2)
         E4lt  = Eval(ee4,id2)
         E00lt = Eval(ee00,id2)
         E11lt = Eval(ee11,id2)
         E12lt = Eval(ee12,id2)
         E13lt = Eval(ee13,id2)
         E14lt = Eval(ee14,id2)
         E22lt = Eval(ee22,id2)
         E23lt = Eval(ee23,id2)
         E24lt = Eval(ee24,id2)
         E33lt = Eval(ee33,id2)
         E34lt = Eval(ee34,id2)
         E44lt = Eval(ee44,id2)
      else
         id2 = EgetC(cp3s,cp4s,cp5s,cp2s,cp1s,cp3p4s,cp4p5s,cp2p5s,
     .               cp1p2s,cp1p3s,cm1s,cm2s,cm3s,cm4s,cm5s)
         E0lt  = EvalC(ee0,id2)
         E1lt  = EvalC(ee1,id2)
         E2lt  = EvalC(ee2,id2)
         E3lt  = EvalC(ee3,id2)
         E4lt  = EvalC(ee4,id2)
         E00lt = EvalC(ee00,id2)
         E11lt = EvalC(ee11,id2)
         E12lt = EvalC(ee12,id2)
         E13lt = EvalC(ee13,id2)
         E14lt = EvalC(ee14,id2)
         E22lt = EvalC(ee22,id2)
         E23lt = EvalC(ee23,id2)
         E24lt = EvalC(ee24,id2)
         E33lt = EvalC(ee33,id2)
         E34lt = EvalC(ee34,id2)
         E44lt = EvalC(ee44,id2)
      endif

      include 'form/pent2B1S.f'
      pent2B1S = pent2BS * cover  * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pent2B1S)
      cpentagon = cpentagon + pent2B1S

c      print*,'QED 3 ',2.d0 * dReal(pent2B1S + pent2B2S)


*********** CORRESPONDING WEAK PENTAGONS
      IF (iweakcorr.eq.1) THEN
*** Z
      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id2z = Eget(p3s,p4s,p5s,p2s,p1s,p3p4s,p4p5s,p2p5s,p1p2s,p1p3s,
     .              m3s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id2z)
         E1lt  = Eval(ee1,id2z)
         E2lt  = Eval(ee2,id2z)
         E3lt  = Eval(ee3,id2z)
         E4lt  = Eval(ee4,id2z)
         E00lt = Eval(ee00,id2z)
         E11lt = Eval(ee11,id2z)
         E12lt = Eval(ee12,id2z)
         E13lt = Eval(ee13,id2z)
         E14lt = Eval(ee14,id2z)
         E22lt = Eval(ee22,id2z)
         E23lt = Eval(ee23,id2z)
         E24lt = Eval(ee24,id2z)
         E33lt = Eval(ee33,id2z)
         E34lt = Eval(ee34,id2z)
         E44lt = Eval(ee44,id2z)
      else
         id2z = EgetC(cp3sw,cp4sw,cp5s,cp2sw,cp1sw,cp3p4s,cp4p5s,cp2p5s,
     .               cp1p2s,cp1p3s,cm3s,cm2sw,cm3s,cm4s,cm5sw)
         E0lt  = EvalC(ee0,id2z)
         E1lt  = EvalC(ee1,id2z)
         E2lt  = EvalC(ee2,id2z)
         E3lt  = EvalC(ee3,id2z)
         E4lt  = EvalC(ee4,id2z)
         E00lt = EvalC(ee00,id2z)
         E11lt = EvalC(ee11,id2z)
         E12lt = EvalC(ee12,id2z)
         E13lt = EvalC(ee13,id2z)
         E14lt = EvalC(ee14,id2z)
         E22lt = EvalC(ee22,id2z)
         E23lt = EvalC(ee23,id2z)
         E24lt = EvalC(ee24,id2z)
         E33lt = EvalC(ee33,id2z)
         E34lt = EvalC(ee34,id2z)
         E44lt = EvalC(ee44,id2z)
      endif

      include 'form/pentZ2B1S.f'
      pentZ2B1S = pent2BS * coverZ * P12s*P34s 

      pentagon  = pentagon  + 2.d0 * dReal(pentZ2B1S)
      cpentagon = cpentagon + pentZ2B1S


*** NO W !!!

      ENDIF

******** END *********************************************************************************

******** START PENTAGON 4 WITH PHOTON BETWEEN PARTICLES 2 AND 4 INTERFERED WITH conjugate[BORN_1]
********                                                               AND WITH conjugate[BORN_2]
      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id4 = Eget(p4s,p3s,p5s,p1s,p2s,p3p4s,p3p5s,p1p5s,p1p2s,p2p4s,
     .              m1s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id4)
         E1lt  = Eval(ee1,id4)
         E2lt  = Eval(ee2,id4)
         E3lt  = Eval(ee3,id4)
         E4lt  = Eval(ee4,id4)
         E00lt = Eval(ee00,id4)
         E11lt = Eval(ee11,id4)
         E12lt = Eval(ee12,id4)
         E13lt = Eval(ee13,id4)
         E14lt = Eval(ee14,id4)
         E22lt = Eval(ee22,id4)
         E23lt = Eval(ee23,id4)
         E24lt = Eval(ee24,id4)
         E33lt = Eval(ee33,id4)
         E34lt = Eval(ee34,id4)
         E44lt = Eval(ee44,id4)
      else
         id4 = EgetC(cp4s,cp3s,cp5s,cp1s,cp2s,cp3p4s,cp3p5s,cp1p5s,
     .               cp1p2s,cp2p4s,cm1s,cm2s,cm3s,cm4s,cm5s)
         E0lt  = EvalC(ee0,id4)
         E1lt  = EvalC(ee1,id4)
         E2lt  = EvalC(ee2,id4)
         E3lt  = EvalC(ee3,id4)
         E4lt  = EvalC(ee4,id4)
         E00lt = EvalC(ee00,id4)
         E11lt = EvalC(ee11,id4)
         E12lt = EvalC(ee12,id4)
         E13lt = EvalC(ee13,id4)
         E14lt = EvalC(ee14,id4)
         E22lt = EvalC(ee22,id4)
         E23lt = EvalC(ee23,id4)
         E24lt = EvalC(ee24,id4)
         E33lt = EvalC(ee33,id4)
         E34lt = EvalC(ee34,id4)
         E44lt = EvalC(ee44,id4)
      endif

      include 'form/pent4B1S.f'
      pent4B1S = pent4BS * cover * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pent4B1S)
      cpentagon = cpentagon + pent4B1S

c      print*,'QED 4 ',2.d0 * dReal(pent4B1S + pent4B2S)


*********** CORRESPONDING WEAK PENTAGONS
      IF (iweakcorr.eq.1) THEN
*** Z
      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id4z = Eget(p4s,p3s,p5s,p1s,p2s,p3p4s,p3p5s,p1p5s,p1p2s,p2p4s,
     .              m3s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id4z)
         E1lt  = Eval(ee1,id4z)
         E2lt  = Eval(ee2,id4z)
         E3lt  = Eval(ee3,id4z)
         E4lt  = Eval(ee4,id4z)
         E00lt = Eval(ee00,id4z)
         E11lt = Eval(ee11,id4z)
         E12lt = Eval(ee12,id4z)
         E13lt = Eval(ee13,id4z)
         E14lt = Eval(ee14,id4z)
         E22lt = Eval(ee22,id4z)
         E23lt = Eval(ee23,id4z)
         E24lt = Eval(ee24,id4z)
         E33lt = Eval(ee33,id4z)
         E34lt = Eval(ee34,id4z)
         E44lt = Eval(ee44,id4z)
      else
         id4z = EgetC(cp4sw,cp3sw,cp5s,cp1sw,cp2sw,cp3p4s,cp3p5s,cp1p5s,
     .               cp1p2s,cp2p4s,cm3s,cm2sw,cm3s,cm4s,cm5sw)
         E0lt  = EvalC(ee0,id4z)
         E1lt  = EvalC(ee1,id4z)
         E2lt  = EvalC(ee2,id4z)
         E3lt  = EvalC(ee3,id4z)
         E4lt  = EvalC(ee4,id4z)
         E00lt = EvalC(ee00,id4z)
         E11lt = EvalC(ee11,id4z)
         E12lt = EvalC(ee12,id4z)
         E13lt = EvalC(ee13,id4z)
         E14lt = EvalC(ee14,id4z)
         E22lt = EvalC(ee22,id4z)
         E23lt = EvalC(ee23,id4z)
         E24lt = EvalC(ee24,id4z)
         E33lt = EvalC(ee33,id4z)
         E34lt = EvalC(ee34,id4z)
         E44lt = EvalC(ee44,id4z)
      endif

      include 'form/pentZ4B1S.f'
      pentZ4B1S = pent4BS * coverZ * P12s*P34s 

      pentagon  = pentagon  + 2.d0 * dReal(pentZ4B1S)
      cpentagon = cpentagon + pentZ4B1S

******** NO W
      ENDIF

******** END *********************************************************************************      

*** >>  returning if final state is e+e-mu+mu-
      if (idpart.eq.0) return
*** <<

*#######################################################################
** 4 other terms by symmetry [p2 <-> p4]

******** START PENTAGON 5 WITH PHOTON BETWEEN PARTICLES 3 AND 4 INTERFERED WITH conjugate[BORN_1]
********                                                               AND WITH conjugate[BORN_2]
      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id5 = Eget(p3s,p2s,p5s,p1s,p4s,p2p3s,p2p5s,p1p5s,p1p4s,p3p4s,
     .              m1s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id5)
         E1lt  = Eval(ee1,id5)
         E2lt  = Eval(ee2,id5)
         E3lt  = Eval(ee3,id5)
         E4lt  = Eval(ee4,id5)
         E00lt = Eval(ee00,id5)
         E11lt = Eval(ee11,id5)
         E12lt = Eval(ee12,id5)
         E13lt = Eval(ee13,id5)
         E14lt = Eval(ee14,id5)
         E22lt = Eval(ee22,id5)
         E23lt = Eval(ee23,id5)
         E24lt = Eval(ee24,id5)
         E33lt = Eval(ee33,id5)
         E34lt = Eval(ee34,id5)
         E44lt = Eval(ee44,id5)
      else
         id5 = EgetC(cp3s,cp2s,cp5s,cp1s,cp4s,cp2p3s,cp2p5s,cp1p5s,
     .               cp1p4s,cp3p4s,cm1s,cm2s,cm3s,cm4s,cm5s)
         E0lt  = EvalC(ee0,id5)
         E1lt  = EvalC(ee1,id5)
         E2lt  = EvalC(ee2,id5)
         E3lt  = EvalC(ee3,id5)
         E4lt  = EvalC(ee4,id5)
         E00lt = EvalC(ee00,id5)
         E11lt = EvalC(ee11,id5)
         E12lt = EvalC(ee12,id5)
         E13lt = EvalC(ee13,id5)
         E14lt = EvalC(ee14,id5)
         E22lt = EvalC(ee22,id5)
         E23lt = EvalC(ee23,id5)
         E24lt = EvalC(ee24,id5)
         E33lt = EvalC(ee33,id5)
         E34lt = EvalC(ee34,id5)
         E44lt = EvalC(ee44,id5)
      endif

      include 'form/pent5B1S.f'
      pent5B1S = pent5BS * cover * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pent5B1S)
      cpentagon = cpentagon + pent5B1S

*********** CORRESPONDING WEAK PENTAGONS

      IF (iweakcorr.eq.1) THEN

      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id5z = Eget(p3s,p2s,p5s,p1s,p4s,p2p3s,p2p5s,p1p5s,p1p4s,p3p4s,
     .              m3s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id5z)
         E1lt  = Eval(ee1,id5z)
         E2lt  = Eval(ee2,id5z)
         E3lt  = Eval(ee3,id5z)
         E4lt  = Eval(ee4,id5z)
         E00lt = Eval(ee00,id5z)
         E11lt = Eval(ee11,id5z)
         E12lt = Eval(ee12,id5z)
         E13lt = Eval(ee13,id5z)
         E14lt = Eval(ee14,id5z)
         E22lt = Eval(ee22,id5z)
         E23lt = Eval(ee23,id5z)
         E24lt = Eval(ee24,id5z)
         E33lt = Eval(ee33,id5z)
         E34lt = Eval(ee34,id5z)
         E44lt = Eval(ee44,id5z)
      else
         id5z = EgetC(cp3sw,cp2sw,cp5s,cp1sw,cp4sw,cp2p3s,cp2p5s,cp1p5s,
     .               cp1p4s,cp3p4s,cm3s,cm2sw,cm3s,cm4s,cm5sw)
         E0lt  = EvalC(ee0,id5z)
         E1lt  = EvalC(ee1,id5z)
         E2lt  = EvalC(ee2,id5z)
         E3lt  = EvalC(ee3,id5z)
         E4lt  = EvalC(ee4,id5z)
         E00lt = EvalC(ee00,id5z)
         E11lt = EvalC(ee11,id5z)
         E12lt = EvalC(ee12,id5z)
         E13lt = EvalC(ee13,id5z)
         E14lt = EvalC(ee14,id5z)
         E22lt = EvalC(ee22,id5z)
         E23lt = EvalC(ee23,id5z)
         E24lt = EvalC(ee24,id5z)
         E33lt = EvalC(ee33,id5z)
         E34lt = EvalC(ee34,id5z)
         E44lt = EvalC(ee44,id5z)
      endif

      include 'form/pentZ5B1S.f'
      pentZ5B1S = pent5BS * coverZ * P12s*P34s 

      pentagon  = pentagon  + 2.d0 * dReal(pentZ5B1S)
      cpentagon = cpentagon + pentZ5B1S

***** W 
      if (wwonoff.lt.0.5d0) then ! Z width set to zero
         id5w = Eget(p3s,p2s,p5s,p1s,p4s,p2p3s,p2p5s,p1p5s,p1p4s,p3p4s,
     .              mws,zero,mws,mws,zero)
         E0lt  = Eval(ee0,id5w)
         E1lt  = Eval(ee1,id5w)
         E2lt  = Eval(ee2,id5w)
         E3lt  = Eval(ee3,id5w)
         E4lt  = Eval(ee4,id5w)
         E00lt = Eval(ee00,id5w)
         E11lt = Eval(ee11,id5w)
         E12lt = Eval(ee12,id5w)
         E13lt = Eval(ee13,id5w)
         E14lt = Eval(ee14,id5w)
         E22lt = Eval(ee22,id5w)
         E23lt = Eval(ee23,id5w)
         E24lt = Eval(ee24,id5w)
         E33lt = Eval(ee33,id5w)
         E34lt = Eval(ee34,id5w)
         E44lt = Eval(ee44,id5w)
      else
         id5w = EgetC(cp3sw,cp2sw,cp5s,cp1sw,cp4sw,cp2p3s,cp2p5s,cp1p5s,
     .               cp1p4s,cp3p4s,cmws,czero,cmws,cmws,czero)
         E0lt  = EvalC(ee0,id5w)
         E1lt  = EvalC(ee1,id5w)
         E2lt  = EvalC(ee2,id5w)
         E3lt  = EvalC(ee3,id5w)
         E4lt  = EvalC(ee4,id5w)
         E00lt = EvalC(ee00,id5w)
         E11lt = EvalC(ee11,id5w)
         E12lt = EvalC(ee12,id5w)
         E13lt = EvalC(ee13,id5w)
         E14lt = EvalC(ee14,id5w)
         E22lt = EvalC(ee22,id5w)
         E23lt = EvalC(ee23,id5w)
         E24lt = EvalC(ee24,id5w)
         E33lt = EvalC(ee33,id5w)
         E34lt = EvalC(ee34,id5w)
         E44lt = EvalC(ee44,id5w)
      endif

      include 'form/pentW5B1S.f'
      pentW5B1S = pent5BS * coverW * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pentW5B1S)
      cpentagon = cpentagon + pentW5B1S

      ENDIF

******** END *********************************************************************************

******** START PENTAGON 7 WITH PHOTON BETWEEN PARTICLES 1 AND 2 INTERFERED WITH conjugate[BORN_1]
********                                                               AND WITH conjugate[BORN_2]
      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id7 = Eget(p2s,p3s,p5s,p4s,p1s,p2p3s,p3p5s,p4p5s,p1p4s,p1p2s,
     .              m1s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id7)
         E1lt  = Eval(ee1,id7)
         E2lt  = Eval(ee2,id7)
         E3lt  = Eval(ee3,id7)
         E4lt  = Eval(ee4,id7)
         E00lt = Eval(ee00,id7)
         E11lt = Eval(ee11,id7)
         E12lt = Eval(ee12,id7)
         E13lt = Eval(ee13,id7)
         E14lt = Eval(ee14,id7)
         E22lt = Eval(ee22,id7)
         E23lt = Eval(ee23,id7)
         E24lt = Eval(ee24,id7)
         E33lt = Eval(ee33,id7)
         E34lt = Eval(ee34,id7)
         E44lt = Eval(ee44,id7)
      else
         id7 = EgetC(cp2s,cp3s,cp5s,cp4s,cp1s,cp2p3s,cp3p5s,cp4p5s,
     .               cp1p4s,cp1p2s,cm1s,cm2s,cm3s,cm4s,cm5s)
         E0lt  = EvalC(ee0,id7)
         E1lt  = EvalC(ee1,id7)
         E2lt  = EvalC(ee2,id7)
         E3lt  = EvalC(ee3,id7)
         E4lt  = EvalC(ee4,id7)
         E00lt = EvalC(ee00,id7)
         E11lt = EvalC(ee11,id7)
         E12lt = EvalC(ee12,id7)
         E13lt = EvalC(ee13,id7)
         E14lt = EvalC(ee14,id7)
         E22lt = EvalC(ee22,id7)
         E23lt = EvalC(ee23,id7)
         E24lt = EvalC(ee24,id7)
         E33lt = EvalC(ee33,id7)
         E34lt = EvalC(ee34,id7)
         E44lt = EvalC(ee44,id7)
      endif

      include 'form/pent7B1S.f'
      pent7B1S = pent7BS * cover * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pent7B1S)
      cpentagon = cpentagon + pent7B1S

*********** CORRESPONDING WEAK PENTAGONS

      IF (iweakcorr.eq.1) THEN

      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id7z = Eget(p2s,p3s,p5s,p4s,p1s,p2p3s,p3p5s,p4p5s,p1p4s,p1p2s,
     .              m3s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id7z)
         E1lt  = Eval(ee1,id7z)
         E2lt  = Eval(ee2,id7z)
         E3lt  = Eval(ee3,id7z)
         E4lt  = Eval(ee4,id7z)
         E00lt = Eval(ee00,id7z)
         E11lt = Eval(ee11,id7z)
         E12lt = Eval(ee12,id7z)
         E13lt = Eval(ee13,id7z)
         E14lt = Eval(ee14,id7z)
         E22lt = Eval(ee22,id7z)
         E23lt = Eval(ee23,id7z)
         E24lt = Eval(ee24,id7z)
         E33lt = Eval(ee33,id7z)
         E34lt = Eval(ee34,id7z)
         E44lt = Eval(ee44,id7z)
      else
         id7z = EgetC(cp2sw,cp3sw,cp5s,cp4sw,cp1sw,cp2p3s,cp3p5s,cp4p5s,
     .               cp1p4s,cp1p2s,cm3s,cm2sw,cm3s,cm4s,cm5sw)
         E0lt  = EvalC(ee0,id7z)
         E1lt  = EvalC(ee1,id7z)
         E2lt  = EvalC(ee2,id7z)
         E3lt  = EvalC(ee3,id7z)
         E4lt  = EvalC(ee4,id7z)
         E00lt = EvalC(ee00,id7z)
         E11lt = EvalC(ee11,id7z)
         E12lt = EvalC(ee12,id7z)
         E13lt = EvalC(ee13,id7z)
         E14lt = EvalC(ee14,id7z)
         E22lt = EvalC(ee22,id7z)
         E23lt = EvalC(ee23,id7z)
         E24lt = EvalC(ee24,id7z)
         E33lt = EvalC(ee33,id7z)
         E34lt = EvalC(ee34,id7z)
         E44lt = EvalC(ee44,id7z)
      endif

      include 'form/pentZ7B1S.f'
      pentZ7B1S = pent7BS * coverZ * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pentZ7B1S)
      cpentagon = cpentagon + pentZ7B1S

******** W

      if (wwonoff.lt.0.5d0) then ! Z width set to zero
         id7w = Eget(p2s,p3s,p5s,p4s,p1s,p2p3s,p3p5s,p4p5s,p1p4s,p1p2s,
     .              mws,zero,mws,mws,zero)
         E0lt  = Eval(ee0,id7w)
         E1lt  = Eval(ee1,id7w)
         E2lt  = Eval(ee2,id7w)
         E3lt  = Eval(ee3,id7w)
         E4lt  = Eval(ee4,id7w)
         E00lt = Eval(ee00,id7w)
         E11lt = Eval(ee11,id7w)
         E12lt = Eval(ee12,id7w)
         E13lt = Eval(ee13,id7w)
         E14lt = Eval(ee14,id7w)
         E22lt = Eval(ee22,id7w)
         E23lt = Eval(ee23,id7w)
         E24lt = Eval(ee24,id7w)
         E33lt = Eval(ee33,id7w)
         E34lt = Eval(ee34,id7w)
         E44lt = Eval(ee44,id7w)
      else
         id7w = EgetC(cp2sw,cp3sw,cp5s,cp4sw,cp1sw,cp2p3s,cp3p5s,cp4p5s,
     .               cp1p4s,cp1p2s,cmws,czero,cmws,cmws,czero)
         E0lt  = EvalC(ee0,id7w)
         E1lt  = EvalC(ee1,id7w)
         E2lt  = EvalC(ee2,id7w)
         E3lt  = EvalC(ee3,id7w)
         E4lt  = EvalC(ee4,id7w)
         E00lt = EvalC(ee00,id7w)
         E11lt = EvalC(ee11,id7w)
         E12lt = EvalC(ee12,id7w)
         E13lt = EvalC(ee13,id7w)
         E14lt = EvalC(ee14,id7w)
         E22lt = EvalC(ee22,id7w)
         E23lt = EvalC(ee23,id7w)
         E24lt = EvalC(ee24,id7w)
         E33lt = EvalC(ee33,id7w)
         E34lt = EvalC(ee34,id7w)
         E44lt = EvalC(ee44,id7w)
      endif

      include 'form/pentW7B1S.f'
      pentW7B1S = pent7BS * coverW * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pentW7B1S)
      cpentagon = cpentagon + pentW7B1S

      ENDIF

******** END *********************************************************************************
c      return
******** START PENTAGON 6 WITH PHOTON BETWEEN PARTICLES 1 AND 3 INTERFERED WITH conjugate[BORN_1]
********                                                               AND WITH conjugate[BORN_2]
      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id6 = Eget(p3s,p2s,p5s,p4s,p1s,p2p3s,p2p5s,p4p5s,p1p4s,p1p3s,
     .              m1s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id6)
         E1lt  = Eval(ee1,id6)
         E2lt  = Eval(ee2,id6)
         E3lt  = Eval(ee3,id6)
         E4lt  = Eval(ee4,id6)
         E00lt = Eval(ee00,id6)
         E11lt = Eval(ee11,id6)
         E12lt = Eval(ee12,id6)
         E13lt = Eval(ee13,id6)
         E14lt = Eval(ee14,id6)
         E22lt = Eval(ee22,id6)
         E23lt = Eval(ee23,id6)
         E24lt = Eval(ee24,id6)
         E33lt = Eval(ee33,id6)
         E34lt = Eval(ee34,id6)
         E44lt = Eval(ee44,id6)
      else
         id6 = EgetC(cp3s,cp2s,cp5s,cp4s,cp1s,cp2p3s,cp2p5s,cp4p5s,
     .               cp1p4s,cp1p3s,cm1s,cm2s,cm3s,cm4s,cm5s)
         E0lt  = EvalC(ee0,id6)
         E1lt  = EvalC(ee1,id6)
         E2lt  = EvalC(ee2,id6)
         E3lt  = EvalC(ee3,id6)
         E4lt  = EvalC(ee4,id6)
         E00lt = EvalC(ee00,id6)
         E11lt = EvalC(ee11,id6)
         E12lt = EvalC(ee12,id6)
         E13lt = EvalC(ee13,id6)
         E14lt = EvalC(ee14,id6)
         E22lt = EvalC(ee22,id6)
         E23lt = EvalC(ee23,id6)
         E24lt = EvalC(ee24,id6)
         E33lt = EvalC(ee33,id6)
         E34lt = EvalC(ee34,id6)
         E44lt = EvalC(ee44,id6)
      endif

      include 'form/pent6B1S.f'
      pent6B1S = pent6BS * cover * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pent6B1S)
      cpentagon = cpentagon + pent6B1S

*********** CORRESPONDING WEAK PENTAGONS
      IF (iweakcorr.eq.1) THEN

      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id6z = Eget(p3s,p2s,p5s,p4s,p1s,p2p3s,p2p5s,p4p5s,p1p4s,p1p3s,
     .              m3s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id6z)
         E1lt  = Eval(ee1,id6z)
         E2lt  = Eval(ee2,id6z)
         E3lt  = Eval(ee3,id6z)
         E4lt  = Eval(ee4,id6z)
         E00lt = Eval(ee00,id6z)
         E11lt = Eval(ee11,id6z)
         E12lt = Eval(ee12,id6z)
         E13lt = Eval(ee13,id6z)
         E14lt = Eval(ee14,id6z)
         E22lt = Eval(ee22,id6z)
         E23lt = Eval(ee23,id6z)
         E24lt = Eval(ee24,id6z)
         E33lt = Eval(ee33,id6z)
         E34lt = Eval(ee34,id6z)
         E44lt = Eval(ee44,id6z)
      else
         id6z = EgetC(cp3sw,cp2sw,cp5s,cp4sw,cp1sw,cp2p3s,cp2p5s,cp4p5s,
     .               cp1p4s,cp1p3s,cm3s,cm2sw,cm3s,cm4s,cm5sw)
         E0lt  = EvalC(ee0,id6z)
         E1lt  = EvalC(ee1,id6z)
         E2lt  = EvalC(ee2,id6z)
         E3lt  = EvalC(ee3,id6z)
         E4lt  = EvalC(ee4,id6z)
         E00lt = EvalC(ee00,id6z)
         E11lt = EvalC(ee11,id6z)
         E12lt = EvalC(ee12,id6z)
         E13lt = EvalC(ee13,id6z)
         E14lt = EvalC(ee14,id6z)
         E22lt = EvalC(ee22,id6z)
         E23lt = EvalC(ee23,id6z)
         E24lt = EvalC(ee24,id6z)
         E33lt = EvalC(ee33,id6z)
         E34lt = EvalC(ee34,id6z)
         E44lt = EvalC(ee44,id6z)
      endif

      include 'form/pentZ6B1S.f'
      pentZ6B1S = pent6BS * coverZ * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pentZ6B1S)
      cpentagon = cpentagon + pentZ6B1S

      ENDIF

******** END *********************************************************************************

******** START PENTAGON 8 WITH PHOTON BETWEEN PARTICLES 2 AND 4 INTERFERED WITH conjugate[BORN_1]
********                                                               AND WITH conjugate[BORN_2]
      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id8 = Eget(p2s,p3s,p5s,p1s,p4s,p2p3s,p3p5s,p1p5s,p1p4s,p2p4s,
     .              m1s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id8)
         E1lt  = Eval(ee1,id8)
         E2lt  = Eval(ee2,id8)
         E3lt  = Eval(ee3,id8)
         E4lt  = Eval(ee4,id8)
         E00lt = Eval(ee00,id8)
         E11lt = Eval(ee11,id8)
         E12lt = Eval(ee12,id8)
         E13lt = Eval(ee13,id8)
         E14lt = Eval(ee14,id8)
         E22lt = Eval(ee22,id8)
         E23lt = Eval(ee23,id8)
         E24lt = Eval(ee24,id8)
         E33lt = Eval(ee33,id8)
         E34lt = Eval(ee34,id8)
         E44lt = Eval(ee44,id8)
      else
         id8 = EgetC(cp2s,cp3s,cp5s,cp1s,cp4s,cp2p3s,cp3p5s,cp1p5s,
     .               cp1p4s,cp2p4s,cm1s,cm2s,cm3s,cm4s,cm5s)
         E0lt  = EvalC(ee0,id8)
         E1lt  = EvalC(ee1,id8)
         E2lt  = EvalC(ee2,id8)
         E3lt  = EvalC(ee3,id8)
         E4lt  = EvalC(ee4,id8)
         E00lt = EvalC(ee00,id8)
         E11lt = EvalC(ee11,id8)
         E12lt = EvalC(ee12,id8)
         E13lt = EvalC(ee13,id8)
         E14lt = EvalC(ee14,id8)
         E22lt = EvalC(ee22,id8)
         E23lt = EvalC(ee23,id8)
         E24lt = EvalC(ee24,id8)
         E33lt = EvalC(ee33,id8)
         E34lt = EvalC(ee34,id8)
         E44lt = EvalC(ee44,id8)
      endif

      include 'form/pent8B1S.f'
      pent8B1S = pent8BS * cover * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pent8B1S)
      cpentagon = cpentagon + pent8B1S

*********** CORRESPONDING WEAK PENTAGONS
      IF (iweakcorr.eq.1) THEN

      if (zwonoff.lt.0.5d0) then ! Z width set to zero
         id8z = Eget(p2s,p3s,p5s,p1s,p4s,p2p3s,p3p5s,p1p5s,p1p4s,p2p4s,
     .              m3s,m2s,m3s,m4s,m5s)
         E0lt  = Eval(ee0,id8z)
         E1lt  = Eval(ee1,id8z)
         E2lt  = Eval(ee2,id8z)
         E3lt  = Eval(ee3,id8z)
         E4lt  = Eval(ee4,id8z)
         E00lt = Eval(ee00,id8z)
         E11lt = Eval(ee11,id8z)
         E12lt = Eval(ee12,id8z)
         E13lt = Eval(ee13,id8z)
         E14lt = Eval(ee14,id8z)
         E22lt = Eval(ee22,id8z)
         E23lt = Eval(ee23,id8z)
         E24lt = Eval(ee24,id8z)
         E33lt = Eval(ee33,id8z)
         E34lt = Eval(ee34,id8z)
         E44lt = Eval(ee44,id8z)
      else
         id8z = EgetC(cp2sw,cp3sw,cp5s,cp1sw,cp4sw,cp2p3s,cp3p5s,cp1p5s,
     .               cp1p4s,cp2p4s,cm3s,cm2sw,cm3s,cm4s,cm5sw)
         E0lt  = EvalC(ee0,id8z)
         E1lt  = EvalC(ee1,id8z)
         E2lt  = EvalC(ee2,id8z)
         E3lt  = EvalC(ee3,id8z)
         E4lt  = EvalC(ee4,id8z)
         E00lt = EvalC(ee00,id8z)
         E11lt = EvalC(ee11,id8z)
         E12lt = EvalC(ee12,id8z)
         E13lt = EvalC(ee13,id8z)
         E14lt = EvalC(ee14,id8z)
         E22lt = EvalC(ee22,id8z)
         E23lt = EvalC(ee23,id8z)
         E24lt = EvalC(ee24,id8z)
         E33lt = EvalC(ee33,id8z)
         E34lt = EvalC(ee34,id8z)
         E44lt = EvalC(ee44,id8z)
      endif

      include 'form/pentZ8B1S.f'
      pentZ8B1S = pent8BS * coverZ * P12s*P34s

      pentagon  = pentagon  + 2.d0 * dReal(pentZ8B1S)
      cpentagon = cpentagon + pentZ8B1S

**** no W

      ENDIF
******** END *********************************************************************************
      return
      end
