      subroutine debugvertexes

      double complex vert1B1S,vert2B1S,vert3B1S,vert4B1S
      double complex vert1B2S,vert2B2S,vert3B2S,vert4B2S

      double complex vertZ1B1S,vertZ2B1S,vertZ3B1S,vertZ4B1S
      double complex vertZ1B2S,vertZ2B2S,vertZ3B2S,vertZ4B2S

      double complex vertW1B1S,vertW2B1S,vertW3B1S,vertW4B1S
      double complex vertW1B2S,vertW2B2S,vertW3B2S,vertW4B2S

      double complex vertNA1B1S,vertNA2B1S,vertNA3B1S,vertNA4B1S
      double complex vertNA1B2S,vertNA2B2S,vertNA3B2S,vertNA4B2S

      common/vertexresults/vert1B1S,vert2B1S,vert3B1S,vert4B1S,
     .                     vert1B2S,vert2B2S,vert3B2S,vert4B2S,
     .                     vertZ1B1S,vertZ2B1S,vertZ3B1S,vertZ4B1S,
     .                     vertZ1B2S,vertZ2B2S,vertZ3B2S,vertZ4B2S,
     .                     vertW1B1S,vertW2B1S,vertW3B1S,vertW4B1S,
     .                     vertW1B2S,vertW2B2S,vertW3B2S,vertW4B2S,
     .                     vertNA1B1S,vertNA2B1S,vertNA3B1S,vertNA4B1S,
     .                     vertNA1B2S,vertNA2B2S,vertNA3B2S,vertNA4B2S

      double complex vZ,vW,vNA
      common/vertexdebug/vZ,vW,vNA

      print*,'  1',vert1B1S
      print*,'  2',vert2B1S
      print*,'  3',vert3B1S
      print*,'  4',vert4B1S
      print*,'  5',vert1B2S
      print*,'  6',vert2B2S
      print*,'  7',vert3B2S
      print*,'  8',vert4B2S

      print*,'  9',vertZ1B1S
      print*,' 10',vertZ2B1S
      print*,' 11',vertZ3B1S
      print*,' 12',vertZ4B1S
      print*,' 13',vertZ1B2S
      print*,' 14',vertZ2B2S
      print*,' 15',vertZ3B2S
      print*,' 16',vertZ4B2S
      
      print*,' 17',vertW1B1S
      print*,' 18',vertW2B1S
      print*,' 19',vertW3B1S
      print*,' 20',vertW4B1S
      print*,' 21',vertW1B2S
      print*,' 22',vertW2B2S
      print*,' 23',vertW3B2S
      print*,' 24',vertW4B2S

      print*,' 25',vertNA1B1S
      print*,' 26',vertNA2B1S
      print*,' 27',vertNA3B1S
      print*,' 28',vertNA4B1S
      print*,' 29',vertNA1B2S
      print*,' 30',vertNA2B2S
      print*,' 31',vertNA3B2S
      print*,' 32',vertNA4B2S
      
      return
      end
****************************************************
      subroutine get_vertexes(vertexout)
c      implicit none
      implicit double complex (Z)

      double precision vertexout
      double complex   vertex,vertextmp
      double complex   cvertex
      double complex   vert1BS,vert2BS,vert3BS,vert4BS

      integer          i,id,ifirst,iret,idpart
      integer*8          id1,id2,id3,id4
      integer*8          id1Z,id2Z,id3Z,id4Z
      integer*8          id1W,id2W,id3W,id4W
      integer*8          id1NA,id2NA,id3NA,id4NA
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3),p5(0:3),ptmp(0:3)
      double precision k1(0:3),k2(0:3),k3(0:3),k4(0:3),k5(0:3)
      double complex   C0lt,C1lt,C2lt,C00lt,C11lt,C12lt,C22lt
      double precision m1s, m2s, m3s,mzs
      double complex   cm1s, cm2s, cm3s
      double complex   P123412s34s,P142314s23s,P12s34s1423,P123414s23s,
     .                 P142312s34s
      double precision p3s, p4s, p1s, p2s

      double complex cp3s, cp4s, cp1s, cp2s
      double complex cp1p2s, cp1p3s, cp1p4s
      double complex cp2p3s, cp2p4s
      double complex cp3p4s
      double complex cp2p1s, cp3p1s, cp4p1s
      double complex cp3p2s, cp4p2s
      double complex cp4p3s

      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed

      double complex   cover,coverZ,coverW,coverNA
      common/commonforvert/cover,coverZ,coverW,coverNA,
     .                     me2,mm2,me4,mm4,ifirst
      data ifirst /1/

      double complex vert1B1S,vert2B1S,vert3B1S,vert4B1S
      double complex vert1B2S,vert2B2S,vert3B2S,vert4B2S

      double complex vertZ1B1S,vertZ2B1S,vertZ3B1S,vertZ4B1S
      double complex vertZ1B2S,vertZ2B2S,vertZ3B2S,vertZ4B2S

      double complex vertW1B1S,vertW2B1S,vertW3B1S,vertW4B1S
      double complex vertW1B2S,vertW2B2S,vertW3B2S,vertW4B2S

      double complex vertNA1B1S,vertNA2B1S,vertNA3B1S,vertNA4B1S
      double complex vertNA1B2S,vertNA2B2S,vertNA3B2S,vertNA4B2S

      common/vertexresults/vert1B1S,vert2B1S,vert3B1S,vert4B1S,
     .                     vert1B2S,vert2B2S,vert3B2S,vert4B2S,
     .                     vertZ1B1S,vertZ2B1S,vertZ3B1S,vertZ4B1S,
     .                     vertZ1B2S,vertZ2B2S,vertZ3B2S,vertZ4B2S,
     .                     vertW1B1S,vertW2B1S,vertW3B1S,vertW4B1S,
     .                     vertW1B2S,vertW2B2S,vertW3B2S,vertW4B2S,
     .                     vertNA1B1S,vertNA2B1S,vertNA3B1S,vertNA4B1S,
     .                     vertNA1B2S,vertNA2B2S,vertNA3B2S,vertNA4B2S

      double complex vZ,vW,vNA
      common/vertexdebug/vZ,vW,vNA

      common/vertargs/m1s, m2s, m3s, p1s, p2s, p3s, p4s

#include "invariants.h"

**** external parameters
      integer imode
      common/imode/imode
      common/identicalparticles/idpart
      double precision me2,mm2,me4,mm4
      double precision mass(5)
      common/amasses/mass ! common used also to force pXs = m^2
***
      double precision dot
      double complex epsfun
      external dot,epsfun

#include "couplingandmasses.h"

#include "looptools.h"
      
      if (ifirst.eq.1) then

         cover = -(64.d0,0.d0)/16.d0/pi2
     .           * g*conjg(g) 
     .           * g*conjg(g) 
     .           * CHZZ*conjg(CHZZ)         
     .           * elc2 * im

         cover = cover * rescaleQED

         coverZ = (64.d0,0.d0)/16.d0/pi2
     .           * g*conjg(g) 
     .           * g*conjg(g) 
     .           * CHZZ*conjg(CHZZ)         
     .           * g * g * im

         coverW = (64.d0,0.d0)/16.d0/pi2
     .           * g*conjg(g) 
     .           * g*conjg(g)
     .           * CHZZ*conjg(CHZZ)         
     .           * g * g * im

         coverNA = (64.d0,0.d0)/16.d0/pi2
     .           * g * conjg(g)
     .           * g * conjg(g)
     .           * CZWW * conjg(CHZZ) * im
     .           * CHZZ * g


c         do i = 1,10
c            print*,'RESTORE COVER IN VERTEXES!'
c         enddo
c         cover = czero
c         coverZ = czero
c         coverW = czero
c         coverNA = czero

         vert1B1S = (0.d0,0.d0)
         vert2B1S = (0.d0,0.d0)
         vert3B1S = (0.d0,0.d0)
         vert4B1S = (0.d0,0.d0)
         vert1B2S = (0.d0,0.d0)
         vert2B2S = (0.d0,0.d0)
         vert3B2S = (0.d0,0.d0)
         vert4B2S = (0.d0,0.d0)

         vertZ1B1S = (0.d0,0.d0)
         vertZ2B1S = (0.d0,0.d0)
         vertZ3B1S = (0.d0,0.d0)
         vertZ4B1S = (0.d0,0.d0)
         vertZ1B2S = (0.d0,0.d0)
         vertZ2B2S = (0.d0,0.d0)
         vertZ3B2S = (0.d0,0.d0)
         vertZ4B2S = (0.d0,0.d0)

         vertW1B1S = (0.d0,0.d0)
         vertW2B1S = (0.d0,0.d0)
         vertW3B1S = (0.d0,0.d0)
         vertW4B1S = (0.d0,0.d0)
         vertW1B2S = (0.d0,0.d0)
         vertW2B2S = (0.d0,0.d0)
         vertW3B2S = (0.d0,0.d0)
         vertW4B2S = (0.d0,0.d0)

         vertNA1B1S = (0.d0,0.d0)
         vertNA2B1S = (0.d0,0.d0)
         vertNA3B1S = (0.d0,0.d0)
         vertNA4B1S = (0.d0,0.d0)
         vertNA1B2S = (0.d0,0.d0)
         vertNA2B2S = (0.d0,0.d0)
         vertNA3B2S = (0.d0,0.d0)
         vertNA4B2S = (0.d0,0.d0)


c         do i = 1,10
c            print*,'RESTORE MASSES IN VERTEXES!'
c         enddo
         me2 = mass(1)*mass(1) !* 0.d0
         mm2 = mass(3)*mass(3) !* 0.d0
         me4 = me2*me2
         mm4 = me2*mm2

         ifirst = 0
      endif

****  ARGUMENTS FOR Cget... calculated here once for all
********************************************
*!!! WARNING: LT wants incoming momenta !!!*
********************************************

      cp1p2s = cone * p1p2s
      cp1p4s = cone * p1p4s
      cp2p3s = cone * p2p3s
      cp3p4s = cone * p3p4s

      P123412s34s = P12*P34*conjg(P12*P34)
      P142314s23s = P14*P23*conjg(P14*P23)
      P12s34s1423 = conjg(P12*P34)*P14*P23
      P123414s23s = P12*P34*conjg(P14*P23)
      P142312s34s = P14*P23*conjg(P12*P34)


      vertexout = 0.d0
      cvertex   = (0.d0,0.d0)
      vertex    = (0.d0,0.d0)
**********************************************************************************************
******** START VERTEX 1 INTERFERED WITH conjugate[BORN_1 + BORN_2]

      p1s  = mass(1)*mass(1)
      p2s  = p1s
      cp1s = cone * p1s * kfm
      cp2s = cone * p2s * kfm

      m1s = 0.d0 ! mass(5)*mass(5)
      m2s = mass(1)*mass(1)
      m3s = mass(1)*mass(1)
      cm1s = cone*m1s
      cm2s = cone*m2s * kfm
      cm3s = cone*m3s * kfm

      id1   = Cget(p1s,p1p2s,p2s,m1s,m2s,m3s)
      C0lt  = Cval(cc0,id1)
      C1lt  = Cval(cc1,id1)
      C2lt  = Cval(cc2,id1)
      C00lt = Cval(cc00,id1)
      C11lt = Cval(cc11,id1)
      C12lt = Cval(cc12,id1)
      C22lt = Cval(cc22,id1)

      include 'form/vert1B1S.f'
      vert1B1S = vertex * cover * P123412s34s

      vertexout = vertexout + 2.d0 * dReal(vert1B1S)
      cvertex   = cvertex + vert1B1S

      IF (iweakcorr.eq.1) THEN
** Z
      id1Z = CgetC(cp1s,cp1p2s,cp2s,mz2,cm2s,cm3s)
      C0lt  = CvalC(cc0,id1Z)
      C1lt  = CvalC(cc1,id1Z)
      C2lt  = CvalC(cc2,id1Z)
      C00lt = CvalC(cc00,id1Z)
      C11lt = CvalC(cc11,id1Z)
      C12lt = CvalC(cc12,id1Z)
      C22lt = CvalC(cc22,id1Z)

      include 'form/vertZ1B1S.f'
      vertZ1B1S = vertex * coverZ * P123412s34s

      vertexout = vertexout + 2.d0 * dReal(vertZ1B1S)
      cvertex   = cvertex + vertZ1B1S
** W
      id1W  = CgetC(cp1s,cp1p2s,cp2s,mw2,czero,czero)
      C0lt  = CvalC(cc0,id1W)
      C1lt  = CvalC(cc1,id1W)
      C2lt  = CvalC(cc2,id1W)
      C00lt = CvalC(cc00,id1W)
      C11lt = CvalC(cc11,id1W)
      C12lt = CvalC(cc12,id1W)
      C22lt = CvalC(cc22,id1W)

      include 'form/vertW1B1S.f'
      vertW1B1S = vertex * coverW * P123412s34s

      vertexout = vertexout + 2.d0 * dReal(vertW1B1S)
      cvertex   = cvertex + vertW1B1S + vertW1B2S

** NA
      id1NA = CgetC(cp1s,cp1p2s,cp2s,czero,mw2,mw2)
      C0lt  = CvalC(cc0,id1NA)
      C1lt  = CvalC(cc1,id1NA)
      C2lt  = CvalC(cc2,id1NA)
      C00lt = CvalC(cc00,id1NA)
      C11lt = CvalC(cc11,id1NA)
      C12lt = CvalC(cc12,id1NA)
      C22lt = CvalC(cc22,id1NA)

      include 'form/vertNA1B1S.f'
      vertNA1B1S = vertex * coverNA * P123412s34s

      vertexout = vertexout + 2.d0 * dReal(vertNA1B1S)
      cvertex   = cvertex + vertNA1B1S + vertNA1B2S

      ENDIF

******** END *********************************************************************************

**********************************************************************************************
******** START VERTEX 3 INTERFERED WITH conjugate[BORN_1 + BORN_2]
      p1s = mass(3)*mass(3)
      p2s = p1s
      cp1s = cone * p1s * kfm
      cp2s = cone * p2s * kfm

      m1s = 0.d0 ! mass(5)*mass(5)
      m2s = mass(3)*mass(3)
      m3s = mass(3)*mass(3)
      cm1s = cone * m1s
      cm2s = cone * m2s * kfm
      cm3s = cone * m3s * kfm

      id2 = Cget(p1s,p3p4s,p2s,m1s,m2s,m3s)
      C0lt  = Cval(cc0,id2)
      C1lt  = Cval(cc1,id2)
      C2lt  = Cval(cc2,id2)
      C00lt = Cval(cc00,id2)
      C11lt = Cval(cc11,id2)
      C12lt = Cval(cc12,id2)
      C22lt = Cval(cc22,id2)


      include 'form/vert3B1S.f'
      vert3B1S = vertex * cover * P123412s34s

      vertexout = vertexout + 2.d0 * dReal(vert3B1S)
      cvertex   = cvertex + vert3B1S

      IF (iweakcorr.eq.1) THEN

*** Z
      id2Z  = CgetC(cp1s,cp3p4s,cp2s,mz2,cm2s,cm3s)
      C0lt  = CvalC(cc0,id2Z)
      C1lt  = CvalC(cc1,id2Z)
      C2lt  = CvalC(cc2,id2Z)
      C00lt = CvalC(cc00,id2Z)
      C11lt = CvalC(cc11,id2Z)
      C12lt = CvalC(cc12,id2Z)
      C22lt = CvalC(cc22,id2Z)

      include 'form/vertZ3B1S.f'
      vertZ3B1S = vertex * coverZ * P123412s34s

      vertexout = vertexout + 2.d0 * dReal(vertZ3B1S)
      cvertex   = cvertex + vertZ3B1S

*** W
      id2W  = CgetC(cp1s,cp3p4s,cp2s,mw2,czero,czero)
      C0lt  = CvalC(cc0,id2W)
      C1lt  = CvalC(cc1,id2W)
      C2lt  = CvalC(cc2,id2W)
      C00lt = CvalC(cc00,id2W)
      C11lt = CvalC(cc11,id2W)
      C12lt = CvalC(cc12,id2W)
      C22lt = CvalC(cc22,id2W)

      include 'form/vertW3B1S.f'
      vertW3B1S = vertex * coverW * P123412s34s

      vertexout = vertexout + 2.d0 * dReal(vertW3B1S)
      cvertex   = cvertex + vertW3B1S

*** NA
      id2NA = CgetC(cp1s,cp3p4s,cp2s,czero,mw2,mw2)
      C0lt  = CvalC(cc0,id2NA)
      C1lt  = CvalC(cc1,id2NA)
      C2lt  = CvalC(cc2,id2NA)
      C00lt = CvalC(cc00,id2NA)
      C11lt = CvalC(cc11,id2NA)
      C12lt = CvalC(cc12,id2NA)
      C22lt = CvalC(cc22,id2NA)

      include 'form/vertNA3B1S.f'
      vertNA3B1S = vertex * coverNA * P123412s34s

      vertexout = vertexout + 2.d0 * dReal(vertNA3B1S)
      cvertex   = cvertex + vertNA3B1S

      ENDIF

******** END *********************************************************************************
*** >>  returning if final state is e+e-mu+mu-
      if (idpart.eq.0) return
*** <<
**********************************************************************************************
******** START VERTEX 2 INTERFERED WITH conjugate[BORN_1 + BORN_2]
      p1s = mass(1)*mass(1)
      p2s = p1s
      cp1s = cone * p1s * kfm
      cp2s = cone * p2s * kfm

      m1s = 0.d0 ! mass(5)*mass(5)
      m2s = mass(1)*mass(1)
      m3s = mass(1)*mass(1)
      cm1s = cone * m1s
      cm2s = cone * m2s * kfm
      cm3s = cone * m3s * kfm

      id3 = Cget(p1s,p1p4s,p2s,m1s,m2s,m3s)
      C0lt  = Cval(cc0,id3)
      C1lt  = Cval(cc1,id3)
      C2lt  = Cval(cc2,id3)
      C00lt = Cval(cc00,id3)
      C11lt = Cval(cc11,id3)
      C12lt = Cval(cc12,id3)
      C22lt = Cval(cc22,id3)

      include 'form/vert2B1S.f'
      vert2B1S = vertex * cover * P142312s34s

      vertexout = vertexout + 2.d0 * dReal(vert2B1S)
      cvertex   = cvertex + vert2B1S

      IF (iweakcorr.eq.1) THEN

*** Z
      id3Z = CgetC(cp1s,cp1p4s,cp2s,mz2,cm2s,cm3s)
      C0lt  = CvalC(cc0,id3Z)
      C1lt  = CvalC(cc1,id3Z)
      C2lt  = CvalC(cc2,id3Z)
      C00lt = CvalC(cc00,id3Z)
      C11lt = CvalC(cc11,id3Z)
      C12lt = CvalC(cc12,id3Z)
      C22lt = CvalC(cc22,id3Z)

      include 'form/vertZ2B1S.f'
      vertZ2B1S = vertex * coverZ * P142312s34s

      vertexout = vertexout + 2.d0 * dReal(vertZ2B1S)
      cvertex   = cvertex + vertZ2B1S

*** W
      id3W = CgetC(cp1s,cp1p4s,cp2s,mw2,czero,czero)
      C0lt  = CvalC(cc0,id3W)
      C1lt  = CvalC(cc1,id3W)
      C2lt  = CvalC(cc2,id3W)
      C00lt = CvalC(cc00,id3W)
      C11lt = CvalC(cc11,id3W)
      C12lt = CvalC(cc12,id3W)
      C22lt = CvalC(cc22,id3W)

      include 'form/vertW2B1S.f'
      vertW2B1S = vertex * coverW * P142312s34s

      vertexout = vertexout + 2.d0 * dReal(vertW2B1S)
      cvertex   = cvertex + vertW2B1S

*** NA
      id3NA = CgetC(cp1s,cp1p4s,cp2s,czero,mw2,mw2)
      C0lt  = CvalC(cc0,id3NA)
      C1lt  = CvalC(cc1,id3NA)
      C2lt  = CvalC(cc2,id3NA)
      C00lt = CvalC(cc00,id3NA)
      C11lt = CvalC(cc11,id3NA)
      C12lt = CvalC(cc12,id3NA)
      C22lt = CvalC(cc22,id3NA)

      include 'form/vertNA2B1S.f'
      vertNA2B1S = vertex * coverNA * P142312s34s

      vertexout = vertexout + 2.d0 * dReal(vertNA2B1S)
      cvertex   = cvertex + vertNA2B1S

      ENDIF


******** END *********************************************************************************

**********************************************************************************************
******** START VERTEX 4 INTERFERED WITH conjugate[BORN_1 + BORN_2]
      p1s = mass(3)*mass(3)
      p2s = p1s
      cp1s = cone * p1s * kfm
      cp2s = cone * p2s * kfm

      m1s = 0.d0 ! mass(5)*mass(5)
      m2s = mass(3)*mass(3)
      m3s = mass(3)*mass(3)
      cm1s = cone * m1s
      cm2s = cone * m2s * kfm
      cm3s = cone * m3s * kfm

      id4 = Cget(p1s,p2p3s,p2s,m1s,m2s,m3s)
      C0lt  = Cval(cc0,id4)
      C1lt  = Cval(cc1,id4)
      C2lt  = Cval(cc2,id4)
      C00lt = Cval(cc00,id4)
      C11lt = Cval(cc11,id4)
      C12lt = Cval(cc12,id4)
      C22lt = Cval(cc22,id4)

      include 'form/vert4B1S.f'
      vert4B1S = vertex * cover * P142312s34s

      vertexout = vertexout + 2.d0 * dReal(vert4B1S)
      cvertex   = cvertex + vert4B1S

      IF (iweakcorr.eq.1) then
** Z
      id4Z = CgetC(cp1s,cp2p3s,cp2s,mz2,cm2s,cm3s)
      C0lt  = CvalC(cc0,id4Z)
      C1lt  = CvalC(cc1,id4Z)
      C2lt  = CvalC(cc2,id4Z)
      C00lt = CvalC(cc00,id4Z)
      C11lt = CvalC(cc11,id4Z)
      C12lt = CvalC(cc12,id4Z)
      C22lt = CvalC(cc22,id4Z)

      include 'form/vertZ4B1S.f'
      vertZ4B1S = vertex * coverZ * P142312s34s

      vertexout = vertexout + 2.d0 * dReal(vertZ4B1S)
      cvertex   = cvertex + vertZ4B1S

** W
      id4W = CgetC(cp1s,cp2p3s,cp2s,mw2,czero,czero)
      C0lt  = CvalC(cc0,id4W)
      C1lt  = CvalC(cc1,id4W)
      C2lt  = CvalC(cc2,id4W)
      C00lt = CvalC(cc00,id4W)
      C11lt = CvalC(cc11,id4W)
      C12lt = CvalC(cc12,id4W)
      C22lt = CvalC(cc22,id4W)

      include 'form/vertW4B1S.f'
      vertW4B1S = vertex * coverW * P142312s34s

      vertexout = vertexout + 2.d0 * dReal(vertW4B1S)
      cvertex   = cvertex + vertW4B1S

** NA
      id4NA = CgetC(cp1s,cp2p3s,cp2s,czero,mw2,mw2)
      C0lt  = CvalC(cc0,id4NA)
      C1lt  = CvalC(cc1,id4NA)
      C2lt  = CvalC(cc2,id4NA)
      C00lt = CvalC(cc00,id4NA)
      C11lt = CvalC(cc11,id4NA)
      C12lt = CvalC(cc12,id4NA)
      C22lt = CvalC(cc22,id4NA)

      include 'form/vertNA4B1S.f'
      vertNA4B1S = vertex * coverNA * P142312s34s

      vertexout = vertexout + 2.d0 * dReal(vertNA4B1S)
      cvertex   = cvertex + vertNA4B1S


      ENDIF

******** END *******************************************************************************
      return
      end
**************************************************************************
      subroutine debugextravertexes
      double complex vert1B1S,vert2B1S,vert3B1S,vert4B1S
      double complex vert5B1S,vert6B1S,vert7B1S,vert8B1S
      double complex vert1B2S,vert2B2S,vert3B2S,vert4B2S
      double complex vert5B2S,vert6B2S,vert7B2S,vert8B2S
      double complex coverZZ,coverWW,cWWocZZ
      double precision me2,mm2,me4,mm4,WW,ZZ
      integer ifirst
      common/commonforextravert/coverZZ,coverWW,cWWocZZ,
     .                     me2,mm2,me4,mm4,WW,ZZ,ifirst

      common/extravertexresults/
     .                     vert1B1S,vert2B1S,vert3B1S,vert4B1S,
     .                     vert5B1S,vert6B1S,vert7B1S,vert8B1S,
     .                     vert1B2S,vert2B2S,vert3B2S,vert4B2S,
     .                     vert5B2S,vert6B2S,vert7B2S,vert8B2S

      print*,coverZZ,coverWW,cWWocZZ
      print*,vert1B1S
      print*,vert2B1S
      print*,vert3B1S
      print*,vert4B1S
      print*,vert5B1S
      print*,vert6B1S
      print*,vert7B1S
      print*,vert8B1S
      print*,vert1B2S
      print*,vert2B2S
      print*,vert3B2S
      print*,vert4B2S
      print*,vert5B2S
      print*,vert6B2S
      print*,vert7B2S
      print*,vert8B2S
      
      return
      end
************************************************************************
      subroutine get_extravertexes(vertexout)
*** definitions in the notes
c      implicit none     
      implicit double complex (Z)

      double precision vertexout
      double complex   vertex
      double complex   cvertex

      integer          i,id,ifirst,iret,idpart
      integer          id1ZZ,id2ZZ,id3ZZ,id4ZZ
      integer          id1WW,id2WW,id3WW,id4WW
      integer          id5ZZ,id6ZZ,id7ZZ,id8ZZ
      integer          id5WW,id6WW,id7WW,id8WW
      double complex   C0lt,C1lt,C2lt,C00lt,C11lt,C12lt,C22lt
      double complex   C0ltZZ,C1ltZZ,C2ltZZ,C00ltZZ,C11ltZZ,C12ltZZ,
     .     C22ltZZ
      double complex   C0ltWW,C1ltWW,C2ltWW,C00ltWW,C11ltWW,C12ltWW,
     .     C22ltWW

      double precision m1s, m2s, m3s,mzs
      double complex   cm1s, cm2s, cm3s
      double precision p3s, p4s, p1s, p2s

      double complex cp3s, cp4s, cp1s, cp2s
      double complex cp1p2s, cp1p3s, cp1p4s
      double complex cp2p3s, cp2p4s
      double complex cp3p4s
      double complex cp2p1s, cp3p1s, cp4p1s
      double complex cp3p2s, cp4p2s
      double complex cp4p3s

      integer iweakcorr,ionlyqed
      common/weakcorrections/iweakcorr,ionlyqed

      double complex   coverZZ,coverWW,cWWocZZ
      double precision me2,mm2,me4,mm4,Pfermion,WW,ZZ
      common/commonforextravert/coverZZ,coverWW,cWWocZZ,
     .                     me2,mm2,me4,mm4,WW,ZZ,ifirst
      data ifirst /1/

      double complex vert1B1S,vert2B1S,vert3B1S,vert4B1S
      double complex vert5B1S,vert6B1S,vert7B1S,vert8B1S
      double complex vert1B2S,vert2B2S,vert3B2S,vert4B2S
      double complex vert5B2S,vert6B2S,vert7B2S,vert8B2S

      common/extravertexresults/
     .                     vert1B1S,vert2B1S,vert3B1S,vert4B1S,
     .                     vert5B1S,vert6B1S,vert7B1S,vert8B1S,
     .                     vert1B2S,vert2B2S,vert3B2S,vert4B2S,
     .                     vert5B2S,vert6B2S,vert7B2S,vert8B2S

#include "invariants.h"

**** external parameters
      integer imode
      common/imode/imode
      common/identicalparticles/idpart
      double precision mass(5)
      common/amasses/mass ! common used also to force pXs = m^2
***
      double precision dot
      double complex epsfun
      external dot,epsfun

#include "couplingandmasses.h"

#include "looptools.h"
      
      if (ifirst.eq.1) then

         coverZZ = (64.d0,0.d0)/16.d0/pi2
     .           * g*conjg(g) 
     .           * g*conjg(g) 
     .           * CHZZ*conjg(CHZZ)         
     .           * g * g * im

         coverWW = (64.d0,0.d0)/16.d0/pi2
     .           * g*conjg(g) 
     .           * g*conjg(g)
     .           * CHWW*conjg(CHZZ)
     .           * g * g * im

         cWWocZZ = coverWW/coverZZ
         
c         cWWocZZ = czero
         
         me2 = mass(1)*mass(1)
         mm2 = mass(3)*mass(3)
         me4 = me2*me2
         mm4 = me2*mm2

         WW = 1.d0
         ZZ = 1.d0

         vert1B1S = czero
         vert2B1S = czero
         vert3B1S = czero
         vert4B1S = czero
         vert5B1S = czero
         vert6B1S = czero
         vert7B1S = czero
         vert8B1S = czero
         vert1B2S = czero
         vert2B2S = czero
         vert3B2S = czero
         vert4B2S = czero
         vert5B2S = czero
         vert6B2S = czero
         vert7B2S = czero
         vert8B2S = czero

         ifirst = 0
      endif

c      print*,'vert ',iweakcorr,ionlyqed,rescaleQED


******************************
      vertexout = 0.d0
      if (iweakcorr.eq.0) return
******************************

      cvertex   = (0.d0,0.d0)
      vertex    = (0.d0,0.d0)
**********************************************************************************************

** Vertex 1 

****  ARGUMENTS FOR Cget... 
********************************************
*!!! WARNING: LT wants incoming momenta !!!*
********************************************
      cp1s   = cone * mass(2)*mass(2) * kfm
      cp2s   = cone * p1p2p3p4s ! dot(p1+p2+p3+p4,p1+p2+p3+p4)
      cp1p2s = cone * p1p3p4s   ! dot(p1+p3+p4,p1+p3+p4)
      cm2s   = cp1s

      id1ZZ   = CgetC(cp1s,cp2s,cp1p2s,cm2s,mz2,mz2)
      C0ltZZ  = CvalC(cc0,id1ZZ)
      C1ltZZ  = CvalC(cc1,id1ZZ)
      C2ltZZ  = CvalC(cc2,id1ZZ)
      C00ltZZ = CvalC(cc00,id1ZZ)
      C11ltZZ = CvalC(cc11,id1ZZ)
      C12ltZZ = CvalC(cc12,id1ZZ)
      C22ltZZ = CvalC(cc22,id1ZZ)

      id1WW   = CgetC(cp1s,cp2s,cp1p2s,czero,mw2,mw2)
      C0ltWW  = CvalC(cc0,id1WW) 
      C1ltWW  = CvalC(cc1,id1WW) 
      C2ltWW  = CvalC(cc2,id1WW) 
      C00ltWW = CvalC(cc00,id1WW)
      C11ltWW = CvalC(cc11,id1WW)
      C12ltWW = CvalC(cc12,id1WW)
      C22ltWW = CvalC(cc22,id1WW)

! the denominator of the fermion propagator was missing!!!!
      Pfermion = 1.d0 / (p1p3p4s - me2)

      include 'form/vert1ZZWWB1S.f'
      vert1B1S = vertex * coverZZ * P12s * P34s * Pfermion

      vertexout = vertexout + 2.d0 * dReal(vert1B1S)
      cvertex   = cvertex + vert1B1S

** Vertex 2

****  ARGUMENTS FOR Cget... 
********************************************
*!!! WARNING: LT wants incoming momenta !!!*
********************************************
      cp1s   = cone * p2p3p4s ! dot(p2+p3+p4,p2+p3+p4)
c      cp2s   = cone * dot(p1+p2+p3+p4,p1+p2+p3+p4)
      cp1p2s = cone * mass(1)*mass(1) * kfm
      cm2s   = cp1p2s

      id2ZZ   = CgetC(cp1s,cp2s,cp1p2s,cm2s,mz2,mz2)
      C0ltZZ  = CvalC(cc0,id2ZZ)
      C1ltZZ  = CvalC(cc1,id2ZZ)
      C2ltZZ  = CvalC(cc2,id2ZZ)
      C00ltZZ = CvalC(cc00,id2ZZ)
      C11ltZZ = CvalC(cc11,id2ZZ)
      C12ltZZ = CvalC(cc12,id2ZZ)
      C22ltZZ = CvalC(cc22,id2ZZ)

      id2WW   = CgetC(cp1s,cp2s,cp1p2s,czero,mw2,mw2)
      C0ltWW  = CvalC(cc0,id2WW)
      C1ltWW  = CvalC(cc1,id2WW)
      C2ltWW  = CvalC(cc2,id2WW)
      C00ltWW = CvalC(cc00,id2WW)
      C11ltWW = CvalC(cc11,id2WW)
      C12ltWW = CvalC(cc12,id2WW)
      C22ltWW = CvalC(cc22,id2WW)

      Pfermion = 1.d0/(p2p3p4s - me2)

      include 'form/vert2ZZWWB1S.f'
      vert2B1S = vertex * coverZZ * P12s * P34s * Pfermion

      vertexout = vertexout + 2.d0 * dReal(vert2B1S)
      cvertex   = cvertex + vert2B1S

** Vertex 3

****  ARGUMENTS FOR Cget... 
********************************************
*!!! WARNING: LT wants incoming momenta !!!*
********************************************
      cp1s   = cone * mass(4)*mass(4) * kfm
c      cp2s   = cone * dot(p1+p2+p3+p4,p1+p2+p3+p4)
      cp1p2s = cone * p1p2p3s ! dot(p1+p2+p3,p1+p2+p3)
      cm2s   = cp1s

      id3ZZ   = CgetC(cp1s,cp2s,cp1p2s,cm2s,mz2,mz2)
      C0ltZZ  = CvalC(cc0,id3ZZ)
      C1ltZZ  = CvalC(cc1,id3ZZ)
      C2ltZZ  = CvalC(cc2,id3ZZ)
      C00ltZZ = CvalC(cc00,id3ZZ)
      C11ltZZ = CvalC(cc11,id3ZZ)
      C12ltZZ = CvalC(cc12,id3ZZ)
      C22ltZZ = CvalC(cc22,id3ZZ)

      id3WW   = CgetC(cp1s,cp2s,cp1p2s,czero,mw2,mw2)
      C0ltWW  = CvalC(cc0,id3WW) 
      C1ltWW  = CvalC(cc1,id3WW) 
      C2ltWW  = CvalC(cc2,id3WW) 
      C00ltWW = CvalC(cc00,id3WW)
      C11ltWW = CvalC(cc11,id3WW)
      C12ltWW = CvalC(cc12,id3WW)
      C22ltWW = CvalC(cc22,id3WW)

      Pfermion = 1.d0/(p1p2p3s - mm2)

      include 'form/vert3ZZWWB1S.f'
      vert3B1S = vertex * coverZZ * P12s * P34s * Pfermion

      vertexout = vertexout + 2.d0 * dReal(vert3B1S)
      cvertex   = cvertex + vert3B1S

** Vertex 4

****  ARGUMENTS FOR Cget... 
********************************************
*!!! WARNING: LT wants incoming momenta !!!*
********************************************
      cp1s   = cone * p1p2p4s ! dot(p1+p2+p4,p1+p2+p4)
c      cp2s   = cone * dot(p1+p2+p3+p4,p1+p2+p3+p4)
      cp1p2s = cone * mass(3)*mass(3) * kfm
      cm2s   = cp1p2s

      id4ZZ   = CgetC(cp1s,cp2s,cp1p2s,cm2s,mz2,mz2)
      C0ltZZ  = CvalC(cc0,id4ZZ)
      C1ltZZ  = CvalC(cc1,id4ZZ)
      C2ltZZ  = CvalC(cc2,id4ZZ)
      C00ltZZ = CvalC(cc00,id4ZZ)
      C11ltZZ = CvalC(cc11,id4ZZ)
      C12ltZZ = CvalC(cc12,id4ZZ)
      C22ltZZ = CvalC(cc22,id4ZZ)

      id4WW   = CgetC(cp1s,cp2s,cp1p2s,czero,mw2,mw2)
      C0ltWW  = CvalC(cc0,id4WW) 
      C1ltWW  = CvalC(cc1,id4WW) 
      C2ltWW  = CvalC(cc2,id4WW) 
      C00ltWW = CvalC(cc00,id4WW)
      C11ltWW = CvalC(cc11,id4WW)
      C12ltWW = CvalC(cc12,id4WW)
      C22ltWW = CvalC(cc22,id4WW)

      Pfermion = 1.d0/(p1p2p4s - mm2)

      include 'form/vert4ZZWWB1S.f'
      vert4B1S = vertex * coverZZ * P12s * P34s * Pfermion

      vertexout = vertexout + 2.d0 * dReal(vert4B1S)
      cvertex   = cvertex + vert4B1S

*################################à
      if (idpart.eq.0) return
*################################à

** Vertex 5

****  ARGUMENTS FOR Cget... 
********************************************
*!!! WARNING: LT wants incoming momenta !!!*
********************************************
      cp1s   = cone * mass(4)*mass(4) * kfm
c      cp2s   = cone * dot(p1+p2+p3+p4,p1+p2+p3+p4)
      cp1p2s = cone * p1p2p3s ! dot(p1+p2+p3,p1+p2+p3)
      cm2s   = cp1s

c      id5ZZ   = CgetC(cp1s,cp2s,cp1p2s,cm2s,mz2,mz2)
      C0ltZZ  = CvalC(cc0,id3ZZ)
      C1ltZZ  = CvalC(cc1,id3ZZ)
      C2ltZZ  = CvalC(cc2,id3ZZ)
      C00ltZZ = CvalC(cc00,id3ZZ)
      C11ltZZ = CvalC(cc11,id3ZZ)
      C12ltZZ = CvalC(cc12,id3ZZ)
      C22ltZZ = CvalC(cc22,id3ZZ)

c      id5WW   = CgetC(cp1s,cp2s,cp1p2s,czero,mw2,mw2)
      C0ltWW  = CvalC(cc0,id3WW) 
      C1ltWW  = CvalC(cc1,id3WW) 
      C2ltWW  = CvalC(cc2,id3WW) 
      C00ltWW = CvalC(cc00,id3WW)
      C11ltWW = CvalC(cc11,id3WW)
      C12ltWW = CvalC(cc12,id3WW)
      C22ltWW = CvalC(cc22,id3WW)

      Pfermion = 1.d0/(p1p2p3s - me2)

      include 'form/vert5ZZWWB1S.f'
      vert5B1S = vertex * coverZZ * P12s * P34s * Pfermion

      vertexout = vertexout + 2.d0 * dReal(vert5B1S)
      cvertex   = cvertex + vert5B1S

** Vertex 6

****  ARGUMENTS FOR Cget... 
********************************************
*!!! WARNING: LT wants incoming momenta !!!*
********************************************
      cp1s   = cone * p2p3p4s ! dot(p2+p3+p4,p2+p3+p4)
c      cp2s   = cone * dot(p1+p2+p3+p4,p1+p2+p3+p4)
      cp1p2s = cone * mass(1)*mass(1) * kfm
      cm2s   = cp1p2s

c      id6ZZ   = CgetC(cp1s,cp2s,cp1p2s,cm2s,mz2,mz2)
      C0ltZZ  = CvalC(cc0,id2ZZ)
      C1ltZZ  = CvalC(cc1,id2ZZ)
      C2ltZZ  = CvalC(cc2,id2ZZ)
      C00ltZZ = CvalC(cc00,id2ZZ)
      C11ltZZ = CvalC(cc11,id2ZZ)
      C12ltZZ = CvalC(cc12,id2ZZ)
      C22ltZZ = CvalC(cc22,id2ZZ)

c      id6WW   = CgetC(cp1s,cp2s,cp1p2s,czero,mw2,mw2)
      C0ltWW  = CvalC(cc0,id2WW) 
      C1ltWW  = CvalC(cc1,id2WW) 
      C2ltWW  = CvalC(cc2,id2WW) 
      C00ltWW = CvalC(cc00,id2WW)
      C11ltWW = CvalC(cc11,id2WW)
      C12ltWW = CvalC(cc12,id2WW)
      C22ltWW = CvalC(cc22,id2WW)

      Pfermion = 1.d0/(p2p3p4s - me2)

      include 'form/vert6ZZWWB1S.f'
      vert6B1S = vertex * coverZZ * P12s * P34s * Pfermion

      vertexout = vertexout + 2.d0 * dReal(vert6B1S)
      cvertex   = cvertex + vert6B1S

** Vertex 7

****  ARGUMENTS FOR Cget... 
********************************************
*!!! WARNING: LT wants incoming momenta !!!*
********************************************
      cp1s   = cone * mass(2)*mass(2) * kfm
c      cp2s   = cone * dot(p1+p2+p3+p4,p1+p2+p3+p4)
      cp1p2s = cone * p1p3p4s ! dot(p1+p3+p4,p1+p3+p4)
      cm2s   = cp1s

c      id7ZZ   = CgetC(cp1s,cp2s,cp1p2s,cm2s,mz2,mz2)
      C0ltZZ  = CvalC(cc0,id1ZZ)
      C1ltZZ  = CvalC(cc1,id1ZZ)
      C2ltZZ  = CvalC(cc2,id1ZZ)
      C00ltZZ = CvalC(cc00,id1ZZ)
      C11ltZZ = CvalC(cc11,id1ZZ)
      C12ltZZ = CvalC(cc12,id1ZZ)
      C22ltZZ = CvalC(cc22,id1ZZ)

c      id7WW   = CgetC(cp1s,cp2s,cp1p2s,czero,mw2,mw2)
      C0ltWW  = CvalC(cc0,id1WW) 
      C1ltWW  = CvalC(cc1,id1WW) 
      C2ltWW  = CvalC(cc2,id1WW) 
      C00ltWW = CvalC(cc00,id1WW)
      C11ltWW = CvalC(cc11,id1WW)
      C12ltWW = CvalC(cc12,id1WW)
      C22ltWW = CvalC(cc22,id1WW)

      Pfermion = 1.d0/(p1p3p4s - me2)

      include 'form/vert7ZZWWB1S.f'
      vert7B1S = vertex * coverZZ * P12s * P34s * Pfermion

      vertexout = vertexout + 2.d0 * dReal(vert7B1S)
      cvertex   = cvertex + vert7B1S

** Vertex 8

****  ARGUMENTS FOR Cget... 
********************************************
*!!! WARNING: LT wants incoming momenta !!!*
********************************************
      cp1s   = cone * p1p2p4s ! dot(p1+p2+p4,p1+p2+p4)
c      cp2s   = cone * dot(p1+p2+p3+p4,p1+p2+p3+p4) 
      cp1p2s = cone * mass(3)*mass(3) * kfm
      cm2s   = cp1p2s

c      id8ZZ   = CgetC(cp1s,cp2s,cp1p2s,cm2s,mz2,mz2)
      C0ltZZ  = CvalC(cc0,id4ZZ)
      C1ltZZ  = CvalC(cc1,id4ZZ)
      C2ltZZ  = CvalC(cc2,id4ZZ)
      C00ltZZ = CvalC(cc00,id4ZZ)
      C11ltZZ = CvalC(cc11,id4ZZ)
      C12ltZZ = CvalC(cc12,id4ZZ)
      C22ltZZ = CvalC(cc22,id4ZZ)

c      id8WW   = CgetC(cp1s,cp2s,cp1p2s,czero,mw2,mw2)
      C0ltWW  = CvalC(cc0,id4WW) 
      C1ltWW  = CvalC(cc1,id4WW) 
      C2ltWW  = CvalC(cc2,id4WW) 
      C00ltWW = CvalC(cc00,id4WW)
      C11ltWW = CvalC(cc11,id4WW)
      C12ltWW = CvalC(cc12,id4WW)
      C22ltWW = CvalC(cc22,id4WW)

      Pfermion = 1.d0/(p1p2p4s-me2)

      include 'form/vert8ZZWWB1S.f'
      vert8B1S = vertex * coverZZ * P12s * P34s * Pfermion

      vertexout = vertexout + 2.d0 * dReal(vert8B1S)
      cvertex   = cvertex + vert8B1S
      
      return
      end
