      subroutine distributions(sd,nc,p1,p2,p3,p4,ng,qph)
      include 'distr.inc'
      double precision m1234,m12,m13,m14,m23,m24,m34,m12l,m34nl
      double precision m1234r,m12r,m13r,m14r,m23r,m24r,m34r,m12lr,m34nlr
      double precision pt4l
      double precision pttemp(1:4)
      integer ind
      dimension ptv(4),etav(4),sptv(4)
      integer indexes(4)
      double precision masshiggs
      double precision mass(5)
      common/amasses/mass
      common/paramhiggs/masshiggs
      common/zparam/zmass,zwidth
      integer idpart
      common/identicalparticles/idpart
! when using PS, q is the most energetic photon 
      double precision icount
      common/ionlyfirsttime/icount,ifirst
      data icount /0.d0/
      data ifirst /0/ 
      common/constindistr/pi,radtodeg,zm2,drmin
      dimension fun(ndistr)
      data ((distr(i,j),i=1,ndistr),j=1,ibin)   / iperj * 0.d0 /	
      data ((s_distr(i,j),i=1,ndistr),j=1,ibin) / iperj * 0.d0 /
      integer*8 nc
      double precision qa(0:3),qb(0:3),qw(0:3),egammas(ng),drqa(4)
      double precision pippo(0:3),pluto(0:3),topolino(0:3)
      double precision p1c(0:3),p2c(0:3),p3c(0:3),p4c(0:3)
      double precision p1l(0:3),p2l(0:3),p3l(0:3),p4l(0:3)
      double precision p1r(0:3),p2r(0:3),p3r(0:3),p4r(0:3)
      integer iloc(1)
      double precision xx,yy,zz
      common/searchmin/xx,yy,zz
      data xx,yy,zz/1d10,0.d0,1d5/
      common/todebug/emtx2,phsp
      common/decayCFRdistr/var1,var2,var3

      double precision mlead,msub
      double precision phi_p1p3, phi_p2p4,phi_sum,phi_dif
      double precision cos1,cos2
      double precision pz1(0:3),pz2(0:3),ptot(0:3),
     .     pp1(0:3),pp3(0:3),pptot1(0:3),pptot2(0:3)

***********************************************************************
* DISTRIBUTIONS
* see setfilenames
************************************************************************
      if (ifirst.eq.0) then
         pi = 4.d0 * atan(1.d0)
         radtodeg = 180.d0 / pi
         zm2 = zmass * zmass

         drmin = 0.1d0
         
         del    = (masshiggs-sum(mass))/(nbin-1)
         bmi(1) = sum(mass)
         bma(1) = masshiggs-sum(mass) + del

         del    = (masshiggs-sum(mass))/(nbin-1)
         bmi(2) = 0.d0
         bma(2) = masshiggs-sum(mass)+del

         
         bmi(3) = bmi(2)
         bma(3) = bma(2)

         bmi(4) = bmi(2)
         bma(4) = bma(2)

         bmi(5) = bmi(2)
         bma(5) = bma(2)
         
         bmi(6) = bmi(2)
         bma(6) = bma(2)
         
         bmi(7) = bmi(2)
         bma(7) = bma(2)
         

         bmi(8) = bmi(2)
         bma(8) = bma(2) * 0.5d0
         
         bmi(9) = -1.01d0
         bma(9) =  1.01d0
         
         bmi(10) = bmi(9)
         bma(10) = bma(9)
         
         bmi(11) = bmi(9) !0.d0         !
         bma(11) = bma(9) !180d0        !         
         
         bmi(12) = bmi(9)
         bma(12) = bma(9)
         
         bmi(13) = 0.d0
         bma(13) = masshiggs/2.d0
         
         bmi(14) = bmi(13)
         bma(14) = bma(13)
         
         bmi(15) = bmi(13)
         bma(15) = bma(13)
         
         bmi(16) = bmi(13)
         bma(16) = bma(13)
         
         del = 360.d0/(nbin-1)
         bmi(17) =  0d0
         bma(17) =  360d0+del
         
         bmi(18) = -0.1d0
         bma(18) = 8.d0 + bmi(18)
         bmi(30) = bmi(18)
         bma(30) = bma(18)
         bmi(31) = bmi(18)
         bma(31) = bma(18)

         bmi(32) = 0.d0
         bma(32) = 1.d0

         del     = masshiggs/(nbin-1)
         bmi(19) = 25.d0 !masshiggs - zmass
         bma(19) = masshiggs + del

         del     = masshiggs/(nbin-1)/2.d0
         bmi(20) = 0.d0
         bma(20) = masshiggs/2.d0 + del

         eng_min = 5.d0
         
         bmi(21) = 0.d0
         bma(21) = masshiggs/2.d0
         
         bmi(22) = bmi(21)
         bma(22) = bma(21)

         bmi(23) = 0.d0
         bma(23) = nbin + bmi(23)
         bmi(29) = bmi(23)
         bma(29) = bma(23)
         
         bmi(24) = -1.001d0 !bmi(23)
         bma(24) =  1.001d0 !bma(23)
         
         del = (95.d0-85.d0)/(nbin-1)
         bmi(25) =  85.d0
         bma(25) =  95.d0+del
         
         del = (100.d0-60.d0)/(nbin-1)
         bmi(26) =  60.d0
         bma(26) = 100.d0+del
         
         del = (95.d0-85.d0)/(nbin-1)
         bmi(27) =  85.d0
         bma(27) =  95.d0+del
         
         del = (100.d0-60.d0)/(nbin-1)
         bmi(28) =  60.d0
         bma(28) = 100.d0+del
         
         bmi(9) = bmi(2)
         bma(9) = bma(2)

         bmi(10) = bmi(3)
         bma(10) = bma(3)

         bmi(11) = bmi(4)
         bma(11) = bma(4)
         bmi(12) = bmi(5)
         bma(12) = bma(5)

         bmi(30) = bmi(6)
         bma(30) = bma(6)

         bmi(18) = bmi(17)
         bma(18) = bma(17)

         bmi(31) = bmi(25)
         bma(31) = bma(25)

         bmi(29) = bmi(26)
         bma(29) = bma(26)


******************************************************
******** plot per le masse leading e subleading ******
         bmi(33) = 0d0
         bma(33) = masshiggs

         bmi(34) = 0d0
         bma(34) = masshiggs

         bmi(35) = 10d0
         bma(35) = 60d0

         bmi(36) = 85d0
         bma(36) = 95d0

*******************************************************
*********** additional angular variables **************
         del     =  180.d0/(nbin-1)
         bmi(37) =  0d0
         bma(37) =  180d0+del
         bmi(38) =  0d0
         bma(38) =  180d0+del


         del     =  360d0/(nbin-1)
         bmi(39) =  0d0
         bma(39) =  360 + del
         del     =  360d0/(nbin-1)
         bmi(40) = -180d0
         bma(40) =  180d0 + del
********************************************************
************ additional CP-sensitive observables *******
         bmi(41) = -1d0
         bma(41) =  1d0
         bmi(42) = -1d0
         bma(42) =  1d0
********************************************************
         
! filling distr. components when entering the first time
         do k = 1,ndistr
            d = (bma(k) - bmi(k))/nbin
            y = bmi(k)
            do i = 1,nbin
               y = y + d
               distr(k,i*3-2)   = y - d
               s_distr(k,i*3-2) = y - d
            enddo
         enddo
         ifirst = 1
      endif
****
      icount = icount + 1.d0
*******************************
** recombining photons      
      p1r = p1
      p2r = p2
      p3r = p3
      p4r = p4
      if (ng.gt.0) then
         do k = 1,ng
            qa = qph(k,:)
            drqa(1) = get_deltaR(qa,p1)
            drqa(2) = get_deltaR(qa,p2)
            if (idpart.eq.0) then
               iloc = minloc(drqa(1:2))
            else
               drqa(3) = get_deltaR(qa,p3)
               drqa(4) = get_deltaR(qa,p4)
               iloc = minloc(drqa)
            endif
            if (drqa(iloc(1)).lt.drmin) then
               if (iloc(1).eq.1) p1r = p1r + qa
               if (iloc(1).eq.2) p2r = p2r + qa
               if (iloc(1).eq.3) p3r = p3r + qa
               if (iloc(1).eq.4) p4r = p4r + qa
            endif
         enddo
      endif
*******************************
      
      m12  = sqrt(dot(p1+p2,p1+p2))
      m12r = sqrt(dot(p1r+p2r,p1r+p2r))
      m13  = sqrt(dot(p1+p3,p1+p3))
      m13r = sqrt(dot(p1r+p3r,p1r+p3r))
      m14  = sqrt(dot(p1+p4,p1+p4))
      m14r = sqrt(dot(p1r+p4r,p1r+p4r))
      m23  = sqrt(dot(p2+p3,p2+p3))
      m23r = sqrt(dot(p2r+p3r,p2r+p3r))
      m24  = sqrt(dot(p2+p4,p2+p4))
      m24r = sqrt(dot(p2r+p4r,p2r+p4r))
      m34  = sqrt(dot(p4+p3,p4+p3))
      m34r = sqrt(dot(p4r+p3r,p4r+p3r))

      if (idpart.eq.0) then
         p1l = p1
         p2l = p2
         p3l = p3
         p4l = p4         
      else
         dz12 = abs(dot(p1+p2,p1+p2)-zm2)
         dz23 = abs(dot(p2+p3,p2+p3)-zm2)
         dz14 = abs(dot(p1+p4,p1+p4)-zm2)
         dz34 = abs(dot(p4+p3,p4+p3)-zm2)
         if (dz12.lt.dz23.and.
     .       dz12.lt.dz14.and.
     .       dz12.lt.dz34) then
            p1l = p1
            p2l = p2
            p3l = p3
            p4l = p4
         elseif (dz23.lt.dz12.and.
     .           dz23.lt.dz14.and.
     .           dz23.lt.dz34) then
            p1l = p3
            p2l = p2
            p3l = p1
            p4l = p4
         elseif (dz14.lt.dz12.and.
     .           dz14.lt.dz23.and.
     .           dz14.lt.dz34) then
            p1l = p1
            p2l = p4
            p3l = p3
            p4l = p2
         elseif (dz34.lt.dz12.and.
     .           dz34.lt.dz23.and.
     .           dz34.lt.dz14) then
            p1l = p3
            p2l = p4
            p3l = p1
            p4l = p2
         endif
      endif
      
      m12l  = sqrt(dot(p1l+p2l,p1l+p2l))
      m34nl = sqrt(dot(p3l+p4l,p3l+p4l))

      do k = 0,3
         pippo(k) = p1l(k) + p2l(k) + p3l(k) + p4l(k)
      enddo
      m1234 = sqrt(dot(pippo,pippo))

      pt4l = sqrt(pippo(1)**2+pippo(2)**2)

      call new_boost(pippo,p1l,p1c,1)
      call new_boost(pippo,p2l,p2c,1)
      call new_boost(pippo,p3l,p3c,1)
      call new_boost(pippo,p4l,p4c,1)

      c13 = tridot(p1c,p3c)/sqrt(tridot(p1c,p1c))/sqrt(tridot(p3c,p3c))
      c24 = tridot(p2c,p4c)/sqrt(tridot(p2c,p2c))/sqrt(tridot(p4c,p4c))
      c12 = tridot(p1c,p2c)/sqrt(tridot(p1c,p1c))/sqrt(tridot(p2c,p2c))
      c34 = tridot(p3c,p4c)/sqrt(tridot(p3c,p3c))/sqrt(tridot(p4c,p4c))

      ptv(1) = sqrt(p1l(1)**2 + p1l(2)**2)
      ptv(2) = sqrt(p2l(1)**2 + p2l(2)**2)
      ptv(3) = sqrt(p3l(1)**2 + p3l(2)**2)
      ptv(4) = sqrt(p4l(1)**2 + p4l(2)**2)
      call sort_vector(ptv,sptv,indexes,4)

      pt1 = sptv(1)
      pt2 = sptv(2)
      pt3 = sptv(3)
      pt4 = sptv(4)

      etav(1) = 0.5d0*log((p1l(0)+p1l(3))/((p1l(0)-p1l(3))))
      etav(2) = 0.5d0*log((p2l(0)+p2l(3))/((p2l(0)-p2l(3))))
      etav(3) = 0.5d0*log((p3l(0)+p3l(3))/((p3l(0)-p3l(3))))
      etav(4) = 0.5d0*log((p4l(0)+p4l(3))/((p4l(0)-p4l(3))))
      eta1 = etav(indexes(1))
      eta2 = etav(indexes(2))
      eta3 = etav(indexes(3))
      eta4 = etav(indexes(4))

      eng1 = -5d0
      eng2 = -5d0
      ptg  = -5d0
      cg   = -2.d0
      cg1  = -2.d0

      if (ng.ge.1) then
         do k = 1,ng
            egammas(k) = qph(k,0)
         enddo
         iloc   = maxloc(egammas)
         imax   = iloc(1)
         engmax = egammas(iloc(1))
         if (engmax.gt.eng_min) then
            eng1=engmax
            ptg =sqrt(qph(imax,1)**2 + qph(imax,2)**2)
            cg  =qph(imax,3)/qph(imax,0)
            cg1 =tridot(p1,qph(imax,:))/qph(imax,0)/sqrt(tridot(p1,p1))
         endif
         iloc = minloc(egammas)
         imin = iloc(1)
      endif

      if (ng.ge.2) then
         iloc = maxloc(egammas,MASK=egammas.lt.engmax)
         eng2max = egammas(iloc(1))
         if (eng2max.gt.eng_min) then
            eng2 = eng2max
         endif
      endif

      call phi1phi2(p1l,p2l,p3l,p4l,phi1,phi2)
      call phi1phi2(p1r,p2r,p3r,p4r,phi1r,phi2r)

******************** NEW OBSERVABLES **************************
      if(abs(m12-zmass) .lt. abs(m34-zmass)) then
         mlead =  m12
         msub  =  m34
      else
         mlead =  m34
         msub  =  m12
      endif
************* additional CP-sensitive observables **************
      phi_p1p3 = radtodeg*acos(tridot(p1,p3)
     .     /sqrt((abs(tridot(p1,p1)*tridot(p3,p3))))) 
      phi_p2p4 = radtodeg*acos(tridot(p2,p4)
     .     /sqrt((abs(tridot(p2,p2)*tridot(p4,p4))))) 

      phi_sum = phi_p1p3 + phi_p2p4
      phi_dif = phi_p1p3 - phi_p2p4

****************************************************************
      pz1  = p1 + p2
      pz2  = p3 + p4
      ptot = p1 + p2 + p3 + p4
      
      call new_boost(pz1,p1,pp1,1)
      call new_boost(pz1,ptot,pptot1,1)
      cos1 = tridot(pp1,pptot1)
      cos1 = cos1/(sqrt(tridot(pp1,pp1))*sqrt(tridot(pptot1,pptot1)))
      
      call new_boost(pz2,p3,pp3,1)
      call new_boost(pz2,ptot,pptot2,1)
      cos2 = tridot(pp3,pptot2)
      cos2 = cos2/(sqrt(tridot(pp3,pp3))*sqrt(tridot(pptot2,pptot2)))

      
**********************************************************************
      
      fun(1)  = m1234
      fun(2)  = m12
      fun(3)  = m13
      fun(4)  = m14
      fun(5)  = m23
      fun(6)  = m24
      fun(7)  = m34

      fun(8)  = pt4l

      fun(9)  = m12r
      fun(10) = m13r
      fun(11) = m14r

      
      fun(12) = m23r

      fun(13) = pt1
      fun(14) = pt2
      fun(15) = pt3
      fun(16) = pt4
      fun(17) = phi1
      fun(18) = phi2
      fun(19) = m12l
      fun(20) = m34nl
      fun(21) = eng1
      fun(22) = eng2
      fun(24) = cg1
      fun(25) = fun(2)
      fun(26) = fun(25)
      fun(27) = fun(7)
      fun(28) = fun(27)

      fun(23) = 0.001d0
      fun(29) = 0.001d0
      if (ng.ge.1) then
         do k = 1,ng
            if (qph(k,0).gt.4.d0) fun(23) = fun(23)+1.d0
            if (qph(k,0).gt.0.d0) fun(29) = fun(29)+1.d0
         enddo
      endif

*** filling distr 18 and 30,31,32
      fun(18) = -1.d0
      fun(30) = -1.d0
      fun(31) = -1.d0
      fun(32) = -1.d0
      if (ng.ge.1) then
         if (qph(imax,0).gt.4.d0) then
            ptv(1) = p1l(0)
            ptv(2) = p2l(0)
            ptv(3) = p3l(0)
            ptv(4) = p4l(0)
            call sort_vector(ptv,sptv,indexes,4)
            if (indexes(1).eq.1) pippo = p1l
            if (indexes(1).eq.2) pippo = p2l
            if (indexes(1).eq.3) pippo = p3l
            if (indexes(1).eq.4) pippo = p4l
            if (indexes(4).eq.1) topolino = p1l
            if (indexes(4).eq.2) topolino = p2l
            if (indexes(4).eq.3) topolino = p3l
            if (indexes(4).eq.4) topolino = p4l

            pluto = qph(imax,:) ! the photon
            fun(18) = get_deltaR(pluto,pippo)
            fun(30) = get_deltaR(pluto,topolino)

            if (qph(imin,0).gt.0.d0) then
               pluto   = qph(imin,:) ! the photon
               fun(31) = get_deltaR(pluto,pippo)
               fun(32) = get_deltaR(pluto,topolino)
            endif

         endif
      endif
      
**!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
** overwriting
      fun(18) = phi1r
      fun(29) = fun(9)
      fun(30) = m24r
      fun(31) = fun(9)      
****
****  
      fun(32) = -1.d0

      z2 = zmass!*zmass
      am12 = abs(sqrt(dot(p1+p2,p1+p2))-z2)
      am34 = abs(sqrt(dot(p3+p4,p3+p4))-z2)
      if (am12.le.am34) then
         pippo = p1 + p2
      else
         pippo = p3 + p4
      endif

      fun(32) = abs(pippo(3)/sqrt(tridot(pippo,pippo)))
******
******

****** LEADING AND SUBLEADING MASSES ***************
      fun(33) = msub
      fun(34) = mlead
      fun(35) = msub
      fun(36) = mlead
      fun(37) = phi_p1p3
      fun(38) = phi_p2p4
      fun(39) = phi_sum
      fun(40) = phi_dif
      fun(41) = cos1
      fun(42) = cos2
***********************************


***************************
      DO k = 1,ndistr
         d = (bma(k) - bmi(k))/nbin
         x = bmi(k)
** NEW ***
         if (fun(k).lt.bma(k).and.fun(k).gt.bmi(k)) then
            i  = (fun(k) - bmi(k))/d
            i  = (i+1)*3
            distr(k,i-1) = distr(k,i-1) + sd
            distr(k,i)   = distr(k,i)   + sd*sd                   
            su  = distr(k,i-1)
            su2 = distr(k,i)               
            s_distr(k,i-1) = su / nc	       
            argument = abs((su2/nc-s_distr(k,i-1)**2)/nc)
            s_distr(k,i) = sqrt(argument)
         endif
** NEW ***
      ENDDO

      return
      end
*********************************************************************
      subroutine setfilenames(programma,path)
      include 'distr.inc'
      common/filenames/distname

      character*30 programma,corrections
      character*100 path
      character*100 distname(ndistr),tmp(ndistr)
      character*2 ec,ac
      character*7 bw
      character*9 crsstr
      character*1 tstr

      common/recombinesmearcut/irecombine,ismearing,icut

      corrections = 'oal'

      do k = 1,len(bw)
         bw(k:k) = ' '
      enddo
      do k = 1,ndistr
         do i = 1,100
            tmp(k)(i:i) = ' '
         enddo
      enddo

      if (nbin.eq.50)  bw =  '50.txt'
      if (nbin.eq.100) bw = '100.txt'
      if (nbin.eq.200) bw = '200.txt'

      ac = ''
      ec = ''

      call itoa(icut,tstr)
      crsstr(1:3) = '_c'//tstr
      call itoa(irecombine,tstr)
      crsstr(4:6) = '_r'//tstr
      call itoa(ismearing,tstr)
      crsstr(7:9) = '_s'//tstr

      tmp(1)  ='_m1234'//'.dat'
      tmp(2)  ='_m12'//'.dat'
      tmp(3)  ='_m13'//'.dat'
      tmp(4)  ='_m14'//'.dat'
      tmp(5)  ='_m23'//'.dat'
      tmp(6)  ='_m24'//'.dat'
      tmp(7)  ='_m34'//'.dat'
      tmp(8)  ='_pt4l'//'.dat'
      tmp(9)  ='_m12r'//'.dat'
      tmp(10) ='_m13r'//'.dat'
      tmp(11) ='_m14r'//'.dat'
      tmp(12) ='_m23r'//'.dat'
      tmp(13) ='_ptl1'//'.dat'
      tmp(14) ='_ptl2'//'.dat'
      tmp(15) ='_ptl3'//'.dat'
      tmp(16) ='_ptl4'//'.dat'
      tmp(17) ='_phi1'//'.dat'
      tmp(18) ='_phi1r'//'.dat'
      tmp(30) ='_m24r'//'.dat'
      tmp(31) ='_m12rw1'//'.dat'
      tmp(32) ='_cst'//'.dat'
      tmp(19) ='_m12l'//'.dat'
      tmp(20) ='_m34nl'//'.dat'
      tmp(21) ='_eng1'//'.dat'
      tmp(22) ='_eng2'//'.dat'
      tmp(23) ='_mult'//'.dat'
      tmp(29) ='_m12rw2'//'.dat'
      tmp(24) ='_cg1'//'.dat'

      tmp(25) ='_m12w1'//'.dat'
      tmp(26) ='_m12w2'//'.dat'
      tmp(27) ='_m34w1'//'.dat'
      tmp(28) ='_m34w2'//'.dat'
******************************************
      tmp(33) = '_msub'//'.dat' 
      tmp(34) = '_mlead'//'.dat' 
      tmp(35) = '_msub_w1'//'.dat' 
      tmp(36) = '_mlead_w1'//'.dat'
      tmp(37) = '_phi13'//'.dat'
      tmp(38) = '_phi24'//'.dat'
      tmp(39) = '_phisum'//'.dat'
      tmp(40) = '_phidif'//'.dat'
      tmp(41) = '_cos1'//'.dat'
      tmp(42) = '_cos2'//'.dat'
*******************************************      
      do k = 1,30
         if (programma(k:k).ne.' ') lprog=k
      enddo

      do k = 1,100
         if (path(k:k).ne.' ') lpath=k
      enddo

      do k = 1,ndistr
         distname(k)(1:lpath) = path
         distname(k)(lpath+1:lpath+lprog) = programma
         distname(k)(lpath+lprog+1:) = tmp(k)
      enddo

      return
      end
*********************************************************************
      subroutine writedistributions
      include 'distr.inc'
      common/filenames/distname
      character*150 ciccio(ndistr)
      character*100 distname(ndistr)
      character*8  distorder
      do k = 1,ndistr
         open(12,file=distname(k),status='unknown')
c         write(12,*)'## header for cfr Prophecy4f-2.0'
c         write(12,*)'## header for cfr Prophecy4f-2.0'
c         write(12,*)'## header for cfr Prophecy4f-2.0'
c         write(12,*)'## header for cfr Prophecy4f-2.0'
c         write(12,*)'## header for cfr Prophecy4f-2.0'
         do i=1,nbin
            sezd  = s_distr(k,i*3-1) /(bma(k)-bmi(k))*nbin
            esezd = s_distr(k,i*3) /(bma(k)-bmi(k))*nbin
            write(12,*)s_distr(k,i*3-2),sezd,esezd
	 enddo
         close(12)
      enddo
      return
      end
*********************************************************
***************
      subroutine phi1phi2(p1,p2,p3,p4,phi1,phi2)
      implicit double precision (a-h,o-z)
      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3),ptmp1(0:3),ptmp2(0:3)
      dimension ptmp(0:3),ptmp3(0:3)

      common/constindistr/pi,radtodeg,zm2,drmin

      ptmp(0) = p1(0)+p2(0)
      ptmp(1) = p1(1)+p2(1)
      ptmp(2) = p1(2)+p2(2)
      ptmp(3) = p1(3)+p2(3)
      call vecprod(ptmp,p1,ptmp1)
      call vecprod(ptmp,p3,ptmp2)
      cphi1 = tridot(ptmp1,ptmp2)
     .        /sqrt(tridot(ptmp1,ptmp1))/sqrt(tridot(ptmp2,ptmp2))
      phi1 = acos(cphi1)
      call vecprod(ptmp1,ptmp2,ptmp3)
      if (tridot(ptmp3,ptmp).lt.0.d0) phi1=2.d0*pi - phi1

      phi1 = phi1*radtodeg

      ptmp(0) = p1(0)+p4(0)
      ptmp(1) = p1(1)+p4(1)
      ptmp(2) = p1(2)+p4(2)
      ptmp(3) = p1(3)+p4(3)
      call vecprod(ptmp,p1,ptmp1)
      call vecprod(ptmp,p3,ptmp2)
      cphi2 = tridot(ptmp1,ptmp2)
     .        /sqrt(tridot(ptmp1,ptmp1))/sqrt(tridot(ptmp2,ptmp2))
      phi2 = acos(cphi2)
      call vecprod(ptmp1,ptmp2,ptmp3)
      if (tridot(ptmp3,ptmp).lt.0.d0) phi2=2d0*pi- phi2

      phi2 = phi2*radtodeg

      return
      end
***************
      subroutine vecprod(p1,p2,p3)
      implicit double precision (a-h,o-z)
      dimension p1(0:3),p2(0:3),p3(0:3)
      p3(0) =  p1(0)+p2(0)
      p3(1) =  p1(2)*p2(3) - p1(3)*p2(2)
      p3(2) = -p1(1)*p2(3) + p1(3)*p2(1)
      p3(3) =  p1(1)*p2(2) - p1(2)*p2(1)
      return
      end
****************************************************
      function get_deltaR(p1,p2)
      implicit double precision (a-h,o-z)
      dimension p1(0:3),p2(0:3)

! from ALPGEN
      pt1 = sqrt(p1(1)**2+p1(2)**2)
      pt2 = sqrt(p2(1)**2+p2(2)**2)
      eta1 = -log(tan(0.5d0*atan2(pt1,p1(3))))
      eta2 = -log(tan(0.5d0*atan2(pt2,p2(3))))
      dphi = (p1(1)*p2(1)+p1(2)*p2(2))/pt1/pt2
      if (abs(dphi).gt.1.d0) then
         dphi = dphi/abs(dphi)
      endif
      dphi = acos(dphi)

      get_deltaR = sqrt((eta1-eta2)**2+dphi**2)

c      if (abs(get_deltaR-3.141592d0).lt.0.1d0) then
c         print*,eta1,eta2,eta1-eta2,dphi,get_deltaR
c      endif
      
      return
      end
**********
      function pseudorapidity(p)
      implicit none
      double precision pseudorapidity,p(0:3),theta,tridot
      external tridot
      theta = acos(p(3)/sqrt(tridot(p,p)))
      pseudorapidity = -log(tan(theta/2.d0))
      return
      end
*****************************************
      function get_dphi(p1,p2)
      implicit double precision (a-h,o-z)
      double precision p1(0:3),p2(0:3)
! from ALPGEN
      dphi = (p1(1)*p2(1)+p1(2)*p2(2))/
     .     sqrt(p1(1)**2+p1(2)**2)/sqrt(p2(1)**2+p2(2)**2)
      if (abs(dphi).gt.1.d0) then
         dphi = dphi/abs(dphi)
      endif
      get_dphi = acos(dphi)
      return
      end
***********************
      function getphi(ppp)
      implicit double precision (a-h,o-z)
      dimension ppp(0:3)
      parameter (pi = 3.141592653589793238462643383279502884197169399d0)
      pm = sqrt(ppp(1)**2+ppp(2)**2+ppp(3)**2)
      c  = ppp(3)/pm
      s  = sqrt(1.d0-c**2)
      if (s.eq.0.d0) then
         getphi = 0.d0
         return
      else   
         arg = ppp(1)/pm/s
*  avoiding numerical problems......
         if (abs(arg).ge.1.d0) then
            iarg = arg
            arg  = iarg
         endif   
         if (ppp(2).ge.0.d0) getphi = acos(arg)
         if (ppp(2).lt.0.d0) getphi = 2.d0*pi-acos(arg)
      endif             
      return
      end
