C-- Input parameters from MG5 
c$$$      gW = MG5GW
c$$$      CW = MG5CW
c$$$      SW = MG5SW
c$$$      MZ = MDL_MZ
c$$$      WZ = MDL_WZ 
C=================
c$$$      gZ = gW/CW
c$$$      g1 = gZ*SW
c$$$      gE = gW*SW
c$$$      COUPLSM = (gZ**3*MZ)**2
c$$$
c$$$      SWSQ = SW**2
c$$$      CV   = (SWSQ -1.D0/4.D0)
c$$$      CA   = (+1.D0/4.D0)
c$$$      CVA  = CV*CA
c$$$      CVSQ = CV**2
c$$$      CASQ = CA**2
c$$$
c$$$      MZSQ = MZ**2

      s12 = dot(k1,k2)
      s13 = dot(k1,k3)
      s14 = dot(k1,k4)
      s23 = dot(k2,k3)
      s24 = dot(k2,k4)
      s34 = dot(k3,k4)

      CI = (0D0, 1D0)
      PROPZ12 = 1d0/(dot(k1+k2,k1+k2)-MZSQ+CI*WZ*MZ)
      PROPZ34 = 1d0/(dot(k3+k4,k3+k4)-MZSQ+CI*WZ*MZ)

      PROPZ12C= 1d0/(dot(k1+k2,k1+k2)-MZSQ-CI*WZ*MZ)
      PROPZ34C= 1d0/(dot(k3+k4,k3+k4)-MZSQ-CI*WZ*MZ)

*      eps1234 = EPS4(k1,k2,k3,k4)
      eps1234 = CI*epsfun(k1,k2,k3,k4) ! in Hto4l


      MSQSM =
     &  + CASQ**2*couplsm * ( 32*s14*s23*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C + 32*s13*s24*PropZ12*PropZ34*PropZ12C*PropZ34C )
      MSQSM = MSQSM + CVSQ*CASQ*couplsm * (  - 64*s14*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 192*s13*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQSM = MSQSM + CVSQ**2*couplsm * ( 32*s14*s23*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 32*s13*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C )

      MSQBSM =
     &  + mzsq**(-2)*couplsm*NPSQ*tCaa**2 * (  - s12**(-2)*s14**2*
     &    s23**2*s34**(-2)*cw**4*sw**8 + 2*s12**(-2)*s13*s14*s23*s24*
     &    s34**(-2)*cw**4*sw**8 - s12**(-2)*s13**2*s24**2*s34**(-2)*
     &    cw**4*sw**8 + 1./2.*s12**(-1)*s24**2*s34**(-1)*cw**4*sw**8 + 
     &    1./2.*s12**(-1)*s23**2*s34**(-1)*cw**4*sw**8 + s12**(-1)*s14*
     &    s23*s34**(-1)*cw**4*sw**8 + 1./2.*s12**(-1)*s14**2*s34**(-1)*
     &    cw**4*sw**8 + s12**(-1)*s13*s24*s34**(-1)*cw**4*sw**8 + 1./2.
     &    *s12**(-1)*s13**2*s34**(-1)*cw**4*sw**8 - cw**4*sw**8 )
      MSQBSM = MSQBSM + CVA*mzsq**(-1)*couplsm*NP*tCaa*CI * (  - 4*
     &    s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C
     &     + 4*s12**(-1)*s14*s23*s24*s34**(-1)*cw**2*sw**4*PropZ12*
     &    PropZ34 + 4*s12**(-1)*s13*s24**2*s34**(-1)*cw**2*sw**4*
     &    PropZ12C*PropZ34C - 4*s12**(-1)*s13*s24**2*s34**(-1)*cw**2*
     &    sw**4*PropZ12*PropZ34 + 4*s12**(-1)*s13*s14*s23*s34**(-1)*
     &    cw**2*sw**4*PropZ12C*PropZ34C - 4*s12**(-1)*s13*s14*s23*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13**2*
     &    s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 4*s12**(-1)*
     &    s13**2*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 4*s24*
     &    cw**2*sw**4*PropZ12C*PropZ34C - 4*s24*cw**2*sw**4*PropZ12*
     &    PropZ34 - 4*s13*cw**2*sw**4*PropZ12C*PropZ34C + 4*s13*cw**2*
     &    sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*tCza**2 * (  - 4*
     &    s12**(-2)*s14**2*s23**2*sw**4*PropZ34*PropZ34C + 8*s12**(-2)*
     &    s13*s14*s23*s24*sw**4*PropZ34*PropZ34C - 4*s12**(-2)*s13**2*
     &    s24**2*sw**4*PropZ34*PropZ34C + 2*s12**(-1)*s24**2*s34*sw**4*
     &    PropZ34*PropZ34C + 2*s12**(-1)*s23**2*s34*sw**4*PropZ34*
     &    PropZ34C + 4*s12**(-1)*s14*s23*s34*sw**4*PropZ34*PropZ34C + 2
     &    *s12**(-1)*s14**2*s34*sw**4*PropZ34*PropZ34C + 4*s12**(-1)*
     &    s13*s24*s34*sw**4*PropZ34*PropZ34C + 2*s12**(-1)*s13**2*s34*
     &    sw**4*PropZ34*PropZ34C - 4*s34**2*sw**4*PropZ34*PropZ34C + 2*
     &    s24**2*sw**4*PropZ34*PropZ12C + 2*s24**2*sw**4*PropZ12*
     &    PropZ34C - 2*s23**2*sw**4*PropZ34*PropZ12C - 2*s23**2*sw**4*
     &    PropZ12*PropZ34C + 4*s14*s23*sw**4*PropZ34*PropZ12C + 4*s14*
     &    s23*sw**4*PropZ12*PropZ34C - 2*s14**2*sw**4*PropZ34*PropZ12C
     &     - 2*s14**2*sw**4*PropZ12*PropZ34C - 4*s14**2*s23**2*
     &    s34**(-2)*sw**4*PropZ12*PropZ12C - 4*s13*s24*sw**4*PropZ34*
     &    PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*tCza**2 * (  - 4*
     &    s13*s24*sw**4*PropZ12*PropZ34C + 8*s13*s14*s23*s24*s34**(-2)*
     &    sw**4*PropZ12*PropZ12C + 2*s13**2*sw**4*PropZ34*PropZ12C + 2*
     &    s13**2*sw**4*PropZ12*PropZ34C - 4*s13**2*s24**2*s34**(-2)*
     &    sw**4*PropZ12*PropZ12C + 2*s12*s24**2*s34**(-1)*sw**4*PropZ12
     &    *PropZ12C + 2*s12*s23**2*s34**(-1)*sw**4*PropZ12*PropZ12C + 4
     &    *s12*s14*s23*s34**(-1)*sw**4*PropZ12*PropZ12C + 2*s12*s14**2*
     &    s34**(-1)*sw**4*PropZ12*PropZ12C + 4*s12*s13*s24*s34**(-1)*
     &    sw**4*PropZ12*PropZ12C + 2*s12*s13**2*s34**(-1)*sw**4*PropZ12
     &    *PropZ12C - 4*s12**2*sw**4*PropZ12*PropZ12C )
      MSQBSM = MSQBSM + CASQ*mzsq**(-2)*couplsm*NPSQ*tCaa*tCzz * ( 2*
     &    s24**2*cw**2*sw**4*PropZ12C*PropZ34C + 2*s24**2*cw**2*sw**4*
     &    PropZ12*PropZ34 - 2*s23**2*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s23**2*cw**2*sw**4*PropZ12*PropZ34 + 4*s14*s23*cw**2*sw**4*
     &    PropZ12C*PropZ34C + 4*s14*s23*cw**2*sw**4*PropZ12*PropZ34 - 2
     &    *s14**2*cw**2*sw**4*PropZ12C*PropZ34C - 2*s14**2*cw**2*sw**4*
     &    PropZ12*PropZ34 - 4*s13*s24*cw**2*sw**4*PropZ12C*PropZ34C - 4
     &    *s13*s24*cw**2*sw**4*PropZ12*PropZ34 + 2*s13**2*cw**2*sw**4*
     &    PropZ12C*PropZ34C + 2*s13**2*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CASQ*mzsq**(-1)*eps1234*couplsm*NP*tCaa * (  - 
     &    2*s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s23*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s14*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s14*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-2)*couplsm*NPSQ*tCzz**2 * (  - 
     &    16*s14**2*s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s13*
     &    s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s13**2*
     &    s24**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 8*s12*s24**2*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 8*s12*s23**2*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 16*s12*s14*s23*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 8*s12*s14**2*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 16*s12*s13*s24*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 8*s12*s13**2*s34*PropZ12*PropZ34*PropZ12C
     &    *PropZ34C - 16*s12**2*s34**2*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C )
      MSQBSM = MSQBSM + CASQ**2*mzsq**(-1)*eps1234*couplsm*NP*tCzz * ( 
     &     - 16*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 16*s14*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C - 16*s13*PropZ12*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CASQ**2*couplsm * ( 32*s14*s23*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 32*s13*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*tCza**2 * (  - 4*
     &    s12**(-2)*s14**2*s23**2*sw**4*PropZ34*PropZ34C + 8*s12**(-2)*
     &    s13*s14*s23*s24*sw**4*PropZ34*PropZ34C - 4*s12**(-2)*s13**2*
     &    s24**2*sw**4*PropZ34*PropZ34C + 2*s12**(-1)*s24**2*s34*sw**4*
     &    PropZ34*PropZ34C + 2*s12**(-1)*s23**2*s34*sw**4*PropZ34*
     &    PropZ34C + 4*s12**(-1)*s14*s23*s34*sw**4*PropZ34*PropZ34C + 2
     &    *s12**(-1)*s14**2*s34*sw**4*PropZ34*PropZ34C - 4*s12**(-1)*
     &    s14**2*s23**2*s34**(-1)*sw**4*PropZ34*PropZ12C - 4*s12**(-1)*
     &    s14**2*s23**2*s34**(-1)*sw**4*PropZ12*PropZ34C + 4*s12**(-1)*
     &    s13*s24*s34*sw**4*PropZ34*PropZ34C + 8*s12**(-1)*s13*s14*s23*
     &    s24*s34**(-1)*sw**4*PropZ34*PropZ12C + 8*s12**(-1)*s13*s14*
     &    s23*s24*s34**(-1)*sw**4*PropZ12*PropZ34C + 2*s12**(-1)*s13**2
     &    *s34*sw**4*PropZ34*PropZ34C - 4*s12**(-1)*s13**2*s24**2*
     &    s34**(-1)*sw**4*PropZ34*PropZ12C - 4*s12**(-1)*s13**2*s24**2*
     &    s34**(-1)*sw**4*PropZ12*PropZ34C - 4*s34**2*sw**4*PropZ34*
     &    PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*tCza**2 * ( 2*
     &    s24**2*sw**4*PropZ34*PropZ12C + 2*s24**2*sw**4*PropZ12*
     &    PropZ34C + 2*s23**2*sw**4*PropZ34*PropZ12C + 2*s23**2*sw**4*
     &    PropZ12*PropZ34C + 4*s14*s23*sw**4*PropZ34*PropZ12C + 4*s14*
     &    s23*sw**4*PropZ12*PropZ34C + 2*s14**2*sw**4*PropZ34*PropZ12C
     &     + 2*s14**2*sw**4*PropZ12*PropZ34C - 4*s14**2*s23**2*
     &    s34**(-2)*sw**4*PropZ12*PropZ12C + 4*s13*s24*sw**4*PropZ34*
     &    PropZ12C + 4*s13*s24*sw**4*PropZ12*PropZ34C + 8*s13*s14*s23*
     &    s24*s34**(-2)*sw**4*PropZ12*PropZ12C + 2*s13**2*sw**4*PropZ34
     &    *PropZ12C + 2*s13**2*sw**4*PropZ12*PropZ34C - 4*s13**2*s24**2
     &    *s34**(-2)*sw**4*PropZ12*PropZ12C - 4*s12*s34*sw**4*PropZ34*
     &    PropZ12C - 4*s12*s34*sw**4*PropZ12*PropZ34C + 2*s12*s24**2*
     &    s34**(-1)*sw**4*PropZ12*PropZ12C + 2*s12*s23**2*s34**(-1)*
     &    sw**4*PropZ12*PropZ12C + 4*s12*s14*s23*s34**(-1)*sw**4*
     &    PropZ12*PropZ12C + 2*s12*s14**2*s34**(-1)*sw**4*PropZ12*
     &    PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*tCza**2 * ( 4*s12*
     &    s13*s24*s34**(-1)*sw**4*PropZ12*PropZ12C + 2*s12*s13**2*
     &    s34**(-1)*sw**4*PropZ12*PropZ12C - 4*s12**2*sw**4*PropZ12*
     &    PropZ12C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*tCaa*tCzz * (  - 4
     &    *s12**(-1)*s14**2*s23**2*s34**(-1)*cw**2*sw**4*PropZ12C*
     &    PropZ34C - 4*s12**(-1)*s14**2*s23**2*s34**(-1)*cw**2*sw**4*
     &    PropZ12*PropZ34 + 8*s12**(-1)*s13*s14*s23*s24*s34**(-1)*cw**2
     &    *sw**4*PropZ12C*PropZ34C + 8*s12**(-1)*s13*s14*s23*s24*
     &    s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 4*s12**(-1)*s13**2*
     &    s24**2*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 4*s12**(-1)*
     &    s13**2*s24**2*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s24**2*cw**2*sw**4*PropZ12C*PropZ34C + 2*s24**2*cw**2*sw**4*
     &    PropZ12*PropZ34 + 2*s23**2*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s23**2*cw**2*sw**4*PropZ12*PropZ34 + 4*s14*s23*cw**2*sw**4*
     &    PropZ12C*PropZ34C + 4*s14*s23*cw**2*sw**4*PropZ12*PropZ34 + 2
     &    *s14**2*cw**2*sw**4*PropZ12C*PropZ34C + 2*s14**2*cw**2*sw**4*
     &    PropZ12*PropZ34 + 4*s13*s24*cw**2*sw**4*PropZ12C*PropZ34C + 4
     &    *s13*s24*cw**2*sw**4*PropZ12*PropZ34 + 2*s13**2*cw**2*sw**4*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-2)*couplsm*NPSQ*tCaa*tCzz * ( 2*
     &    s13**2*cw**2*sw**4*PropZ12*PropZ34 - 4*s12*s34*cw**2*sw**4*
     &    PropZ12C*PropZ34C - 4*s12*s34*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*mzsq**(-1)*eps1234*couplsm*NP*tCaa * (  - 
     &    2*s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s24*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s12**(-1)*s23*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s23*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 + 2*
     &    s12**(-1)*s14*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C + 2*
     &    s12**(-1)*s14*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 - 2*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12C*PropZ34C - 2*
     &    s12**(-1)*s13*s34**(-1)*cw**2*sw**4*PropZ12*PropZ34 )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-2)*couplsm*NPSQ*tCzz**2 * ( 
     &     - 32*s14**2*s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 64*
     &    s13*s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 32*s13**2
     &    *s24**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 48*s12*s24**2*s34
     &    *PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s23**2*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 96*s12*s14*s23*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s12*s14**2*s34*PropZ12
     &    *PropZ34*PropZ12C*PropZ34C - 32*s12*s13*s24*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 48*s12*s13**2*s34*PropZ12*PropZ34
     &    *PropZ12C*PropZ34C - 32*s12**2*s34**2*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ*CASQ*mzsq**(-1)*eps1234*couplsm*NP*tCzz
     &  * (  - 96*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 32*s23*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C - 32*s14*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C - 96*s13*PropZ12*PropZ34*PropZ12C*PropZ34C
     &     )
      MSQBSM = MSQBSM + CVSQ*CASQ*couplsm * (  - 64*s14*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 192*s13*s24*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-2)*couplsm*NPSQ*tCzz**2 * (  - 
     &    16*s14**2*s23**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 32*s13*
     &    s14*s23*s24*PropZ12*PropZ34*PropZ12C*PropZ34C - 16*s13**2*
     &    s24**2*PropZ12*PropZ34*PropZ12C*PropZ34C + 8*s12*s24**2*s34*
     &    PropZ12*PropZ34*PropZ12C*PropZ34C + 8*s12*s23**2*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 16*s12*s14*s23*s34*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 8*s12*s14**2*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 16*s12*s13*s24*s34*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 8*s12*s13**2*s34*PropZ12*PropZ34*PropZ12C
     &    *PropZ34C - 16*s12**2*s34**2*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*mzsq**(-1)*eps1234*couplsm*NP*tCzz * ( 
     &     - 16*s24*PropZ12*PropZ34*PropZ12C*PropZ34C + 16*s23*PropZ12*
     &    PropZ34*PropZ12C*PropZ34C + 16*s14*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C - 16*s13*PropZ12*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CVSQ**2*couplsm * ( 32*s14*s23*PropZ12*PropZ34*
     &    PropZ12C*PropZ34C + 32*s13*s24*PropZ12*PropZ34*PropZ12C*
     &    PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NP*tCza*CI * ( 4*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NP*tCza*CI * (  - 4*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*s24*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s24*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C - 4*s23*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 4*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s14*s34*sw**2
     &    *PropZ34*PropZ12C*PropZ34C - 4*s14*s34*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s14*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s13*
     &    s34*sw**2*PropZ12*PropZ34*PropZ34C - 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s24**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CASQ*mzsq**(-1)*couplsm*NP*tCza*CI * (  - 4*
     &    s13*s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13
     &    *s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s13*s14
     &    *s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*s14*
     &    s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s12*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 4*s12*s24*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 4*s12*s23*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12*
     &    s23*sw**2*PropZ12*PropZ34*PropZ12C - 4*s12*s14*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s12*s14*sw**2*PropZ12*PropZ34*PropZ12C
     &     + 4*s12*s13*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12*s13*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NP*tCza*CI * ( 12*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 12*
     &    s12**(-1)*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s14*s23**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s14**2*s23*sw**2*PropZ12*PropZ34*PropZ34C - 12*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C + 12*
     &    s12**(-1)*s13*s24**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*
     &    s12**(-1)*s13*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 4*
     &    s12**(-1)*s13*s14*s24*sw**2*PropZ12*PropZ34*PropZ34C - 12*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ34*PropZ12C*PropZ34C + 12*
     &    s12**(-1)*s13*s14*s23*sw**2*PropZ12*PropZ34*PropZ34C + 12*
     &    s12**(-1)*s13**2*s24*sw**2*PropZ34*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NP*tCza*CI * (  - 12
     &    *s12**(-1)*s13**2*s24*sw**2*PropZ12*PropZ34*PropZ34C - 12*s24
     &    *s34*sw**2*PropZ34*PropZ12C*PropZ34C + 12*s24*s34*sw**2*
     &    PropZ12*PropZ34*PropZ34C + 4*s23*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 4*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C - 4*s14*
     &    s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s14*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C + 12*s14*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 12*s14*s23*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s14*s23**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s14**2*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 12*s13*s34*sw**2*PropZ34*PropZ12C*PropZ34C
     &     - 12*s13*s34*sw**2*PropZ12*PropZ34*PropZ34C - 12*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s13*s24**2*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CA*CVSQ*mzsq**(-1)*couplsm*NP*tCza*CI * ( 4*s13
     &    *s23*s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s13*
     &    s23*s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13*s14*
     &    s24*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s14*s24
     &    *s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 12*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s13*s14*s23*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 12*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 12*s13**2*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 12*s12*s24*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 12*s12*s24*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 4*s12*s23*sw**2*PropZ12*PropZ12C*PropZ34C + 4*s12*
     &    s23*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s14*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s12*s14*sw**2*PropZ12*PropZ34*PropZ12C
     &     + 12*s12*s13*sw**2*PropZ12*PropZ12C*PropZ34C - 12*s12*s13*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*tCaa*tCza * ( 2*
     &    s12**(-2)*s14**2*s23**2*s34**(-1)*cw**2*sw**6*PropZ34C + 2*
     &    s12**(-2)*s14**2*s23**2*s34**(-1)*cw**2*sw**6*PropZ34 - 4*
     &    s12**(-2)*s13*s14*s23*s24*s34**(-1)*cw**2*sw**6*PropZ34C - 4*
     &    s12**(-2)*s13*s14*s23*s24*s34**(-1)*cw**2*sw**6*PropZ34 + 2*
     &    s12**(-2)*s13**2*s24**2*s34**(-1)*cw**2*sw**6*PropZ34C + 2*
     &    s12**(-2)*s13**2*s24**2*s34**(-1)*cw**2*sw**6*PropZ34 - 
     &    s12**(-1)*s24**2*cw**2*sw**6*PropZ34C - s12**(-1)*s24**2*
     &    cw**2*sw**6*PropZ34 - s12**(-1)*s23**2*cw**2*sw**6*PropZ34C
     &     - s12**(-1)*s23**2*cw**2*sw**6*PropZ34 - 2*s12**(-1)*s14*s23
     &    *cw**2*sw**6*PropZ34C - 2*s12**(-1)*s14*s23*cw**2*sw**6*
     &    PropZ34 - s12**(-1)*s14**2*cw**2*sw**6*PropZ34C - s12**(-1)*
     &    s14**2*cw**2*sw**6*PropZ34 + 2*s12**(-1)*s14**2*s23**2*
     &    s34**(-2)*cw**2*sw**6*PropZ12C + 2*s12**(-1)*s14**2*s23**2*
     &    s34**(-2)*cw**2*sw**6*PropZ12 - 2*s12**(-1)*s13*s24*cw**2*
     &    sw**6*PropZ34C )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*tCaa*tCza * (  - 2*
     &    s12**(-1)*s13*s24*cw**2*sw**6*PropZ34 - 4*s12**(-1)*s13*s14*
     &    s23*s24*s34**(-2)*cw**2*sw**6*PropZ12C - 4*s12**(-1)*s13*s14*
     &    s23*s24*s34**(-2)*cw**2*sw**6*PropZ12 - s12**(-1)*s13**2*
     &    cw**2*sw**6*PropZ34C - s12**(-1)*s13**2*cw**2*sw**6*PropZ34
     &     + 2*s12**(-1)*s13**2*s24**2*s34**(-2)*cw**2*sw**6*PropZ12C
     &     + 2*s12**(-1)*s13**2*s24**2*s34**(-2)*cw**2*sw**6*PropZ12 + 
     &    2*s34*cw**2*sw**6*PropZ34C + 2*s34*cw**2*sw**6*PropZ34 - 
     &    s24**2*s34**(-1)*cw**2*sw**6*PropZ12C - s24**2*s34**(-1)*
     &    cw**2*sw**6*PropZ12 - s23**2*s34**(-1)*cw**2*sw**6*PropZ12C
     &     - s23**2*s34**(-1)*cw**2*sw**6*PropZ12 - 2*s14*s23*s34**(-1)
     &    *cw**2*sw**6*PropZ12C - 2*s14*s23*s34**(-1)*cw**2*sw**6*
     &    PropZ12 - s14**2*s34**(-1)*cw**2*sw**6*PropZ12C - s14**2*
     &    s34**(-1)*cw**2*sw**6*PropZ12 - 2*s13*s24*s34**(-1)*cw**2*
     &    sw**6*PropZ12C - 2*s13*s24*s34**(-1)*cw**2*sw**6*PropZ12 - 
     &    s13**2*s34**(-1)*cw**2*sw**6*PropZ12C )
      MSQBSM = MSQBSM + CV*mzsq**(-2)*couplsm*NPSQ*tCaa*tCza * (  - 
     &    s13**2*s34**(-1)*cw**2*sw**6*PropZ12 + 2*s12*cw**2*sw**6*
     &    PropZ12C + 2*s12*cw**2*sw**6*PropZ12 )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*tCza*tCzz * ( 8
     &    *s12**(-1)*s14**2*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C + 8*
     &    s12**(-1)*s14**2*s23**2*sw**2*PropZ12*PropZ34*PropZ34C - 16*
     &    s12**(-1)*s13*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 
     &    16*s12**(-1)*s13*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C
     &     + 8*s12**(-1)*s13**2*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 8*s12**(-1)*s13**2*s24**2*sw**2*PropZ12*PropZ34*PropZ34C
     &     - 12*s24**2*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 12*s24**2*
     &    s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*s23**2*s34*sw**2*
     &    PropZ34*PropZ12C*PropZ34C + 4*s23**2*s34*sw**2*PropZ12*
     &    PropZ34*PropZ34C - 24*s14*s23*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 24*s14*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C + 4*
     &    s14**2*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s14**2*s34*
     &    sw**2*PropZ12*PropZ34*PropZ34C + 8*s14**2*s23**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 8*s14**2*s23**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*tCza*tCzz * ( 8
     &    *s13*s24*s34*sw**2*PropZ34*PropZ12C*PropZ34C + 8*s13*s24*s34*
     &    sw**2*PropZ12*PropZ34*PropZ34C - 16*s13*s14*s23*s24*s34**(-1)
     &    *sw**2*PropZ12*PropZ12C*PropZ34C - 16*s13*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 12*s13**2*s34*
     &    sw**2*PropZ34*PropZ12C*PropZ34C - 12*s13**2*s34*sw**2*PropZ12
     &    *PropZ34*PropZ34C + 8*s13**2*s24**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 8*s13**2*s24**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 8*s12*s34**2*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 8*s12*s34**2*sw**2*PropZ12*PropZ34*PropZ34C - 12*
     &    s12*s24**2*sw**2*PropZ12*PropZ12C*PropZ34C - 12*s12*s24**2*
     &    sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s23**2*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 4*s12*s23**2*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 24*s12*s14*s23*sw**2*PropZ12*PropZ12C*PropZ34C - 
     &    24*s12*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C + 4*s12*s14**2*
     &    sw**2*PropZ12*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-2)*couplsm*NPSQ*tCza*tCzz * ( 4
     &    *s12*s14**2*sw**2*PropZ12*PropZ34*PropZ12C + 8*s12*s13*s24*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 8*s12*s13*s24*sw**2*PropZ12
     &    *PropZ34*PropZ12C - 12*s12*s13**2*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 12*s12*s13**2*sw**2*PropZ12*PropZ34*PropZ12C + 8*
     &    s12**2*s34*sw**2*PropZ12*PropZ12C*PropZ34C + 8*s12**2*s34*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CASQ*mzsq**(-1)*eps1234*couplsm*NP*tCza * ( 
     &    12*s12**(-1)*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 12*
     &    s12**(-1)*s24*sw**2*PropZ12*PropZ34*PropZ34C + 4*s12**(-1)*
     &    s23*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s12**(-1)*s23*sw**2*
     &    PropZ12*PropZ34*PropZ34C + 4*s12**(-1)*s14*sw**2*PropZ34*
     &    PropZ12C*PropZ34C + 4*s12**(-1)*s14*sw**2*PropZ12*PropZ34*
     &    PropZ34C + 12*s12**(-1)*s13*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 12*s12**(-1)*s13*sw**2*PropZ12*PropZ34*PropZ34C + 12*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s24*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C + 4*s23*s34**(-1)*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 4*s23*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 4*s14*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C + 4*s14*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 
     &    12*s13*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C + 12*s13*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*tCza*tCzz * ( 8
     &    *s12**(-1)*s14**2*s23**2*sw**2*PropZ34*PropZ12C*PropZ34C + 8*
     &    s12**(-1)*s14**2*s23**2*sw**2*PropZ12*PropZ34*PropZ34C - 16*
     &    s12**(-1)*s13*s14*s23*s24*sw**2*PropZ34*PropZ12C*PropZ34C - 
     &    16*s12**(-1)*s13*s14*s23*s24*sw**2*PropZ12*PropZ34*PropZ34C
     &     + 8*s12**(-1)*s13**2*s24**2*sw**2*PropZ34*PropZ12C*PropZ34C
     &     + 8*s12**(-1)*s13**2*s24**2*sw**2*PropZ12*PropZ34*PropZ34C
     &     - 4*s24**2*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s24**2*
     &    s34*sw**2*PropZ12*PropZ34*PropZ34C - 4*s23**2*s34*sw**2*
     &    PropZ34*PropZ12C*PropZ34C - 4*s23**2*s34*sw**2*PropZ12*
     &    PropZ34*PropZ34C - 8*s14*s23*s34*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 8*s14*s23*s34*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s14**2*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 4*s14**2*s34*
     &    sw**2*PropZ12*PropZ34*PropZ34C + 8*s14**2*s23**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 8*s14**2*s23**2*s34**(-1)*
     &    sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*tCza*tCzz * ( 
     &     - 8*s13*s24*s34*sw**2*PropZ34*PropZ12C*PropZ34C - 8*s13*s24*
     &    s34*sw**2*PropZ12*PropZ34*PropZ34C - 16*s13*s14*s23*s24*
     &    s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 16*s13*s14*s23*
     &    s24*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4*s13**2*s34*
     &    sw**2*PropZ34*PropZ12C*PropZ34C - 4*s13**2*s34*sw**2*PropZ12*
     &    PropZ34*PropZ34C + 8*s13**2*s24**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ12C*PropZ34C + 8*s13**2*s24**2*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C + 8*s12*s34**2*sw**2*PropZ34*PropZ12C*
     &    PropZ34C + 8*s12*s34**2*sw**2*PropZ12*PropZ34*PropZ34C - 4*
     &    s12*s24**2*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s12*s24**2*
     &    sw**2*PropZ12*PropZ34*PropZ12C - 4*s12*s23**2*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s12*s23**2*sw**2*PropZ12*PropZ34*
     &    PropZ12C - 8*s12*s14*s23*sw**2*PropZ12*PropZ12C*PropZ34C - 8*
     &    s12*s14*s23*sw**2*PropZ12*PropZ34*PropZ12C - 4*s12*s14**2*
     &    sw**2*PropZ12*PropZ12C*PropZ34C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-2)*couplsm*NPSQ*tCza*tCzz * ( 
     &     - 4*s12*s14**2*sw**2*PropZ12*PropZ34*PropZ12C - 8*s12*s13*
     &    s24*sw**2*PropZ12*PropZ12C*PropZ34C - 8*s12*s13*s24*sw**2*
     &    PropZ12*PropZ34*PropZ12C - 4*s12*s13**2*sw**2*PropZ12*
     &    PropZ12C*PropZ34C - 4*s12*s13**2*sw**2*PropZ12*PropZ34*
     &    PropZ12C + 8*s12**2*s34*sw**2*PropZ12*PropZ12C*PropZ34C + 8*
     &    s12**2*s34*sw**2*PropZ12*PropZ34*PropZ12C )
      MSQBSM = MSQBSM + CV*CVSQ*mzsq**(-1)*eps1234*couplsm*NP*tCza * ( 
     &    4*s12**(-1)*s24*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s12**(-1)
     &    *s24*sw**2*PropZ12*PropZ34*PropZ34C - 4*s12**(-1)*s23*sw**2*
     &    PropZ34*PropZ12C*PropZ34C - 4*s12**(-1)*s23*sw**2*PropZ12*
     &    PropZ34*PropZ34C - 4*s12**(-1)*s14*sw**2*PropZ34*PropZ12C*
     &    PropZ34C - 4*s12**(-1)*s14*sw**2*PropZ12*PropZ34*PropZ34C + 4
     &    *s12**(-1)*s13*sw**2*PropZ34*PropZ12C*PropZ34C + 4*s12**(-1)*
     &    s13*sw**2*PropZ12*PropZ34*PropZ34C + 4*s24*s34**(-1)*sw**2*
     &    PropZ12*PropZ12C*PropZ34C + 4*s24*s34**(-1)*sw**2*PropZ12*
     &    PropZ34*PropZ12C - 4*s23*s34**(-1)*sw**2*PropZ12*PropZ12C*
     &    PropZ34C - 4*s23*s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C - 4
     &    *s14*s34**(-1)*sw**2*PropZ12*PropZ12C*PropZ34C - 4*s14*
     &    s34**(-1)*sw**2*PropZ12*PropZ34*PropZ12C + 4*s13*s34**(-1)*
     &    sw**2*PropZ12*PropZ12C*PropZ34C + 4*s13*s34**(-1)*sw**2*
     &    PropZ12*PropZ34*PropZ12C )

