      subroutine matrixelement(p1,p2,p3,p4,qph,ng,emtx2)
      implicit none
      integer ng
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      double precision emtx2,sf,emtx2born,bornIBA,sv,born
      double precision qph(40,0:3),qtmp(0:3)
      double precision emtx2app,tmp,matelem
      double precision charges(4),eps(4),approx,exact
      double precision alpha0,alphaGF,alpha
      common/alphas/alpha0,alphaGF,alpha
      integer imode
      common/imode/imode
      common/charges/charges
      data charges/-1.d0,-1.d0,-1.d0,-1.d0/
      double precision soft_integral,emtx2v,soft_L
      external soft_integral,soft_L
      integer nphotmode
      common/nphotMODE/nphotmode
      double precision dot
      external dot

      double precision phmass,egmin
      COMMON/INFRAR/phmass,egmin

      integer ifirst,k
      common/melemcommon/ifirst
      data ifirst /0/

      if (imode.lt.30) then
         if (ng.ge.1) then
            call newrad(p1,p2,p3,p4,qph(1,:),emtx2)           
         else
            call virtualplussoft(p1,p2,p3,p4,emtx2v,emtx2born,bornIBA)
            emtx2 = bornIBA + emtx2v ! + sf
         endif
      else
         if (ng.ge.1) then            
            call PSradimproved(p1,p2,p3,p4,ng,qph,emtx2)
         else                   ! 0 photons
            eps(1)=egmin/p1(0)
            eps(2)=egmin/p2(0)
            eps(3)=egmin/p3(0)
            eps(4)=egmin/p4(0)
            sf = soft_L(eps,p1,p2,p3,p4)

            if (imode.le.33) then
               sv = 1.d0 -sf

c               call virtualplussoft(p1,p2,p3,p4,emtx2v,born,bornIBA)
c               print*,-sf*born-emtx2v
c               stop
c               sv = 1.d0 + emtx2v/born
               
               call newborn(p1,p2,p3,p4,born,bornIBA)
            else
               sv = exp(-sf)
               if (imode.lt.37) then ! ie. 34 <= imode <= 36
                  call newborn(p1,p2,p3,p4,born,bornIBA)
               elseif (imode.ge.37) then
                  call virtualplussoft(p1,p2,p3,p4,emtx2v,born,bornIBA)
! approx
                  approx = -born*sf
!calculating the SV correction factor !!
! exact
c                  sf   = soft_integral(phmass,egmin,p1,p2,p3,p4,charges)
c                  sf   = sf * born
                  exact = emtx2v ! + sf
! matching!
                  sv = sv * (1.d0 + (exact-approx)/born)
               endif               
            endif
            emtx2 = bornIBA * sv
         endif
      endif
      return
      end

******************************************************************************************
      subroutine PSradimproved(p1,p2,p3,p4,ng,qph,emtx2)
      implicit none
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      double precision p1s(0:3),p2s(0:3),p3s(0:3),p4s(0:3)
      double precision p1p(0:3),p2p(0:3),p3p(0:3),p4p(0:3)
      double precision p1v(0:3),p2v(0:3),p3v(0:3),p4v(0:3)
      double precision p1t(0:3),p2t(0:3),p3t(0:3),p4t(0:3)
      double precision emtx2,fh,fhk,matelem
      double precision qph(40,0:3),q(0:3),qp(0:3)
      double precision peik(0:3),peik1(0:3),peik2(0:3)
      double precision oop1dq,oop2dq,oop3dq,oop4dq
      double precision eikonal,eps(4),eikonalk
      double precision emax12,emax34,emax14,emax23,emax
      double precision emax1,emax2,emax3,emax4,omx
      double precision apx,x,apxk,test1,test2
      integer ng,i,k,j,itest,itmp,ie,ii,iimax
      double precision x1,x2,x3,x4,dH,dV
      double precision apx1,apx2,apx3,apx4,sv,emxr,vapprox(4)
      double precision born,bornIBA,bornC,bornIBAC,emtx2v
      double precision approx,exact,bornk,bornibak
      double precision alpha0,alphaGF,alpha,pi,eikfake
      common/alphas/alpha0,alphaGF,alpha

      double precision rescaleQED
      common/QEDrescale/rescaleQED

      parameter (pi = 3.1415926535897932384626433832795029D0)
      integer iclose(ng),iclosetmp(1),iclosek
      double precision vfhk(2)
      integer iclosecomm(40),viclosek(2)
      common/iclosecomm/iclosecomm

      double precision mz1,mz2
      integer nphleg(4)
      common/eikcheck/mz1,mz2,nphleg

      integer    nmaxph
      parameter (nmaxph = 50)
      integer idiag(nmaxph)
      common/resonantdiagrams/idiag

      integer idpart
      common/identicalparticles/idpart

      double precision phmass,egmin
      COMMON/INFRAR/phmass,egmin

      integer iswitchforidpart
      common/switch24/iswitchforidpart
      integer imode
      common/imode/imode
      
      double precision charges(4)
      common/lcharges/charges
      data charges/-1.d0,-1.d0,-1.d0,-1.d0/

**** from maptoone
      integer iclosekfm1
      common/iclosekfrommp1/iclosekfm1
****

      double precision factorial,dot,soft_L,sf,soft_integral,bw
      double precision tridot
      external factorial,dot,soft_L,soft_integral,bw,tridot

      eikonal = 1.d0

ccc      call madinterface2ph(p1,p2,p3,p4,qph(1:ng,:),matelem)

      call maptozeroNG(ng,p1,p2,p3,p4,qph(1:ng,:),p1p,p2p,p3p,p4p,
     .     p1v,p2v,p3v,p4v,iclose)

      call newborn(p1p,p2p,p3p,p4p,born,bornIBA)

      iclosecomm(1:ng) = iclose


c      if (ng.eq.1.and.imode.ge.37) then
c         call newrad(p1,p2,p3,p4,qph(1,:),emxr)
c      else
      emax1 = p1(0)
      emax2 = p2(0)
      emax3 = p3(0)
      emax4 = p4(0)
      do k = 1,ng
         q = qph(k,:)
         if (iclose(k).eq.1) emax1 = emax1 + q(0)
         if (iclose(k).eq.2) emax2 = emax2 + q(0)
         if (iclose(k).eq.3) emax3 = emax3 + q(0)
         if (iclose(k).eq.4) emax4 = emax4 + q(0)
      enddo
      
      call eikonalWITHBORN_POLNG(ng,p1,p2,p3,p4,qph(1:ng,:),
     .     p1p,p2p,p3p,p4p,eikonal)
      
      apx = 1.d0
      do k = 1,ng
         if (iclose(k).eq.1) then
            emax  = emax1
            emax1 = emax1 - qph(k,0)
         endif
         if (iclose(k).eq.2) then
            emax  = emax2
            emax2 = emax2 - qph(k,0)
         endif
         if (iclose(k).eq.3) then
            emax  = emax3
            emax3 = emax3 - qph(k,0)
         endif
         if (iclose(k).eq.4) then
            emax  = emax4
            emax4 = emax4 - qph(k,0)
         endif
         x = qph(k,0)/emax
c     default            apx = apx*(1.d0 + (1.d0-x)**2)/x/(1.d0-x)/emax/2.d0*qph(k,0)
         apx = apx*(1.d0 + (1.d0-x)**2)/(1.d0-x)/2.d0
      enddo
c      endif

****** calculating real corrections
      fh = 1.d0
*******************************
c      apx = 1.d0
******************************

c      if (imode.ge.37.and.ng.ne.1) then
      if (imode.ge.37) then
         if (ng.eq.1) then
            call newrad(p1,p2,p3,p4,qph(1,:),emxr)
            approx = eikonal * apx
            fh = 1.d0 + (emxr - approx)/approx
            ie = 0
         else
            do k = 1,ng
               fhk = 1.d0       ! initializing!!
               
               call maptooneNG(ng,k,iclose,p1v,p2v,p3v,p4v,
     .              p1,p2,p3,p4,qph(1:ng,:),p1p,p2p,p3p,p4p,
     .              p1t,p2t,p3t,p4t,p1s,p2s,p3s,p4s,q,ie)
               
               if (ie.eq.1) goto 666
               
               call newrad(p1s,p2s,p3s,p4s,q,emxr)
               
               call eikonalWITHBORN_POLNG(1,p1s,p2s,p3s,p4s,qph(k,:),
     .              p1t,p2t,p3t,p4t,eikonalk)
               
               viclosek(1) = iclose(k)
               viclosek(2) = iclosekfm1 ! from the common block
!     trick to optimize variance...
               iimax = 2
               do ii = 1,iimax
                  if (viclosek(ii).eq.1) then
                     emax  = p1s(0)+q(0)
                  endif
                  if (viclosek(ii).eq.2) then
                     emax  = p2s(0)+q(0)
                  endif
                  if (viclosek(ii).eq.3) then
                     emax  = p3s(0)+q(0)
                  endif
                  if (viclosek(ii).eq.4) then
                     emax  = p4s(0)+q(0)
                  endif
                  omx = 1.d0-q(0)/emax
c     apxk = (1.d0 + (1.d0-x)**2)/x/(1.d0-x)/emax/2.d0*q(0)
                  apxk = (1.d0 + omx*omx)/omx/2.d0
                  approx = eikonalk * apxk               
                  vfhk(ii) = 1.d0 + (emxr-approx)/approx
               enddo
               fhk = vfhk(1)
c     if (idpart.eq.1) then
               if (abs(vfhk(2)).lt.abs(vfhk(1))) fhk = vfhk(2)
c     endif
c     fhk = minval(vfhk)

 666        fh = fh*fhk

         enddo
         endif
      endif
***************************
      dH = fh - 1.d0

      sv = 1.d0
      dV = 0.d0

ccc      goto 321
      
      if (imode.ge.34) then 
         eps(1) = egmin/p1p(0)
         eps(2) = egmin/p2p(0)
         eps(3) = egmin/p3p(0)
         eps(4) = egmin/p4p(0)
         sf = soft_L(eps,p1,p2,p3,p4) ! using the original momenta is crucial for eps indip! ???
         sv = exp(-sf)

         if (imode.ge.37) then
            call virtualplussoft(p1p,p2p,p3p,p4p,emtx2v,bornC,bornIBAC)
c            sf    = soft_integral(phmass,egmin,p1p,p2p,p3p,p4p,charges)
c            sf    = sf * bornC
            exact = emtx2v ! + sf
! approx
            sf = -soft_L(eps,p1p,p2p,p3p,p4p)
            approx = bornC*sf
! matching!
            dV = (exact-approx)/bornC

         endif
      endif

 321  continue

c      if (ng.eq.1.and.imode.ge.37) then
c         emtx2 = emxr * sv * (1.d0 + dV) !!!! WARNING!!! IT DOESNT WORK WITH IBA!!!!
c         return
c      endif

c      emtx2 = eikonal * apx * sv * (1.d0+dH) * (1.d0 + dV)
      emtx2 = eikonal * apx * sv * (1.d0 + dH + dV + dH*dV)

c      print*,emtx2/matelem/rescaleQED/rescaleQED

c      if (ng.eq.1) then
c         print*,sv,emtx2
c         print*,eikonal*apx*(1.d0+dH)/emxr,eikonal*apx*(1.d0+dH),emxr,ie
c         stop
c      endif

      return
      end

*******************************************************************
      subroutine eikonalWITHBORN_POLNG(ng,p1,p2,p3,p4,qph,
     .     p1b,p2b,p3b,p4b,eikfact)
      implicit double precision (a-h,m,o-z)

      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      dimension p1b(0:3),p2b(0:3),p3b(0:3),p4b(0:3)
      dimension qph(ng,0:3),q(0:3)
      dimension p12(0:3),p34(0:3),pz1(0:3),pz2(0:3)
      dimension p14(0:3),p23(0:3),pz12(0:3),pz34(0:3)
      dimension pz14(0:3),pz23(0:3)
      dimension collt(4,ng,0:3),coll(4,ng)
      dimension colleps(2,4,ng)
      dimension pt(0:3,4)
      double precision e1(0:3),e2(0:3)
      double complex bw,eikc1,eikc2,bw1234,bw1423
      double complex eikc(2**ng)
      double complex eikctmp,eikctmp1,eikctmp2
      double complex den(0:3,ng)
      double complex cover
      double complex bhel1234,bhel1423,bhel
      double complex ccel(0:3),ccmu(0:3)
      double complex spin1(2,4),spin2(2,4),spin3(2,4),spin4(2,4)
      integer   h1,h2,h3,h4,hh
      integer   pow2(0:ng)
      double complex zm2c

      common/identicalparticles/idpart

      common/POLNGWITHBORN/zm2c,zm2,zmw,cover,ifirst
      data ifirst /0/

      integer imode
      common/imode/imode

#include "couplingandmasses.h"

#ifdef _OPENMP      
      include 'omp_lib.h'
#endif
      
      if (ifirst.eq.0) then
         zm2  = zmass*zmass
         zmw  = zmass*zwidth
         zm2c = zm2 - im*zmw

         cover = g*conjg(g) 
     .         * g*conjg(g) 
     .         * CHZZ*conjg(CHZZ)         

         ifirst = 1
      endif

      pow2(0) = 1
      do k = 1,ng
         pow2(k)      =  pow2(k-1)*2
         call get_eps(qph(k,:),e1,e2)
         colleps(1,1,k)=-dot(p1,e1)/dot(p1,qph(k,:))
         colleps(1,2,k)= dot(p2,e1)/dot(p2,qph(k,:))
         colleps(1,3,k)=-dot(p3,e1)/dot(p3,qph(k,:))
         colleps(1,4,k)= dot(p4,e1)/dot(p4,qph(k,:))
         colleps(2,1,k)=-dot(p1,e2)/dot(p1,qph(k,:))
         colleps(2,2,k)= dot(p2,e2)/dot(p2,qph(k,:))
         colleps(2,3,k)=-dot(p3,e2)/dot(p3,qph(k,:))
         colleps(2,4,k)= dot(p4,e2)/dot(p4,qph(k,:))
      enddo

! with mapped momenta is anyway the best choice
      call get_spinors(p1b,p2b,p3b,p4b,spin1,spin2,spin3,spin4)

      IF (idpart.eq.0) THEN
      p12 = p1+p2
      p34 = p3+p4
      eik = 0.d0

cc$omp  parallel
cc$omp& do private(bhel,ccel,ccmu,eikctmp,pz1,pz2,collprod,iz,ik,bw,
cc$omp& eikm2,h1,h2,h3,h4)
cc$omp& reduction(+:eik) 
c      do h1 = 1,2
c      do h2 = 1,2
c      do h3 = 1,2
c      do h4 = 1,2
      do hh = 0,15
      h1 = mod(hh,16)/8 + 1
      h2 = mod(hh, 8)/4 + 1
      h3 = mod(hh, 4)/2 + 1
      h4 = mod(hh, 2)   + 1

      call currents(gv,ga,spin1,spin2,spin3,spin4,h1,h2,h3,h4,
     .              ccel,ccmu)
      bhel= ( ccel(0)*ccmu(0)-ccel(1)*ccmu(1)
     .       -ccel(2)*ccmu(2)-ccel(3)*ccmu(3) )

      eikm2 = 0.d0
      do ie = 0,2**ng-1

         eikctmp = (0.d0,0.d0)
         do j = 0,2**ng-1
            pz1 = p12
            pz2 = p34
            collprod = 1.d0
            do k = 1,ng
               iz = mod(j,pow2(k)) / pow2(k-1) + 1
               ik = mod(ie,pow2(k)) / pow2(k-1) + 1
               if (iz.eq.1) then
                  pz1      = pz1 + qph(k,:)
                  collprod = collprod*(colleps(ik,1,k)+colleps(ik,2,k))
               else
                  pz2      = pz2 + qph(k,:)
                  collprod = collprod*(colleps(ik,3,k)+colleps(ik,4,k))
               endif
            enddo
c            bw  = 1.d0/(dot(pz1,pz1)-zm2c)/(dot(pz2,pz2)-zm2c)
            bw  = (dot(pz1,pz1)-zm2c)*(dot(pz2,pz2)-zm2c)
            bw  = 1.d0/bw
            eikctmp = eikctmp + collprod*bw * bhel
         enddo
         eikm2 = eikm2 + eikctmp*conjg(eikctmp)
c         eik = eik + eikctmp*conjg(eikctmp)
      enddo

      eik = eik + eikm2

c      enddo
c      enddo
c      enddo
c      enddo
      enddo !! hh do
cc$omp end parallel do
      
      ELSE !! FOR IDENTICAL PARTICLES

      p12 = p1+p2
      p34 = p3+p4
      p14 = p1+p4
      p23 = p2+p3
      eik = 0.d0
c      do h1 = 1,2
c      do h2 = 1,2
c      do h3 = 1,2
c      do h4 = 1,2
cc$omp  parallel
cc$omp  do private(eikctmp,pz12,pz34,pz14,pz23,
cc$omp& collprod1234,collprod1423,iz,ik,bw1234,bw1423,
cc$omp& h1,h2,h3,h4,bhel1234,bhel1423,ccel,ccmu,eikm2)
cc$omp& reduction(+:eik)
      do hh = 0,15
      h1 = mod(hh,16)/8 + 1
      h2 = mod(hh, 8)/4 + 1
      h3 = mod(hh, 4)/2 + 1
      h4 = mod(hh, 2)   + 1
         
      call currents(gv,ga,spin1,spin2,spin3,spin4,h1,h2,h3,h4,
     .              ccel,ccmu)
      bhel1234= ( ccel(0)*ccmu(0)-ccel(1)*ccmu(1)
     .           -ccel(2)*ccmu(2)-ccel(3)*ccmu(3) )

      call currents(gv,ga,spin1,spin4,spin3,spin2,h1,h4,h3,h2,
     .              ccel,ccmu)
      bhel1423= -1.d0 * ( ccel(0)*ccmu(0)-ccel(1)*ccmu(1)  ! MINUS SIGN FOR FS PARTICLE EXCHANGE!!!
     .                   -ccel(2)*ccmu(2)-ccel(3)*ccmu(3) )

      eikm2 = 0.d0
      do ie = 0,2**ng-1

         eikctmp = (0.d0,0.d0)
         do j = 0,2**ng-1

            pz12 = p12
            pz34 = p34
            pz14 = p14
            pz23 = p23
            collprod1234 = 1.d0
            collprod1423 = 1.d0
            do k = 1,ng
               iz = mod(j, pow2(k)) / pow2(k-1) + 1
               ik = mod(ie,pow2(k)) / pow2(k-1) + 1
               if (iz.eq.1) then
                  pz12         = pz12 + qph(k,:)
                  pz14         = pz14 + qph(k,:)
                  collprod1234 = collprod1234
     .                           *(colleps(ik,1,k)+colleps(ik,2,k))
                  collprod1423 = collprod1423
     .                           *(colleps(ik,1,k)+colleps(ik,4,k))
               else
                  pz34         = pz34 + qph(k,:)
                  pz23         = pz23 + qph(k,:)
                  collprod1234 = collprod1234
     .                           *(colleps(ik,3,k)+colleps(ik,4,k))
                  collprod1423 = collprod1423
     .                           *(colleps(ik,2,k)+colleps(ik,3,k))
               endif
            enddo
c            bw1234  = 1.d0/(dot(pz12,pz12)-zm2c)/(dot(pz34,pz34)-zm2c)
c            bw1423  = 1.d0/(dot(pz14,pz14)-zm2c)/(dot(pz23,pz23)-zm2c)
            bw1234  = (dot(pz12,pz12)-zm2c)*(dot(pz34,pz34)-zm2c)
            bw1234  = 1.d0/bw1234
            bw1423  = (dot(pz14,pz14)-zm2c)*(dot(pz23,pz23)-zm2c)
            bw1423  = 1.d0/bw1423
            eikctmp = eikctmp + collprod1234 * bw1234 * bhel1234
     .                        + collprod1423 * bw1423 * bhel1423
         enddo
c         eik = eik + eikctmp*conjg(eikctmp)
         eikm2 = eikm2 + eikctmp*conjg(eikctmp)
      enddo

      eik = eik + eikm2

c      enddo
c      enddo
c      enddo
c      enddo

#ifdef _OPENMP
c     print*,omp_get_thread_num()+1,omp_get_num_threads()
c      print*,omp_get_thread_num()+1,h1,h2,h3,h4
#endif

      enddo                     ! hh do
cc$omp end do
cc$omp end parallel
      
      ENDIF
     
      eikfact = eik * (elc2*rescaleQED)**ng /factorial(ng) * cover      
      
      return
      end
*******************************************************************


      subroutine eikonalPOLNG(ng,p1,p2,p3,p4,qph,eikfact)
      implicit double precision (a-h,m,o-z)

      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      dimension qph(ng,0:3),q(0:3)
      dimension p12(0:3),p34(0:3),pz1(0:3),pz2(0:3)
      dimension collt(4,ng,0:3),coll(4,ng)
c      dimension colleps(4,2,ng)

      dimension colleps(2,4,ng)

      dimension pt(0:3,4)
      double precision e1(0:3),e2(0:3)
c      double precision e0(0:3),e3(0:3)
c      double precision prod(0:3,ng,4**ng)
      double complex bw,eikc1,eikc2
      double complex eikc(2**ng)
      double complex eikctmp,eikctmp1,eikctmp2
      double complex den(0:3,ng)
      integer   pow4(0:ng)
      integer   pow2(0:ng)
      double complex im,zm2c

      common/identicalparticles/idpart

      common/zparam/zmass,zwidth

      common/POLNG/im,zm2c,zm2,zmw,ec2,ifirst
      data ifirst /0/

      common/alphas/alpha0,alphaGF,alpha
      parameter (pi = 3.1415926535897932384626433832795029D0)

      integer imode
      common/imode/imode

      if (ifirst.eq.0) then
         zm2  = zmass*zmass
         zmw  = zmass*zwidth
         im   = (0.d0,1.d0)
         ec2  = 4.d0*pi*alpha
         zm2c = zm2 - im*zmw
         ifirst = 1
      endif

      if (idpart.eq.1) then
         print*,'eikonalimprovedNG not ready'//
     .        'for identical particles yet. STOPPING'
         stop
      endif

c      pow4(0) = 1
      pow2(0) = 1
      do k = 1,ng
c         pow4(k)      =  pow4(k-1)*4
         pow2(k)      =  pow2(k-1)*2
         call get_eps(qph(k,:),e1,e2)
         colleps(1,1,k) = -dot(p1,e1)/dot(p1,qph(k,:))
         colleps(1,2,k) =  dot(p2,e1)/dot(p2,qph(k,:))
         colleps(1,3,k) = -dot(p3,e1)/dot(p3,qph(k,:))
         colleps(1,4,k) =  dot(p4,e1)/dot(p4,qph(k,:))
         colleps(2,1,k) = -dot(p1,e2)/dot(p1,qph(k,:))
         colleps(2,2,k) =  dot(p2,e2)/dot(p2,qph(k,:))
         colleps(2,3,k) = -dot(p3,e2)/dot(p3,qph(k,:))
         colleps(2,4,k) =  dot(p4,e2)/dot(p4,qph(k,:))
      enddo

      p12 = p1+p2
      p34 = p3+p4

*** OPTIMIZED
      eik = 0.d0
      do ie = 0,2**ng-1
         eikctmp = (0.d0,0.d0)
         do j = 0,2**ng-1 ! better than "do j = 1,4**ng"
            pz1 = p12
            pz2 = p34
            collprod = 1.d0
            do k = 1,ng
               iz = mod(j,pow2(k)) / pow2(k-1) + 1
               ik = mod(ie,pow2(k)) / pow2(k-1) + 1
               if (iz.eq.1) then
                  pz1      = pz1 + qph(k,:)
                  collprod = collprod*(colleps(ik,1,k)+colleps(ik,2,k))
               else
                  pz2      = pz2 + qph(k,:)
                  collprod = collprod*(colleps(ik,3,k)+colleps(ik,4,k))
               endif
            enddo
            bw  = 1.d0/(dot(pz1,pz1)-zm2c)/(dot(pz2,pz2)-zm2c)
            eikctmp = eikctmp + collprod*bw
         enddo
c         eik = eik + abs(eikctmp)**2
         eik = eik + eikctmp*conjg(eikctmp)
      enddo

      eikfact = eik * (ec2)**ng /factorial(ng)

      return

*** NOT OPTIMIZED

      print*,'pow4 not defined!'

      eik = 0.d0
      do ie = 1,2**ng
         eikctmp = (0.d0,0.d0)
         do j = 0,4**ng-1 ! better than "do j = 1,4**ng"
            pz1 = p12
            pz2 = p34
            collprod = 1.d0
            do k = 1,ng
               i = mod(j,pow4(k)) / pow4(k-1) + 1
               ik = mod(ie,pow2(k)) / pow2(k-1) + 1
               if (i.le.2) pz1 = pz1 + qph(k,:)
               if (i.gt.2) pz2 = pz2 + qph(k,:)
               collprod = collprod*colleps(ik,i,k)
            enddo
            bw  = 1.d0/(dot(pz1,pz1)-zm2c)/(dot(pz2,pz2)-zm2c)
            eikctmp = eikctmp + collprod*bw
         enddo
         eik = eik + abs(eikctmp)**2
      enddo

      print*,'ADD RESCALE QED! matrixelement.F line ~658'

      eikfact = eik * (ec2)**ng /factorial(ng)

      return
      end

*******************************************************
      subroutine get_eps(k,e1,e2)
      implicit double precision (a-h,o-z)
      double precision k(0:3),e1(0:3),e2(0:3),ku(0:3)
      double precision e0(0:3),e3(0:3)

      ku = k/k(0)

      e1(0) = 0.d0
      if (abs(ku(3)).gt.1d-12) then
         e1(1) = ku(1)
         e1(2) = ku(2)
         e1(3) = (-e1(1)*e1(1) - e1(2)*e1(2))/ku(3)
      elseif (abs(ku(1)).gt.1d-12) then
         e1(3) = ku(3)
         e1(2) = ku(2)
         e1(1) = (-e1(3)*e1(3) - e1(2)*e1(2))/ku(1)
      else
         e1(1) = ku(1)
         e1(3) = ku(3)
         e1(2) = (-e1(3)*e1(3) - e1(1)*e1(1))/ku(2)
      endif
      e1 = e1/(sqrt(tridot(e1,e1)))

      call vecprod(e1,ku,e2)
      e2(0) = 0.d0

      return
      end
************************************
      subroutine findclosest(ng,p1,p2,p3,p4,qph,iclose)
      implicit double precision (a-h,m,o-z)
      dimension qph(ng,0:3),q(0:3)
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      integer iclose(ng),mloc(1)
      
      double precision carray(8),carr4(4)

      parameter (nmaxph = 50)
      integer idiag(nmaxph)
      common/resonantdiagrams/idiag

      common/bwforclosest/bw12, bw34, bw14, bw23,
     .                    bw12q,bw34q,bw14q,bw23q
      data bw12,bw34,bw14,bw23,bw12q,bw34q,bw14q,bw23q/8*0.d0/

      integer radpattern(nmaxph)
      common/emissionpattern/radpattern

      common/identicalparticles/idpart

! from phase space
      common/switch24/iswitchforidpart

      IF (idpart.eq.0) THEN
      do k = 1,ng
         m12  = dot(p1+p2,p1+p2)
         m34  = dot(p3+p4,p3+p4)
         m12q = dot(p1+p2+qph(k,:),p1+p2+qph(k,:))
         m34q = dot(p3+p4+qph(k,:),p3+p4+qph(k,:))

         bw12  = 1.d0/bw(m12)
         bw12q = 1.d0/bw(m12q)
         bw34  = 1.d0/bw(m34)
         bw34q = 1.d0/bw(m34q)

         carr4(1) = dot(p1,qph(k,:)) * bw12q*bw34
         carr4(2) = dot(p2,qph(k,:)) * bw12q*bw34
         carr4(3) = dot(p3,qph(k,:)) * bw34q*bw12
         carr4(4) = dot(p4,qph(k,:)) * bw34q*bw12

         idiag(k) = 1 ! always!

         mloc = minloc(carr4)

         iclose(k) = mloc(1)

c$$$         c1 = dot(p1,qph(k,:)) * bw12q*bw34
c$$$         c2 = dot(p2,qph(k,:)) * bw12q*bw34
c$$$         c3 = dot(p3,qph(k,:)) * bw34q*bw12
c$$$         c4 = dot(p4,qph(k,:)) * bw34q*bw12
c$$$         if (c1.le.c2.and.c1.le.c3.and.c1.le.c4) then
c$$$            iclose(k) = 1
c$$$         endif
c$$$         if (c2.le.c1.and.c2.le.c3.and.c2.le.c4) then
c$$$            iclose(k) = 2
c$$$         endif
c$$$         if (c3.le.c2.and.c3.le.c1.and.c3.le.c4) then
c$$$            iclose(k) = 3
c$$$         endif
c$$$         if (c4.le.c2.and.c4.le.c1.and.c4.le.c3) then
c$$$            iclose(k) = 4
c$$$         endif

      enddo
      ELSE !! FOR IDENTICAL PARTICLES
      do k = 1,ng

         m12  = dot(p1+p2,p1+p2)
         m34  = dot(p3+p4,p3+p4)
         m12q = dot(p1+p2+qph(k,:),p1+p2+qph(k,:))
         m34q = dot(p3+p4+qph(k,:),p3+p4+qph(k,:))
         m14  = dot(p1+p4,p1+p4)
         m23  = dot(p2+p3,p2+p3)
         m14q = dot(p1+p4+qph(k,:),p1+p4+qph(k,:))
         m23q = dot(p2+p3+qph(k,:),p2+p3+qph(k,:))

         bw12  = bw(m12)
         bw12q = bw(m12q)
         bw34  = bw(m34)
         bw34q = bw(m34q)
         bw14  = bw(m14)
         bw14q = bw(m14q)
         bw23  = bw(m23)
         bw23q = bw(m23q)

c$$$         c11 = 1.d0/dot(p1,qph(k,:))*(bw12q*bw34  + bw14q*bw23 )
c$$$         c21 = 1.d0/dot(p2,qph(k,:))*(bw12q*bw34  + bw14 *bw23q)
c$$$         c31 = 1.d0/dot(p3,qph(k,:))*(bw12 *bw34q + bw14 *bw23q)
c$$$         c41 = 1.d0/dot(p4,qph(k,:))*(bw12*bw34q  + bw14q*bw23 )
c$$$         c11 = 1.d0/c11
c$$$         c21 = 1.d0/c21
c$$$         c31 = 1.d0/c31
c$$$         c41 = 1.d0/c41
c$$$         if (c11.le.c21.and.c11.le.c31.and.c11.le.c41) then
c$$$            iclose(k) = 1
c$$$         endif
c$$$         if (c21.le.c11.and.c21.le.c31.and.c21.le.c41) then
c$$$            iclose(k) = 2
c$$$         endif
c$$$         if (c31.le.c21.and.c31.le.c11.and.c31.le.c41) then
c$$$            iclose(k) = 3
c$$$         endif
c$$$         if (c41.le.c21.and.c41.le.c11.and.c41.le.c31) then
c$$$            iclose(k) = 4
c$$$         endif

         idiag(k) = 1

         carray(1) = dot(p1,qph(k,:)) * 1.d0/(bw12q * bw34 )
         carray(2) = dot(p2,qph(k,:)) * 1.d0/(bw12q * bw34 )
         carray(3) = dot(p3,qph(k,:)) * 1.d0/(bw12  * bw34q)
         carray(4) = dot(p4,qph(k,:)) * 1.d0/(bw12  * bw34q)
         carray(5) = dot(p1,qph(k,:)) * 1.d0/(bw14q * bw23 )
         carray(6) = dot(p2,qph(k,:)) * 1.d0/(bw14  * bw23q)
         carray(7) = dot(p3,qph(k,:)) * 1.d0/(bw14  * bw23q)
         carray(8) = dot(p4,qph(k,:)) * 1.d0/(bw14q * bw23 )

         mloc = minloc(carray)

! idiag is overidden in maptoone and maptozero. Anyway....
         if (mloc(1).eq.1) then
            iclose(k) = 1
            idiag(k)  = 1
         elseif (mloc(1).eq.2) then 
            iclose(k) = 2
            idiag(k)  = 1
         elseif (mloc(1).eq.3) then 
            iclose(k) = 3
            idiag(k)  = 1
         elseif (mloc(1).eq.4) then
            iclose(k) = 4
            idiag(k)  = 1
         elseif (mloc(1).eq.5) then
            iclose(k) = 1
            idiag(k)  = 2
         elseif (mloc(1).eq.6) then 
            iclose(k) = 2
            idiag(k)  = 2
         elseif (mloc(1).eq.7) then 
            iclose(k) = 3
            idiag(k)  = 2
         elseif (mloc(1).eq.8) then
            iclose(k) = 4
            idiag(k)  = 2
         endif

      enddo
      ENDIF

      return
      end

************************************************************************************
      subroutine maptozeroNG(ng,p1,p2,p3,p4,qf,p1p,p2p,p3p,p4p,
     .     p1v,p2v,p3v,p4v,iclose)
      implicit double precision (a-h,o-z)
      dimension qf(ng,0:3)
      double precision p1(0:3),p2(0:3),p3(0:3),p4(0:3)
      double precision p1p(0:3),p2p(0:3),p3p(0:3),p4p(0:3)
      double precision p1v(0:3),p2v(0:3),p3v(0:3),p4v(0:3)
      double precision q(0:3),paux(0:3),qaux(0:3),qp(0:3)
      double precision p1x(0:3),p2x(0:3)
      double precision mass(5),shat,dqmin

      parameter (nmaxph = 50)
      integer idiag(nmaxph)
      common/resonantdiagrams/idiag

      integer iclose(ng)

      common/identicalparticles/idpart

      common/amasses/mass
      integer iswitchforidpart
      common/switch24/iswitchforidpart

      double precision mz1,mz2
      integer nphleg(4)
      common/eikcheck/mz1,mz2,nphleg

      call findclosest(ng,p1,p2,p3,p4,qf,iclose)

      p1p = p1
      p2p = p2
      p3p = p3
      p4p = p4

      do k = 1,ng
         if (iclose(k).eq.1) p1p = p1p + qf(k,:)
         if (iclose(k).eq.2) p2p = p2p + qf(k,:)
         if (iclose(k).eq.3) p3p = p3p + qf(k,:)
         if (iclose(k).eq.4) p4p = p4p + qf(k,:)
      enddo

      p1v = p1p
      p2v = p2p
      p3v = p3p
      p4v = p4p

      if (idpart.eq.0) then
         
         p1x = p1p+p2p
         call new_boost(p1x,p1p,p1p,1)         
         call new_boost(p1x,p2p,p2p,1)

         en = sqrt(dot(p1p+p2p,p1p+p2p))/2.d0
         arg = max(0.d0,(1.d0-mass(1)/en)*(1.d0+mass(1)/en))
         beta = sqrt(arg)

         p2x = p1p

         p1p(0) = en
         p1p(1) = en*beta*p2x(1)/sqrt(tridot(p2x,p2x))
         p1p(2) = en*beta*p2x(2)/sqrt(tridot(p2x,p2x))
         p1p(3) = en*beta*p2x(3)/sqrt(tridot(p2x,p2x))
         
         p2p(0) =  p1p(0)
         p2p(1) = -p1p(1)
         p2p(2) = -p1p(2)
         p2p(3) = -p1p(3)
         
         call new_boost(p1x,p1p,p1p,-1)
         call new_boost(p1x,p2p,p2p,-1)
         
         p1x = p3p+p4p
         call new_boost(p1x,p3p,p3p,1)
         call new_boost(p1x,p4p,p4p,1)
         en = sqrt(dot(p3p+p4p,p3p+p4p))/2.d0
         arg = max(0.d0,(1.d0-mass(3)/en)*(1.d0+mass(3)/en))
         beta = sqrt(arg)
         
         p2x = p3p

         p3p(0) = en
         p3p(1) = en*beta*p2x(1)/sqrt(tridot(p2x,p2x))
         p3p(2) = en*beta*p2x(2)/sqrt(tridot(p2x,p2x))
         p3p(3) = en*beta*p2x(3)/sqrt(tridot(p2x,p2x))
         
         p4p(0) =  p3p(0)
         p4p(1) = -p3p(1)
         p4p(2) = -p3p(2)
         p4p(3) = -p3p(3)
         
         call new_boost(p1x,p3p,p3p,-1)
         call new_boost(p1x,p4p,p4p,-1)

      else   ! if idpart = 1

!! checking which is the most resonant configuration
         ck1 = bw(dot(p1v+p2v,p1v+p2v))*bw(dot(p3v+p4v,p3v+p4v))
         ck2 = bw(dot(p1v+p4v,p1v+p4v))*bw(dot(p2v+p3v,p2v+p3v))

         if (ck1.gt.ck2) then
            p1x = p1p+p2p
            call new_boost(p1x,p1p,p1p,1)         
            call new_boost(p1x,p2p,p2p,1)
            
            en = sqrt(dot(p1p+p2p,p1p+p2p))/2.d0
            arg = max(0.d0,(1.d0-mass(1)/en)*(1.d0+mass(1)/en))
            beta = sqrt(arg)
            
            p2x = p1p
            
            p1p(0) = en
            p1p(1) = en*beta*p2x(1)/sqrt(tridot(p2x,p2x))
            p1p(2) = en*beta*p2x(2)/sqrt(tridot(p2x,p2x))
            p1p(3) = en*beta*p2x(3)/sqrt(tridot(p2x,p2x))
            
            p2p(0) =  p1p(0)
            p2p(1) = -p1p(1)
            p2p(2) = -p1p(2)
            p2p(3) = -p1p(3)
            
            call new_boost(p1x,p1p,p1p,-1)
            call new_boost(p1x,p2p,p2p,-1)
            
            p1x = p3p+p4p
            call new_boost(p1x,p3p,p3p,1)
            call new_boost(p1x,p4p,p4p,1)
            en = sqrt(dot(p3p+p4p,p3p+p4p))/2.d0
            arg = max(0.d0,(1.d0-mass(3)/en)*(1.d0+mass(3)/en))
            beta = sqrt(arg)
            
            p2x = p3p
            
            p3p(0) = en
            p3p(1) = en*beta*p2x(1)/sqrt(tridot(p2x,p2x))
            p3p(2) = en*beta*p2x(2)/sqrt(tridot(p2x,p2x))
            p3p(3) = en*beta*p2x(3)/sqrt(tridot(p2x,p2x))
            
            p4p(0) =  p3p(0)
            p4p(1) = -p3p(1)
            p4p(2) = -p3p(2)
            p4p(3) = -p3p(3)
            
            call new_boost(p1x,p3p,p3p,-1)
            call new_boost(p1x,p4p,p4p,-1)
         else
            p1x = p1p+p4p
            call new_boost(p1x,p1p,p1p,1)
            call new_boost(p1x,p4p,p4p,1)
            en = sqrt(dot(p1p+p4p,p1p+p4p))/2.d0
            arg = max(0.d0,(1.d0-mass(1)/en)*(1.d0+mass(1)/en))
            beta = sqrt(1.d0 - mass(1)**2/en**2)
            
            call new_boost(p1x,p1,p2x,1)
            p1p(0) = en
            p1p(1) = en*beta*p2x(1)/sqrt(tridot(p2x,p2x))
            p1p(2) = en*beta*p2x(2)/sqrt(tridot(p2x,p2x))
            p1p(3) = en*beta*p2x(3)/sqrt(tridot(p2x,p2x))
            
            p4p(0) =  p1p(0)
            p4p(1) = -p1p(1)
            p4p(2) = -p1p(2)
            p4p(3) = -p1p(3)
            
            call new_boost(p1x,p1p,p1p,-1)
            call new_boost(p1x,p4p,p4p,-1)
            
            
            p1x = p3p+p2p
            call new_boost(p1x,p3p,p3p,1)
            call new_boost(p1x,p2p,p2p,1)
            en = sqrt(dot(p3p+p2p,p3p+p2p))/2.d0
            arg = max(0.d0,(1.d0-mass(3)/en)*(1.d0+mass(3)/en))
            beta = sqrt(1.d0 - mass(3)**2/en**2)
            
            call new_boost(p1x,p3,p2x,1)
            p3p(0) = en
            p3p(1) = en*beta*p2x(1)/sqrt(tridot(p2x,p2x))
            p3p(2) = en*beta*p2x(2)/sqrt(tridot(p2x,p2x))
            p3p(3) = en*beta*p2x(3)/sqrt(tridot(p2x,p2x))
            
            p2p(0) =  p3p(0)
            p2p(1) = -p3p(1)
            p2p(2) = -p3p(2)
            p2p(3) = -p3p(3)
            call new_boost(p1x,p3p,p3p,-1)
            call new_boost(p1x,p2p,p2p,-1)
         endif
      endif

      return
      end
************************************************************************************
      subroutine maptooneNG(ng,j,iclose,p1v,p2v,p3v,p4v,
     .     p1,p2,p3,p4,qf,p1b,p2b,p3b,p4b,p1t,p2t,p3t,p4t,
     .     p1p,p2p,p3p,p4p,q,iemap)
      implicit double precision (a-h,o-z)
      dimension qf(ng,0:3)
      double precision kone(0:3),kone1(0:3),kone2(0:3)
      double precision p1(0:3), p2(0:3), p3(0:3), p4(0:3)
      double precision p1v(0:3),p2v(0:3),p3v(0:3),p4v(0:3)
      double precision p1vt(0:3),p2vt(0:3),p3vt(0:3),p4vt(0:3)
      double precision p1p(0:3),p2p(0:3),p3p(0:3),p4p(0:3)
      double precision p1b(0:3),p2b(0:3),p3b(0:3),p4b(0:3)
      double precision pa(0:3),pb(0:3),pc(0:3),pd(0:3)
      double precision p1t(0:3),p2t(0:3),p3t(0:3),p4t(0:3)
      double precision q(0:3),paux(0:3),qaux(0:3),qp(0:3)
      double precision p1x(0:3),p2x(0:3),dir(0:3)
      double precision mass(5),shat,dqmin,csi(1)
      integer iclose(ng),j,iclose1(1)

      double precision mr

      integer iclosekfm1
      common/iclosekfrommp1/iclosekfm1

      common/identicalparticles/idpart

      common/amasses/mass
      integer iswitchforidpart
      common/switch24/iswitchforidpart

      double precision mz1,mz2
      integer nphleg(4)
      common/eikcheck/mz1,mz2,nphleg

      parameter (nmaxph = 50)
      integer idiag(nmaxph)
      common/resonantdiagrams/idiag

      iemap = 0

      q = qf(j,:)

*** changing (eventually) the diagram.... 
      idiag(j) = 1 ! always when idpart = 0 !!!
      if (idpart.eq.1) then ! 2nd resonant diagram only if idpart = 1
!! checking which is the most resonant configuration
         ck1 = bw(dot(p1v+p2v,p1v+p2v))*bw(dot(p3v+p4v,p3v+p4v))
         ck2 = bw(dot(p1v+p4v,p1v+p4v))*bw(dot(p2v+p3v,p2v+p3v))
         if (ck2.gt.ck1) idiag(j) = 2
      endif
****
      mr = mass(1)



      if (iclose(j).eq.1) then
         dir = p1
         if (idiag(j).eq.1) then
            pa = p1v
            pb = p2v
            p3p = p3b
            p4p = p4b
            ia = 1
         else
            pa = p1v
            pb = p4v
            p3p = p3b
            p2p = p2b
            ia = 1
         endif
      endif
      if (iclose(j).eq.2) then
         dir = p2
         if (idiag(j).eq.1) then
            pa = p1v
            pb = p2v
            p3p = p3b
            p4p = p4b
            ia = 0
         else 
            p1p = p1b
            pb = p2v
            pa = p3v
            p4p = p4b
            ia = 0
         endif
      endif
      if (iclose(j).eq.3) then
         dir = p3
         if (idiag(j).eq.1) then
            p1p = p1b
            p2p = p2b
            pa = p3v
            pb = p4v
            ia = 1
            mr = mass(3)
         else
            p1p = p1b
            p4p = p4b
            pa = p3v
            pb = p2v
            ia = 1
         endif
      endif
      if (iclose(j).eq.4) then
         dir = p4
         if (idiag(j).eq.1) then
            p1p = p1b
            p2p = p2b
            pa = p3v
            pb = p4v
            ia = 0
            mr = mass(3)
         else
            pa = p1v
            pb = p4v
            p3p = p3b
            p2p = p2b
            ia = 0
         endif
      endif
      
      p1x = pa+pb
      call new_boost(p1x,pa,pa,1)
      call new_boost(p1x,pb,pb,1)
      call new_boost(p1x,q,qp,1)
      call new_boost(p1x,dir,p2x,1)
      
      en = sqrt(dot(pa+pb,pa+pb))

c      mr = 0.1d0
c      mr = 0.00d0

      p2x = p2x / sqrt(tridot(p2x,p2x))
      
      vx = p2x(1)
      vy = p2x(2)
      vz = p2x(3)
      
      odv = vx*qp(1)+vy*qp(2)+vz*qp(3)
      
      abig =  en*en - 2.d0 * en * qp(0)
      bbig = -2.d0 * (en - qp(0))
      cbig = -2.d0 * odv
      arg = abig**2*bbig**2-mr**2*bbig**2*(bbig**2-cbig**2)

c      print*,arg
c      print*,bbig**2
c      print*,cbig**2
c      print*,bbig**2-cbig**2

      if (arg.lt.0.d0) then
         iemap = 1
         return
      endif
      
      pmod = (abig*cbig + sqrt(arg))/(bbig**2 - cbig**2)

c      print*,pmod
c      print*,'line 1193 matrixelement.F - choose the pmod above!'
c      stop
c      print*,pmod
c      stop
      
      if (ia.eq.1) then
         pa(0) = sqrt(pmod**2+mr**2)
         pa(1) = pmod*vx
         pa(2) = pmod*vy
         pa(3) = pmod*vz
         pb(0) =  en-pa(0)-qp(0)
         pb(1) = -pa(1)-qp(1)
         pb(2) = -pa(2)-qp(2)
         pb(3) = -pa(3)-qp(3)
      else
         pb(0) = sqrt(pmod**2+mr**2)
         pb(1) = pmod*vx
         pb(2) = pmod*vy
         pb(3) = pmod*vz
         pa(0) =  en-pb(0)-qp(0)
         pa(1) = -pb(1)-qp(1)
         pa(2) = -pb(2)-qp(2)
         pa(3) = -pb(3)-qp(3)
      endif

c      print*,sqrt(pmod**2+mr**2),ia
c      print*,pa
c      print*,pb
      
      call new_boost(p1x,pa,pa,-1)
      call new_boost(p1x,pb,pb,-1)

c      print*,pa
c      print*,pb
c      stop
      
      if (idiag(j).eq.1) then
         if (iclose(j).le.2) then
            p1p = pa
            p2p = pb
         else
            p3p = pa
            p4p = pb
         endif
      else
         if (iclose(j).eq.1.or.iclose(j).eq.4) then
            p1p = pa
            p4p = pb
         else
            p3p = pa
            p2p = pb
         endif
      endif
      
      call maptozeroNG(1,p1p,p2p,p3p,p4p,q,p1t,p2t,p3t,p4t,
     .     p1vt,p2vt,p3vt,p4vt,iclose1)

!!! change the photon close-position!!!!
c      print*,iclose(j)-iclose1(1)
      iclosekfm1 = iclose1(1)
c      iclose(j) = iclose1(1)
!!!
      return
      end
